import React from 'react'
import Grid from '@material-ui/core/Grid';
import Link from 'next/link';
import Image from 'next/image';
import styles from '../Component/Componentstyle/Categorycard.module.css';
const convertImage = (w, h) => `
<svg width="${w}" height="${h}" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
  <defs>
    <linearGradient id="g">
      <stop stop-color="#eae9e9" offset="20%" />
      <stop stop-color="#bbb" offset="50%" />
      <stop stop-color="#eae9e9" offset="70%" />
    </linearGradient>
  </defs>
  <rect width="${w}" height="${h}" fill="#eae9e9" />
  <rect id="r" width="${w}" height="${h}" fill="url(#g)" />
  <animate xlink:href="#r" attributeName="x" from="-${w}" to="${w}" dur="1s" repeatCount="indefinite"  />
</svg>`;

const toBase64 = (str) =>
  typeof window === 'undefined'
    ? Buffer.from(str).toString('base64')
    : window.btoa(str);

export default function Categorycard(props) {
  return ( 
   <>
		
          <Grid item md={3} sm={6} xs={6} className={styles.catpad}>
            <Link href={props.categoryLink}><a>
              <div className={`${styles.cat_card} cat-card`} data-test = {props.section3Incrementor} >
                <div className={styles.cat_card_inner}> 
					<Image  src={props.CatImage} alt={props.ImgAlt}  width="344" height="401"   layout='responsive' objectFit='fit'	placeholder="blur" blurDataURL={`data:image/svg+xml;base64,${toBase64(convertImage(344, 401))}`}/>
				</div>
				 <span className='cat-text'>{props.CatName}</span> 
                </div>
			       </a></Link> 

          </Grid>



   </>
  )
}
