import React from 'react';
import Grid from '@material-ui/core/Grid';
import Link from 'next/link';
import Image from 'next/image';
    const convertImage = (w, h) => `
  <svg width="${w}" height="${h}" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
    <defs>
      <linearGradient id="g">
        <stop stop-color="#eae9e9" offset="20%" />
        <stop stop-color="#222" offset="50%" />
        <stop stop-color="#eae9e9" offset="70%" />
      </linearGradient>
    </defs>
    <rect width="${w}" height="${h}" fill="#eae9e9" />
    <rect id="r" width="${w}" height="${h}" fill="url(#g)" />
    <animate xlink:href="#r" attributeName="x" from="-${w}" to="${w}" dur="1s" repeatCount="indefinite"  />
  </svg>`;
  
 const toBase64 = (str) =>
    typeof window === 'undefined'
      ? Buffer.from(str).toString('base64')
      : window.btoa(str);
export default function Doodle(props) {
  return (
    <>

          <Grid>
              <div className={props.mainClass} >
              <Link  href={props.categoryLink} >
			    <a>
			      <Image src={props.categoryImage}  alt={props.ImgAlt} blurDataURL={`data:image/svg+xml;base64,${toBase64(convertImage(100, 100))}`}  width="100%" height="100%" 	 title={props.title} />
			    </a>
			  </Link >  
			  
              <Link href={props.categoryLink}><a>{props.categoryName}</a></Link >   

              <span className='redbox'>
                    {(props.New) ?
                    <p>{props.New}</p>
                    :
                    ''
                    }
                  </span>
              </div>
          </Grid>
        
    </>
  )
}

