import React from 'react'
import Grid from '@material-ui/core/Grid';
import Box from '@mui/material/Box';
import Modal from '@mui/material/Modal';
import PinDropIcon from '@material-ui/icons/PinDrop';
import ArrowForwardIosIcon from '@material-ui/icons/ArrowForwardIos';
import SearchIcon from '@material-ui/icons/Search';
import Image from 'next/image';
import { useRouter } from "next/router";
import styles from '../Component/Componentstyle/Midbannersearch.module.css'

const style = {
    position: 'absolute',
    top: '50%',
    left: '50%',
    transform: 'translate(-50%, -50%)',
    width: 400,
    bgcolor: 'background.paper',
    border: '2px solid #000',
    boxShadow: 24,
    p: 4,
};

const convertImage = (w, h) => `
<svg width="${w}" height="${h}" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
  <defs>
    <linearGradient id="g">
      <stop stop-color="#eae9e9" offset="20%" />
      <stop stop-color="#bbb" offset="50%" />
      <stop stop-color="#eae9e9" offset="70%" />
    </linearGradient>
  </defs>
  <rect width="${w}" height="${h}" fill="#eae9e9" />
  <rect id="r" width="${w}" height="${h}" fill="url(#g)" />
  <animate xlink:href="#r" attributeName="x" from="-${w}" to="${w}" dur="1s" repeatCount="indefinite"  />
</svg>`;

const toBase64 = (str) =>
  typeof window === 'undefined'
    ? Buffer.from(str).toString('base64')
    : window.btoa(str);


export default function Midbannersearch(props) {

    const [open, setOpen] = React.useState(false);
    const handleOpen = () => setOpen(true);
    const handleClose = () => setOpen(false);

    const [open1, setOpen1] = React.useState(false);
	
    const [occasionCatIDseletced, setoccasionCatIDseletced] = React.useState('');
    const [giftTypeCatIDseletced, setgiftTypeCatIDseletced] = React.useState('');
    const [pincodeslected, setpincodeslected] = React.useState('');
	const [OccasionCatname, setOccasionCatname] = React.useState('')
    const [GiftTypeCatname, setGiftTypeCatname] = React.useState('')
	
	const router = useRouter()
	const [erroccasionCatIDseletced, seterroccasionCatIDseletced] = React.useState(false);
    const [errgiftTypeCatIDseletced, seterrgiftTypeCatIDseletced] = React.useState(false);
    const [errpincodeseletced, seterrpincodeseletced] = React.useState(false);
	
    const handleOpen1 = () => setOpen1(true);
    const handleClose1 = () => setOpen1(false);
	
	function getOccassionCatId(id,name){
		setoccasionCatIDseletced(id)
		setOccasionCatname(name)
		setOpen(false)
		seterroccasionCatIDseletced(false)
	}
	
	function getGiftTypeCatId(id,name){
		setgiftTypeCatIDseletced(id)
		setGiftTypeCatname(name)
		setOpen1(false)
		seterrgiftTypeCatIDseletced(false)
	}
	
	function getpincodeslected(e){
		setpincodeslected(e.target.value)
		setOpen1(false)
		seterrpincodeseletced(false)
	}
	
	
	function handleClick(e){
		e.preventDefault();
		if(!occasionCatIDseletced){
			seterroccasionCatIDseletced(true)
		}
		else if(!giftTypeCatIDseletced){
			seterrgiftTypeCatIDseletced(true)
		}else{
			router.push(`/search/giftfinder/?pincode=${pincodeslected}&gid=${giftTypeCatIDseletced}&oid=${occasionCatIDseletced}`, null, { shallow: true });
		}
	};
	
  
    return (
        <>

            <Grid container className={styles.banner_inner_img} >
                
                <div className={styles.top_mid_banner_inner}>
				    <h2 className={styles.find_gifts}>Find Gifts</h2>
				    
                    <div className={styles.pincode_sec}>
						
                        <PinDropIcon className={styles.search_loaction} />
                        <input type="text" className={styles.QuickSeacrchpincode} placeholder="Enter Pincode" onChange={(e) => getpincodeslected(e)} value = {pincodeslected} />
						
						{(errpincodeseletced) ?
							<p className={styles.pincode_error_msg}>Please Select Pincode </p>
							:
							<></>
						}

                    </div>


                    <div className={styles.search_occasion}>


                        
						<div className='' onClick={handleOpen}>
                            <input type="text" className={styles.QuickSeacrchoccasion}  />
							
							 
							   {(erroccasionCatIDseletced) ?
									<p className={styles.pincode_error_msg}>Please Select Occasion</p>
									:
									<></>
								}
							<span className={styles.inputs_sec} id="occassions">Occasion
								{(OccasionCatname) ? 
									 <span className={styles.afterselect_placeholders}>{OccasionCatname}</span>
									:
									 <span className={styles.placeholders}>{'Birthday, Anniversary etc.'}</span>
								}
                               
						     </span>

                            <ArrowForwardIosIcon width='12'  className={styles.search_arrow} />
                        </div>
                        <Modal
                            open={open}
                            onClose={handleClose}
                            aria-labelledby="modal-modal-title"
                            aria-describedby="modal-modal-description"
                        >
                            <Box sx={style} className={styles.occasion_box}>

                                <div className={styles.occasion_text} id="modal-modal-title" variant="h6" component="h2">
                                    <div className={`${styles.listPopup} ${styles.occassionsDiv}`}>
                                        <div className={styles.occ_popup_header}>
                                           
                                            <div className={styles.closed}>
                                            <Image width="20" height="20" src='/cross.png' onClick={()=> setOpen(false)} alt="" />
                                            </div> 
                                        </div>
                                        <ul>
											{ props.apiData.length > 0 ?
												<>
												{props.apiData.map((item,itemond) => {
													return(
														(item.isheading) ?
															<li key={`i_${itemond}`} className = {styles.occ_heading}>{item.HomePageOccassionCatName}</li>
														 :
															<li key={`k_${itemond}`} onClick={(e) => getOccassionCatId(item.HomePageOccassionCatiID,item.HomePageOccassionCatName)} >{item.HomePageOccassionCatName}</li>
														
													)
												})}
												</>
												:
												<>
												</>

											}
                                        </ul>
                                    </div>
                                </div>



                            </Box>
                        </Modal>
                    </div>

                    <div className={styles.search_bytype}>
                        <div className='' onClick={handleOpen1}>
                            <input type="text" className={styles.QuickSeacrchgift}   />
							{(errgiftTypeCatIDseletced) ?
									<p className={styles.pincode_error_msg}>Please Select Gift Type</p>
									:
									<></>
								}
                            <span className={styles.inputs_sec} id="Gifts">Gifts Types
							
							 {(GiftTypeCatname) ? 
									 <span className={styles.afterselect_placeholders}>{GiftTypeCatname}</span>
									:
									 <span className={styles.placeholders}>{'Cakes, Flowers, Rakhi.'}</span>
								}
							
                                
							</span>
                            <ArrowForwardIosIcon width='12' className={styles.search_arrow} />
                        </div>

                        <Modal
                            open={open1}
                            onClose={handleClose1}
                            aria-labelledby="modal-modal-title"
                            aria-describedby="modal-modal-description"
                        >
                            <Box sx={style} className={styles.gift_box}>
                                <div className={styles.gifts_text} id="modal-modal-title" variant="h6" component="h2">
                                    <div className={`${styles.listPopup} ${styles.gifttupeDiv}`}>
                                        <div className={styles.gift_popup_header}>
                                           
                                            <div className={styles.closed}>
                                            <Image width="20" height="20" src='/cross.png' onClick={()=> setOpen1(false)} alt=""/>
                                            </div> 
                                        </div>
                                        <ul>
                                        {props.apiData.map((item,itemondn) => {
											return(
												(item.HomePageGiftTypeCatName) ?
													<li key={`h_${itemondn}`} onClick={(e) => getGiftTypeCatId(item.HomePageGiftTypeCatiID,item.HomePageGiftTypeCatName)}>{item.HomePageGiftTypeCatName}</li>
													:
													''
												)
											})
										}
                                        </ul>
                                    </div>
                                </div>
                               
                            </Box>
                        </Modal>
                    </div>

                    <div className={styles.Midbanner_btn}>
						<p className={styles.quick_search_btn} onClick={(e) => handleClick(e)}  ><SearchIcon/></p>
					</div>

                </div>



            </Grid>


        </>
    )
}
