import config from "../../config/config"
import "react-multi-carousel/lib/styles.css";
import Link from 'next/link';
import Image from 'next/image';
const responsive = {
  superLargeDesktop: {
    // the naming can be any, depends on you.
    breakpoint: { max: 4000, min: 3000 },
    items: 5
  },
  desktop: {
    breakpoint: { max: 3000, min: 1024 },
    items: 3
  },
  tablet: {
    breakpoint: { max: 1024, min: 464 },
    items: 2
  },
  mobile: {
    breakpoint: { max: 464, min: 0 },
    items: 1
  }
};

    const convertImage = (w, h) => `
  <svg width="${w}" height="${h}" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
    <defs>
      <linearGradient id="g">
        <stop stop-color="#eae9e9" offset="20%" />
        <stop stop-color="#bbb" offset="50%" />
        <stop stop-color="#eae9e9" offset="70%" />
      </linearGradient>
    </defs>
    <rect width="${w}" height="${h}" fill="#eae9e9" />
    <rect id="r" width="${w}" height="${h}" fill="url(#g)" />
    <animate xlink:href="#r" attributeName="x" from="-${w}" to="${w}" dur="1s" repeatCount="indefinite"  />
  </svg>`;
  
 const toBase64 = (str) =>
    typeof window === 'undefined'
      ? Buffer.from(str).toString('base64')
      : window.btoa(str);
	  
export default function Slider(props) {
  return (
  <>
<picture>
  <source className="imgbanner" srcSet= {config.homepageSliderurl +props.imageName} type="image/webp" />
  {props.slideUrl ?
  <Link href={props.slideUrl}><a>
  <Image priority = {true} className="imgbanner top_bnnerslide" fetchpriority="high" width="1920" height="530" layout='responsive' alt="" title="" src= {config.homepageSliderurl +props.imageName} type="image/jpeg" placeholder="blur" blurDataURL={`data:image/svg+xml;base64,${toBase64(convertImage(1920, 530))}`} />
  </a></Link>
  :
  <Image priority = {true} className="imgbanner top_bnnerslide" fetchpriority="high" width="1920" height="530" layout='responsive' alt="" title="" src= {config.homepageSliderurl +props.imageName} type="image/jpeg" placeholder="blur" blurDataURL={`data:image/svg+xml;base64,${toBase64(convertImage(1920, 530))}`} />
}
</picture>
</>
  )
}
