import React,{ useState, useEffect } from 'react'
import { Grid } from '@material-ui/core';
import Link from "next/link";
import { FaFacebookSquare, FaTwitterSquare, FaPinterestSquare, FaInstagramSquare } from "react-icons/fa";
import Image from 'next/image';
import styles from './Footer.module.css'
import dynamic from "next/dynamic";
import config from '../../config/config';

export default function Footer(props) {
    const WhatsAppWidget = dynamic(() => import("../Whatsapp/WhatsApp"), { ssr: false });
    const [isActive, setIsActive] = useState(false);
    return (
        <>

            <div className='MainFooters'>

                {(props.footerdata) ?
                    <>
                        <div className="footer-container">

                            <div className="footer-section">

                                <section className={styles.footer_main_size}>
                                    <div className={`${styles.footer_all_content} footer_all_content`}>
                                        <div className="accordion-toggle" onClick={() => setIsActive(!isActive)}>
                                            <div className={styles.footerender}><h3>Why us</h3><span className={styles.footerhide}>{isActive ? "-" : "+"}</span></div>
                                        </div>
                                       <div className = { 
                                            isActive ? styles.footerDisplay : styles.desktopVisible + ' ' + styles.mobileHidden } >
                                            <div dangerouslySetInnerHTML={{ __html: props.footerdata }} />
                                        </div>
                                    </div>
                                </section>
                            </div>

                        </div>
                    </>
                    :
                    ''
                }

                <Grid container item md={12} className={styles.footer_inner}>

                    <Grid item md={4} xs={12} sm={4} className={styles.footer_item}>

                        <div className={styles.footer_text}>
                            <div className={styles.se_pay}>
                                <Image width="30" height="30" src="/Egift/se_pay.webp" alt="" />
                                <p>100% safe &amp; secure payments</p>
                            </div>
                            <div className={styles.satisfied_customer}>
                                <Image width="30" height="30" src="/Egift/happy_customers.webp" alt="" />
                                <p>100000 Satisfied Customers</p>
                            </div>
                        </div>
                    </Grid>
                    <Grid item md={4} xs={12} sm={4} className={styles.footer_item}>
                        <div className={styles.social_icon}>

                            <h5>Connect With Us</h5>
                            <Link href='https://www.facebook.com/giftseportal'><a> <FaFacebookSquare width="20" className={styles.socialicofb} alt="" /></a></Link>
                            <Link href='https://twitter.com/1800rakhis1'><a><FaTwitterSquare width="20" className={styles.socialicotweet} alt="" /></a></Link>
                            <FaPinterestSquare width="20" className={styles.socialicopin} alt="" />
                            <FaInstagramSquare width="20" className={styles.socialicoinsta} alt="" />

                        </div>

                    </Grid>
                    <Grid item md={4} xs={12} sm={4} className={styles.footer_item}>
                        <div className={styles.payment_method}>
                            <h5>Secure Ordering &amp; Transactions</h5>
                            <div className="">

                                <Image width="315" height="110" src="/Egift/payment/cards.webp" alt="" />


                            </div>

                        </div>

                    </Grid>
                </Grid>

            </div>
            <div className={styles.footer_menu}>
                <div className={styles.container_fluid_footer}>

                    <ul>
                        <li><Link prefetch={false} href={`${config.callBackUrl}about`}><a>About Us</a></Link></li>
                        <li><Link prefetch={false} href={`${config.callBackUrl}privacy`}><a>Privacy Policy</a></Link></li>
                        <li><Link prefetch={false} href={`${config.callBackUrl}disclaimer`}><a>Disclaimer</a></Link></li>
                        <li><Link prefetch={false} href={`${config.callBackUrl}careers`}><a>Careers</a></Link></li>
                        <li><Link prefetch={false} href={`${config.callBackUrl}contact`}><a>Contact</a></Link></li>
						<li><Link prefetch={false} href={`${config.callBackUrl}cancellation-refund-policy`}><a>Cancellation & Refund Policy</a></Link></li>
                        <li><Link prefetch={false} href={`${config.callBackUrl}shippingpolicy`}><a>Shipping Policy</a></Link></li>
                        <li><a href={`${config.callBackUrl}sitemap`}>Sitemap</a></li>
                    </ul>
                </div>

            </div>

            <div className={`${styles.footer1_copyright} footer1-copyright`}>
                <div className={`${styles.footer1_logo} col text-center`}>
                    <Image width="45" height="45" src='/e-footer.png' alt="" />
                </div>
                <div className={`${styles.backgroundcopy} backgroundcopy`}>
                    <p className="copyright"> Copyright © 1800rakhis</p>
                </div>
            </div>
            <WhatsAppWidget />


        </>
    )
}
