import Link from "next/link";
import "react-multi-carousel/lib/styles.css";
import Grid from '@material-ui/core/Grid';
import Productcard from "../components/Component/Productcard";
import config from "../config/config";
import { useState, useEffect } from 'react'
import InfiniteScroll from "react-infinite-scroll-component";
import { useSelector, useDispatch } from 'react-redux';
import dynamic from 'next/dynamic'
import {setFirstTimeData } from '../redux/actions/cart';
const Egiftloader = dynamic(() => import('../components/Egiftloader/EgiftLoadermd'), {
  loading: () => <header />,
})

import { makeStyles } from "@material-ui/core/styles";
import { useRouter } from "next/router";
import SendAbroad from '../components/Component/SendAbroad'
import styles from './Layoutstyles/Giftfinder.module.css';

const useStyles = makeStyles((theme) => ({
	root: {
		'& > * + *': {
			marginTop: theme.spacing(2),
		},
	},
}));



export default function searchlayout(props) {
	const SelectedCurr = useSelector(state => state.cartReducer.CurrencyData);

	const [categoryId, setcategoryId] = useState(props.apiData.CatId)
	const [Products, setProducts] = useState([])
	const [hasMoreProducts, sethasMoreProducts] = useState(true);
	const [noProducts, setnoProducts] = useState(false);
	const [pageNo, setpageNo] = useState(1);
	const [qParam, setqParam] = useState('?popularity=1');
	const router = useRouter()
	const [categoryLoader, setcategoryLoader] = useState(true);
	const [currencySymbolP, setcurrencySymbolP] = useState(props.currentCurrency.CurrencySymbol);
	const [currencyRateP, setcurrencyRateP] = useState(props.currentCurrency.CurrencyRate);
	const dispatch = useDispatch();
	useEffect(() => {
		if(props.apiData.CatId){
			if(!SelectedCurr){
			var AllCountryData = props.AllCurrencyData
			setcurrencydadtanew()
			async function setcurrencydadtanew(){
				await dispatch(setFirstTimeData(props.currentCurrency, AllCountryData, props.GeoData))
			}
			setSelectedCurrencydata(props.currentCurrency)
			setcurrencySymbolP(props.currentCurrency.CurrencySymbol)
			setcurrencyRateP(props.currentCurrency.CurrencyRate)
				
			}else{
				setSelectedCurrencydata(SelectedCurr)
				setcurrencySymbolP(SelectedCurr.CurrencySymbol)
				setcurrencyRateP(SelectedCurr.CurrencyRate)
			}
		}
		getCategoryProducts()
		setSearchStates()
	},[router.query.stext,SelectedCurr])
	
	async function setSearchStates(){
		setcategoryLoader(true)
		setProducts([])
		setpageNo(1)
		sethasMoreProducts(true)
		setnoProducts(false)
		setqParam('?popularity=1')
		setcurrencySymbolP(props.currentCurrency.CurrencySymbol)
		
	}
	
	async function getCategoryProducts() {
		if(SelectedCurr){
			setProducts([]);
			sethasMoreProducts(true);
			setpageNo(1)
			var url = `${config.apiUrl}search/giftfinder/${qParam}&pageno=1&currencyRate=${currencyRateP}&pincode=${router.query.pincode}&gid=${router.query.gid}&oid=${router.query.oid}`
			const res = await fetch(url)
			const data = await res.json()
			setcategoryLoader(false)
			if(data[0] == 'no data found' ){
				sethasMoreProducts(false)
				setnoProducts(true)
			}
			else if(data.length <  (config.perPage - 1)){
				sethasMoreProducts(false)
				setProducts(data)
			}else{
				setProducts(data)
			}
		}
		
	}


	async function filterProducts(e) {
	
		var value = e.target.value
		setqParam(value)
		var p = 1
		var url = `${config.apiUrl}search/giftfinder/${e.target.value}&pageno=1&currencyRate=${currencyRateP}&pincode=${router.query.pincode}&gid=${router.query.gid}&oid=${router.query.oid}`
		const res = await fetch(url)
		const data = await res.json()
		
		
		if(data[0] == 'no data found' ){
			sethasMoreProducts(false)
			setnoProducts(true)
		}
		else if(data.length <  (config.perPage - 1)){
			sethasMoreProducts(false)
			setProducts(data)
		}else{
			setProducts(data)
			sethasMoreProducts(true)
		}
		setpageNo(1)
	}


	const getMoreProducts = async () => {
		
		var p = pageNo
		var newp = pageNo + 1
		var InfiniteScrollUrl = `${config.apiUrl}search/giftfinder/${qParam}&pageno=${newp}&currencyRate=${currencyRateP}&pincode=${router.query.pincode}&gid=${router.query.gid}&oid=${router.query.oid}`
		const InfiniteScrollRes = await fetch(InfiniteScrollUrl)
		const newData = await InfiniteScrollRes.json()
		if(newData[0] == 'no data found' ){
			sethasMoreProducts(false)
		}
		else if(newData.length <  (config.perPage - 1)){
			sethasMoreProducts(false)
			setProducts((Products) => [...Products, ...newData]);
		}else{
			setProducts((Products) => [...Products, ...newData]);
		}
		
		setpageNo(newp)
		
		
	};


	const classes = useStyles();
	return (
		<>
			
		
		

			
			{(categoryLoader) ? 
			
				<>
					<Egiftloader/>
				</>
				:
				<>
					{(noProducts) ? 
						<>
							<div className='no_pro_found'>
						<h4>{'Sorry, no results found.'}</h4>
						<p>{'Please try searching for something else.'}</p>
							<div className={styles.search_instead_search_options}>
								<span>Search Instead:</span>
								<ul className={styles.search_instead_si_list}>
								<li><label><Link href='/rakhi'><a>Rakhi</a></Link></label></li>
								<li><label><Link href='/birthday-gifts'><a>Birthday</a></Link></label></li>
								<li><label><Link href='/anniversary-gifts'><a>Anniversary</a></Link></label></li>
								<li><label><Link href='/cakes'><a>Cakes</a></Link></label></li>
								<li><label><Link href='/flowers'><a>Flowers</a></Link></label></li>
								<li><label><Link href='/chocolates'><a>Chocolates</a></Link></label></li>
								<li><label><Link href='/gifts-baskets'><a>Gift Baskets</a></Link></label></li>
								<li><label><Link href='/'><a>All Gifts</a></Link></label></li>
								</ul>
					        </div>
							</div>
			        <div className={styles.pagenotfound_worldwide}>
						<div className={`${styles.cat_heading} cat-heading`}>
							<div className={styles.catchoiceheading}>
							<h2>Send Gifts<span> Worldwide</span></h2>
							</div>
						</div>
						<SendAbroad/>
					</div>
							
						</>
						:
						<>
							<InfiniteScroll
								dataLength={Products.length}
								next={getMoreProducts}
								hasMore={hasMoreProducts}
								loader={<h3 className="loadcatgry"><Egiftloader className="load" alt="loader" /></h3>}
								endMessage={<h4><img src="/catend.png" className="catend" /></h4>}>
								{(Products.length > 0) ?
									<>

										<Grid container className='categorylayoutcard2  categorypage-product-card'>
											{Products.map((doodle, ind) => {
												var symbolPrice = doodle.displayProductPrice;
												var symbolDisPrice = doodle.displaySalePrice;
												return (
													<Productcard
														productImage={`${config.categoryPageproductImageurl + doodle.ProductSmallImage}`} productName={doodle.ProductName} key={ind} productLink={doodle.imageurl}
														productPrice={symbolPrice}
														ProductOnSale={doodle.ProductSale}
														productSaleprice={symbolDisPrice}
														productSlug={doodle.ProductSlug}
														ProductBestSeller={doodle.ProductBestSeller}
														ProductNewArrival={doodle.ProductNewArrival}
														TwoDayDelivery={doodle.TwoDayDelivery}
														NextDayDelivery={doodle.NextDayDelivery}
														ThreeHourDelivery={doodle.ThreeHourDelivery}
														PremiumDelivery={doodle.PremiumDelivery}
														ProductPersonalised={doodle.ProductPersonalised}
														ProductSameDayDel={doodle.ProductSameDayDel}
														CurrencySymbol={currencySymbolP}
														ImgAlt={doodle.ImageAltTag}

													/>
												)
											})
											}


										</Grid>
									</>
									:
									<>
									</>
								}
							</InfiniteScroll>
						</>
					}
				</>
			}
		</>
	)

}