import "react-multi-carousel/lib/styles.css";
import Grid from '@material-ui/core/Grid';
import Button from '@mui/material/Button'
import { useSelector, useDispatch } from 'react-redux';
import { updateAllItems, removeItem, emptyCart } from '../redux/actions/cart';
import "react-multi-carousel/lib/styles.css";
import { Lock, CallOutlined, EmailOutlined, Info, CloseOutlined, HomeOutlined, ErrorOutline } from '@material-ui/icons';
import React, { useState, useEffect } from 'react'
import { useSession, getSession, signIn, signOut } from "next-auth/react";
import config from '../config/config';
import Popup from 'reactjs-popup';
import 'reactjs-popup/dist/index.css';
import { useRouter } from 'next/router'
import styles from './Layoutstyles/Checkout.module.css'
import DeleteIcon from '@material-ui/icons/Delete';
import EditIcon from '@material-ui/icons/Edit';
import {AustraliaStates} from '../components/CommonFunctions/Adress/AustraliaStates';
import {IndiaStates} from '../components/CommonFunctions/Adress/IndiaStates';
import {UsaStates} from '../components/CommonFunctions/Adress/UsaStates';
import {GermanyStates} from '../components/CommonFunctions/Adress/GermanyStates';
import {UkStates} from '../components/CommonFunctions/Adress/UkStates';
import {CanadaStates} from '../components/CommonFunctions/Adress/CanadaStates';
import {UaeStates} from '../components/CommonFunctions/Adress/UaeStates';

import { PayPalButton } from "react-paypal-button-v2";
import { GetStorage } from "../redux/lib/localstorage";
//import {sha512} from 'crypto-hash';
//import {sha512} from 'js-sha512';

function handleClick(event) {
    event.preventDefault();
}

export default function Checkout(props) {
    const dispatch = useDispatch();
    //const updateItemsInCart = (Itemdata) => dispatch(updateAllItems(Itemdata))
    //const deleteItemFromCart = (item) => dispatch(removeItem(item))
    const SelectedCurrencydata = useSelector(state => state.cartReducer.CurrencyData);
    const [isLoading, setisLoading] = useState(false);
        
    const CartItemsList = useSelector(state => state.cartReducer.CartItemsList);    

    const CartSubTotal = useSelector(state => state.cartReducer.SubTotal);
    const CartGrandTotal = useSelector(state => state.cartReducer.GrandTotal);
    const CartDiscountsData = useSelector(state => state.cartReducer.DiscountsData);
   // const CurrencyData = useSelector(state => state.cartReducer.CurrencyData);
    const GeoData = useSelector(state => state.cartReducer.GeoData);
    const PincodeData = useSelector(state => state.cartReducer.PincodeData);

    const CouponDiscount = useSelector(state => state.cartReducer.CouponDiscounts);
    const GiftWrapperChargesTotal = useSelector(state => state.cartReducer.GiftWrapperChargesTotal);
    const OrderDeliveryCharges = useSelector(state => state.cartReducer.DeliveryChargesTotal);
    const OrderDeliveryChargesINR = useSelector(state => state.cartReducer.DeliveryChargesTotalINR);

    const [isLoader, setisLoader] = useState(false);
    const [additionalclass, setadditionalclass] = useState('');

    const CartExtraDetail = useSelector(state => state.cartReducer.CartExtraDetail);
    var selectedPincode = ''
    var selectedDeldate = ''
    var selectedMessage = ''
    var selectedpersonalImg = ''
    var selectedcountry = '2'
    var delCountry = '2'

    if (CartExtraDetail.length > 0) {
        delCountry = CartExtraDetail[0].country_id;
        selectedPincode = CartExtraDetail[0].pincode;
        selectedDeldate = CartExtraDetail[0].delivery_date;
        selectedMessage = CartExtraDetail[0].cake_message;
        selectedpersonalImg = CartExtraDetail[0].pesonalize_image;
        selectedcountry = CartExtraDetail[0].country_id;
    }

    const MainPincode = selectedPincode
    const MainDeldate = selectedDeldate
  // const [MainPincode, setMainPincode] = useState(selectedPincode);
    //const [MainDeldate, setMainDeldate] = useState(selectedDeldate);
    // const [MainCakeMessage, setMainCakeMessage] = useState(selectedMessage);
    // const [MainPersonailzeImg, setMainPersonailzeImg] = useState(selectedpersonalImg);

    const [CustomerBillingName, setCustomerBillingName] = useState('')

    //const [CartItems, setCartItems] = useState(CartItemsList);

    // const [status, setStatus] = React.useState(1)

    // const radioHandler = (status) => {
    //     setStatus(status);
    // };

    const [BillingAddressCheck, setBillingAddressCheck] = useState(false);
    const [BillingAddressData, setBillingAddressData] = useState(false);
    const [Email, setEmail] = useState("");
    const [FName, setFName] = useState("");
    const [LName, setLName] = useState("");
    const [Telephone, setTelephone] = useState("");
    const [CustomerNo, setCustomerNo] = useState("");

    // popup billing info
    const [PopupEmail, setPopupEmail] = useState("");
    const [PopupFName, setPopupFName] = useState("");
    const [PopupLName, setPopupLName] = useState("");
    const [PopupTelephone, setPopupTelephone] = useState("");
	const [ShowState, setShowState] = useState(true);
	const [ShowStateNew, setShowStateNew] = useState(true);

    const [PopupFNameErr, setPopupFNameErr] = useState(false);
    const [PopupLNameErr, setPopupLNameErr] = useState(false);
    const [PopupTelephoneErr, setPopupTelephoneErr] = useState(false);
    const [PopupEmailErr, setPopupEmailErr] = useState(false);

    //popup shiiping info
    const [ShippingAddressCheck, setShippingAddressCheck] = useState(false);
    const [PopupshiipingFName, setPopupshiipingFName] = useState("");
    const [PopupshiipingLName, setPopupshiipingLName] = useState("");
    const [PopupshiipingCountry, setPopupshiipingCountry] = useState(2);
    const [PopupshiipingState, setPopupshiipingState] = useState(PincodeData.PincodeState);
    const [CustomPopupshiipingState, setCustomPopupshiipingState] = useState('');
    const [CustomPopupshiipingCity, setCustomPopupshiipingCity] = useState('');
    const [CustomPopupshiipingPincode, setCustomPopupshiipingPincode] = useState('');

    // edit popup    
    const [EditPopupshiipingFName, setEditPopupshiipingFName] = useState("");
    const [EditPopupshiipingLName, setEditPopupshiipingLName] = useState("");
    const [EditPopupshiipingAddress, setEditPopupshiipingAddress] = useState("");
    const [EditPopupshiipingTelephone, setEditPopupshiipingTelephone] = useState("");
    const [EditPopupshiipingCountry, Edit] = useState(delCountry);
    const [EditPopupshiipingState, setEditPopupshiipingState] = useState('');
    const [EditCustomPopupshiipingState, setEditCustomPopupshiipingState] = useState('');
    const [EditCustomPopupshiipingCity, setEditCustomPopupshiipingCity] = useState('');
    const [EditCustomPopupshiipingPincode, setEditCustomPopupshiipingPincode] = useState('');
    const [EditPopupshiipingAddID, setEditPopupshiipingAddID] = useState('');

    const [PopupshiipingAddress, setPopupshiipingAddress] = useState("");
    const [PopupshiipingCity, setPopupshiipingCity] = useState(PincodeData.PinCodeCity);
    const [PopupshiipingPincode, setPopupshiipingPincode] = useState(PincodeData.PinCode);
    const [PopupshiipingTelephone, setPopupshiipingTelephone] = useState("");

    const [PopupshiipingFNameErr, setPopupshiipingFNameErr] = useState("");
    const [PopupshiipingLNameErr, setPopupshiipingLNameErr] = useState("");
    const [PopupshiipingTelephoneErr, setPopupshiipingTelephoneErr] = useState("");
    const [PopupshiipingAddressErr, setPopupshiipingAddressErr] = useState("");
    const [CustomPopupshiipingCityErr, setCustomPopupshiipingCityErr] = useState(false);
    const [CustomPopupshiipingStateErr, setCustomPopupshiipingStateErr] = useState(false);
    const [CustomPopupshiipingPincodeErr, setCustomPopupshiipingPincodeErr] = useState(false);
    
    // const [PopupshiipingFNameError, setPopupshiipingFNameError] = useState("");
    // const [PopupshiipingLNameError, setPopupshiipingLNameError] = useState("");
    // const [PopupshiipingTelephoneError, setPopupshiipingTelephoneError] = useState("");
    // const [PopupshiipingAddressError, setPopupshiipingAddressError] = useState("");
    // const [CustomPopupshiipingCityError, setCustomPopupshiipingCityError] = useState(false);
    // const [CustomPopupshiipingStateError, setCustomPopupshiipingStateError] = useState(false);
    // const [CustomPopupshiipingPincodeError, setCustomPopupshiipingPincodeError] = useState(false);

    const [ShippingAddressData, setShippingAddressData] = useState([]);

    const [RFName, setRFName] = useState("");
    const [RLName, setRLName] = useState("");
    const [ComName, setComName] = useState("");
    const [Country, setCountry] = useState("");
    const [StreetAdd, setStreetAdd] = useState("");
    const [City, setCity] = useState("");
    const [State, setState] = useState("");
    const [RPincode, setRPincode] = useState("");
    const [RTelephone, setRTelephone] = useState("");
    const [GiftMessage, setGiftMessage] = useState("");
    const [SpInstruction, setSpInstruction] = useState("");
    const [CartCountry, setCartCountry] = useState(2);

    const OrderSubtotalINR = useSelector(state => state.cartReducer.SubTotalINR);
    const OrderGrandTotalINR = useSelector(state => state.cartReducer.GrandTotalINR);
    //const OrderDiscounts = useSelector(state => state.cartReducer.Discounts);
    const OrderDiscountsINR = useSelector(state => state.cartReducer.DiscountsINR);

    const [billingaddresscheckerr, setbillingaddresscheckerr] = useState('')
    const [shippingaddrrescheckerr, setshippingaddrrescheckerr] = useState(false)

    const { data: session } = useSession();

    const CustomerIp = GeoData.request
    const CustomerCountry = GeoData.countryName
    //const [CustomerIp, setCustomerIp] = useState(GeoData.request);
    //const [CustomerCountry, setCustomerCountry] = useState(GeoData.countryName);
    const [OrderPaymentGateway, setOrderPaymentGateway] = useState('1');

    // const [EditPopupbillingFName, setEditPopupbillingFName] = useState("");
    // const [EditPopupbillingLName, setEditPopupbillingLName] = useState("");
    // const [EditPopupbillingEmail, setEditPopupbillingEmail] = useState("");
    // const [EditPopupbillingTelephone, setEditPopupbillingTelephone] = useState("");   

    const [ShowShipAddPopUp, setShowShipAddPopUp] = useState(false);   
    const [ShowShipEditPopUp, setShowShipEditPopUp] = useState(false);   
    const [EditPopupErrors, setEditPopupErrors] = useState(false);   
    const [EditPopupErrorsMess, setEditPopupErrorsMess] = useState(''); 
    const [AddNewShipAddSucces, setAddNewShipAddSucces] = useState(false);     

    const [NotPlaceError, setNotPlaceError] = useState(false);     
    const [NotPlaceErrorMessage, setNotPlaceErrorMessage] = useState('');     
    const [PaypalScriptLoaded, setPaypalScriptLoaded] = useState(false);   
	const [DisplayPayPalButton, setDisplayPayPalButton] = useState(false);	
	
    // const [PayUTxnID, setPayUTxnID] = useState('1800rakhis1');  
    // const [PayUHashed, setPayUHashed] = useState('');     
    const [CurrencyCode, setCurrencyCode] = useState('USD'); 
    const [CartSubTotalPaypal, setCartSubTotalPaypal] = useState(CartGrandTotal); 
    const AllCountryData = useSelector(state => state.cartReducer.AllCountryData);   

	const [CcabvenueEncrpypted, setCcabvenueEncrpypted] = useState('');

    var saveOrderDataDatabase = '';
	var SavedOrderId;

    useEffect(() => {
        const body = document.querySelector('body');
        body.style.overflow = ShowShipAddPopUp ? 'hidden' : 'auto';
    }, [ShowShipAddPopUp])

    useEffect(() => {
        const body = document.querySelector('body');
        body.style.overflow = ShowShipEditPopUp ? 'hidden' : 'auto';
    }, [ShowShipEditPopUp])


    useEffect(async () => {
        const addPaypalScript = () => {
            var newcurrencycod = CurrencyCode;
            if (SelectedCurrencydata) {
                if(SelectedCurrencydata.CurrencyCode !== 'INR'){
                    newcurrencycod = SelectedCurrencydata.CurrencyCode
                    setCurrencyCode(newcurrencycod)
                    setDisplayPayPalButton(true)
					setOrderPaymentGateway('2')
                }else{
                    if(AllCountryData.length > 0){
                        AllCountryData.map((val,ind)=>{
                            if(val.CurrencyCode === 'USD'){
                                var newCartSubTotal = (OrderGrandTotalINR*val.CurrencyRate).toFixed();
                                setCartSubTotalPaypal(newCartSubTotal);
                            }
                        })
                    }

                    // var newCartSubTotal = (OrderSubtotalINR*0.13).toFixed();
                    // setCartSubTotalPaypal(newCartSubTotal);
                }
            }    

            // const script = document.createElement("script");
            // script.type = "text/javascript";
            // script.src = `https://www.paypal.com/sdk/js?client-id=Ab9_ABGTchFoDpk6yCm1IhBJ05s6CUIumrhjPzU77loqfv5nJBXs2V4puDhb2YEh7RTt_6WMvRzZ7cd3&currency=${newcurrencycod}`;
            // script.async = true;
			// script.onload = () => setPaypalScriptLoaded(true);
			// document.body.appendChild(script);
        };
        // Payu payment gateway
       // let newTxnidx = Math.floor((Math.random() * 10000000) + 1);

        await addPaypalScript();

      }, [CartSubTotalPaypal]);

    function getCustomPopupshiipingState(e) {
        setCustomPopupshiipingState(e.target.value)
        hideerrrors()
    }

    function getCustomPopupshiipingPincode(e) {
        var regex = /[`!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?~]/g;
        setCustomPopupshiipingPincode(e.target.value.replace(regex, ""))
        hideerrrors()
    }

    function hideerrrors() {
        setPopupEmailErr(false)
        setPopupFNameErr(false)
        setPopupLNameErr(false)
        setPopupTelephoneErr(false)
        setPopupshiipingFNameErr(false)
        setPopupshiipingLNameErr(false)
        setPopupshiipingTelephoneErr(false)
        setPopupshiipingAddressErr(false)
        setCustomPopupshiipingCityErr(false)
        setCustomPopupshiipingStateErr(false)
        setCustomPopupshiipingPincodeErr(false)
    }

    useEffect(() => {
        const serialState = localStorage.getItem('CartItemsList');
		if (serialState === null) {          
		}else{
			var storagedata = JSON.parse(serialState);
			if (storagedata.length > 0) {
				delCountry = storagedata[storagedata.length-1].country_id;
                setCartCountry(delCountry)
                
                if(delCountry === 33){
                    setShowState(false)
                    setShowStateNew(false)
                }else{
                    setShowState(true)
                    setShowStateNew(true)
                }
                setPopupshiipingCountry(delCountry)	
				Edit(delCountry)	
			}
		}


        const securepage = async () => {
            const session = await getSession()
            if (!session) {
                signIn()
            } else {
                setisLoader(false)
                var email = session.user.email
                await setPopupEmail(email)
                // await setCustomerEmail(email)
                getloginuserData(email)
            }
        }
        securepage()
    }, [])

    useEffect(()=>{

    },[ShippingAddressData])

    async function getloginuserData(email) {
        setisLoading(true)
        var delCountry = 2;
        var serialStates = localStorage.getItem('CartItemsList');
		if (serialStates === null) {          
		}else{
			var storagedata = JSON.parse(serialStates);
			if (storagedata.length > 0) {
				delCountry = storagedata[storagedata.length-1].country_id;
			}
		}

            var url = `${config.apiUrl}auth/customer/?customeremail=${email}&country=${delCountry}`

            const res = await fetch(url)
            const data = await res.json()
            var billingAddressdata = data.billingAddress
            var shippingAddressdata = data.shippingAddress
            setCustomerNo(data.results[0].CustomerID)
            if (billingAddressdata.length > 0) {
                setFName(billingAddressdata[0].CustomerBillingFirstName)
                setLName(billingAddressdata[0].CustomerBillingLastName)
                setEmail(billingAddressdata[0].CustomerBillingEmail)
                setTelephone(billingAddressdata[0].CustomerBillingPhone)
                setCustomerBillingName(data.billingAddress[0].CustomerBillingFirstName)
                setBillingAddressData(data.billingAddress[0])
                setBillingAddressCheck(true)
            }

            if (shippingAddressdata.length > 0) {
                setShippingAddressData(shippingAddressdata);
                
                if (shippingAddressdata.length === 1) {
                    setRFName(shippingAddressdata[0].CustomerShippingFirstName)
                    setRLName(shippingAddressdata[0].CustomerShippingLastName)
                    setStreetAdd(shippingAddressdata[0].CustomerShippingAddress)
                    setCity(shippingAddressdata[0].CustomerShippingCity)
                    setState(shippingAddressdata[0].CustomerShippingState)
                    setRPincode(shippingAddressdata[0].CustomerShippingPincode)
                    setCountry(shippingAddressdata[0].CustomerShippingCountryNo)
                    setRTelephone(shippingAddressdata[0].CustomerShippingPhone)
                    setadditionalclass(0)
                    setshippingaddrrescheckerr(false)
                    setShippingAddressCheck(true)
                }
            }

            setisLoading(false)       

    }

    function selectedShiippingAddress(e, CustomerShippingFirstName, CustomerShippingLastName, CustomerShippingAddress, CustomerShippingCity, CustomerShippingState, CustomerShippingPincode, CustomerShippingCountryNo, CustomerShippingPhone, ind) {
        setRFName(CustomerShippingFirstName)
        setRLName(CustomerShippingLastName)
        setStreetAdd(CustomerShippingAddress)
        setCity(CustomerShippingCity)
        setState(CustomerShippingState)
        setRPincode(CustomerShippingPincode)
        setCountry(CustomerShippingCountryNo)
        setRTelephone(CustomerShippingPhone)
        setadditionalclass(ind)
        setShippingAddressCheck(true)
    }

    const router = useRouter()

    async function saveOrderDataindatabase(paypalorderid) {
        
		var CartItemsListStorage = await GetStorage('CartItemsList'); 

		var CurrCode = SelectedCurrencydata.CurrencyCode;
		var CurrSymbol = SelectedCurrencydata.CurrencySymbol;
		var CurrRate = SelectedCurrencydata.CurrencyRate;

		if (CartItemsListStorage && CartItemsListStorage.length > 0) {
			CurrCode = CartItemsListStorage[0].CurrencyCode
			CurrSymbol = CartItemsListStorage[0].CurrencySymbol
			CurrRate = CartItemsListStorage[0].CurrencyRate
		}

        var CouponCode = '';
        if (CartDiscountsData) {
            CouponCode = CartDiscountsData[0].CouponCode;
        }

        // var s = (State) ? State : CustomState
        // var c = (City) ? City : CustomCity
        // var p = (RPincode) ? RPincode : CustomPincode

        var s = (State) ? State : ''
        var c = (City) ? City : ''
        var p = (RPincode) ? RPincode : ''

        var daysInMonth = MainDeldate.split("-");
        var OrderDeliveryDate = daysInMonth[2] + '-' + daysInMonth[1] + '-' + daysInMonth[0];


        var formData =
        {
            "ProductCountry": Country,
            "OrderSubtotalINR": OrderSubtotalINR,
            "OrderSubtotal": CartSubTotal,
            "OrderCouponCode": CouponCode,
            "OrderCouponType": '1',
            "OrderDiscount": CouponDiscount,
            "OrderDiscountINR": OrderDiscountsINR,
            "OrderCurrentCurrRate": CurrRate,
            "OrderCurrentCurrCode": CurrCode,
            "OrderCurrentCurrSymbol": CurrSymbol,
            "CustomerNo": CustomerNo,
            "OrderPaymentGateway": OrderPaymentGateway,
            "OrderGrandTotal": CartGrandTotal,
            "OrderGrandTotalINR": OrderGrandTotalINR,
            "prodcuts": CartItemsList,
            "OrderFromIP": CustomerIp,
            "OrderCouponPerORVal": '0',
            "CustomerBillingFirstName": FName,
            "CustomerBillingLastName": LName,
            "CustomerBillingEmail": Email,
            "CustomerBillingPhone": Telephone,
            "GiftMessage": GiftMessage,
            "SpecialInstructions": SpInstruction,
            "CustomerShippingFirstName": RFName,
            "CustomerShippingLastName": RLName,
            "CustomerShippingCompany": ComName,
            "CustomerShippingCountryNo": Country,
            "CustomerShippingState": s,
            "CustomerShippingCity": c,
            "CustomerShippingAddress": StreetAdd,
            "CustomerShippingPincode": p,
            "CustomerShippingPhone": RTelephone,
            "Pincode": MainPincode,
            "CustomerCountry": CustomerCountry,
            "OrderDeliveryCharges": OrderDeliveryCharges,
            "OrderDeliveryChargesINR": OrderDeliveryChargesINR,
			"paypalorderid": paypalorderid,
            "login": '1',
        }

        var placeOrderUrl = `${config.apiUrl}orders`;
        const result = await fetch(placeOrderUrl, {
            method: "POST",
            headers: {},
            body: JSON.stringify(formData)
        });
        const response = await result.json();
        if (response.CODE === 200) {
            var orderid = response.orderId;
        } else {
            var orderid = '';
        }
        return orderid

    }

    function validatCheckoutForm() {
        var validForm = true;
        if (!BillingAddressCheck) {
            setbillingaddresscheckerr(true)
            validForm = false;
        }
        if (!ShippingAddressCheck) {
            setNotPlaceError(true)
            setNotPlaceErrorMessage('Please select the shiping adrress')
            validForm = false;
        }
        return validForm
    }

    function CheckdeliveryDate() {
		var countryid = Country;
		//const serialState = localStorage.getItem('CartItemsList');
		var validdate = true;

		if(CartItemsList.length < 1){
			return false;
		}else{
			var checkeddata = CartItemsList.map((val,ind)=>{
				var currdate = new Date();
                currdate.setHours(0,0,0,0)

				var deldate = val.del_date;
                var deldt = new Date(deldate)

                if (currdate > deldt) {
                    validdate = false;
                    return validdate
                }
			})        
			return validdate
		}
	}

    async function placeorder(e) {
        e.preventDefault();

        setisLoader(true)
        
        var CartItemsListStorage = GetStorage('CartItemsList'); 

		if(CartItemsListStorage === undefined){
			setisLoader(false)
			setNotPlaceError(true)
			setNotPlaceErrorMessage('You have no items in your cart.')
			return false;s
		}
        
        if(!CartItemsListStorage){
			setisLoader(false)
			setNotPlaceError(true)
			setNotPlaceErrorMessage('You have no items in your cart.')
			return false;s
		}
        if(CartItemsListStorage.length < 1){
			setisLoader(false)
			setNotPlaceError(true)
			setNotPlaceErrorMessage('You have no items in your cart.')
			return false;s
		}

		var validateform = await CheckdeliveryDate();
		if (!validateform) {
			setisLoader(false)
			setNotPlaceError(true)
			setNotPlaceErrorMessage('You have back date delivery products in your cart. ')
			return false;
		}

        var validateform = await validatCheckoutForm();
        if (!validateform) {
            setisLoader(false)
            return false;
        }
		var paypaloid = '';
        saveOrderDataDatabase = await saveOrderDataindatabase(paypaloid)
        if (!saveOrderDataDatabase) {
            setisLoader(false)
            return false;
        }

        setisLoader(true)
		
		if (OrderPaymentGateway == 1) {
			const res = await initializeRazorpay();

			if (!res) {
				setisLoader(false)
				return false;
			}

			const data = await fetch("/api/orders/paymentgateway/razorpay/razorpay", {
				method: "POST",
				headers: {
					'Content-Type': 'application/json',
				},
				body: JSON.stringify({
					'amount': CartGrandTotal,
					'currency': SelectedCurrencydata.CurrencyCode
				})
			}).then((t) =>
				t.json()
			);
			setisLoader(false)

			var options = {
				key: process.env.RazorPaySecretKey, // Enter the Key ID generated from the Dashboard
				name: FName + ' ' + LName,
				currency: SelectedCurrencydata.CurrencyCode,
				amount: data.amount,
				order_id: data.id,
				description: "",
				image: config.callBackUrl + '/logo.png',
				handler: async function (response) {
                    var checklogunableurl = await checklogsenabled('1');
					console.log('checklogunableurl succ',checklogunableurl)
					if(checklogunableurl){
						await savepaymentlogs('1','',saveOrderDataDatabase,response)
					}
					var paypalorderid = ''
					await UpdateOrderStatusAfterPayment(saveOrderDataDatabase, Email,'12',paypalorderid);	
					setisLoader(false)	
                    
				},
				prefill: {
					name: FName + ' ' + LName,
					email: Email,
					contact: Telephone,
				},
			};
			const paymentObject = new window.Razorpay(options);
			paymentObject.on('payment.failed', async function (response) {
                var paypalorderid = ''
				var checklogunableurl = await checklogsenabled('1');
				//console.log('checklogunableurl failed',checklogunableurl)
				if(checklogunableurl){
					await savepaymentlogs('1','',saveOrderDataDatabase,response)
				}
				await UpdateOrderStatusAfterPayment(saveOrderDataDatabase, Email,'11',paypalorderid);
				setisLoader(false)

				// await UpdateOrderStatusAfterPayment(saveOrderDataDatabase, Email, '11');
				// setisLoader(false)
			});

			paymentObject.open();
		}
		
		else if(OrderPaymentGateway == 3){
			setisLoader(true)
			const ccavenuedata = await fetch("/api/orders/paymentgateway/ccavenue/ccavenue", {
				method: "POST",
				headers: {
					'Content-Type': 'application/json',
				},
				body: JSON.stringify({
					'amount': CartGrandTotal,
					'currency': SelectedCurrencydata.CurrencyCode,
					'orderid': saveOrderDataDatabase,
					'billingname': FName+' '+LName
				})
			}).then((t) =>
				t.json()
			);
			setCcabvenueEncrpypted(ccavenuedata.encryptedOrderData)
		}
        
		else {
		}
	}

	useEffect(async () => {
		 if(CcabvenueEncrpypted){
			document.redirect.submit(); 
		 }
	 },[CcabvenueEncrpypted])
	 
    const initializeRazorpay = () => {
        return new Promise((resolve) => {
            const script = document.createElement("script");
            script.src = "https://checkout.razorpay.com/v1/checkout.js";
            // document.body.appendChild(script);

            script.onload = () => {
                resolve(true);
            };
            script.onerror = () => {
                resolve(false);
            };

            document.body.appendChild(script);
        });
    };

    async function UpdateOrderStatusAfterPayment(orderid, mail, paymentstatus,paypalorderid) {
        setisLoader(true)

        var fetchurl = `${config.apiUrl}orders/updatestatus`;
        var uformData = {
            'orderid': orderid,
            'email': mail,
            'paymentstatus': paymentstatus,
            'paypalorderid': paypalorderid,
        }
        const result = await fetch(fetchurl, {
            method: "POST",
            headers: {
            },
            body: JSON.stringify(uformData)
        });

        const response = await result.json();
        setisLoader(false)
        
        if (response.CODE === 200) {
            if (paymentstatus == 12) {
                await dispatch(emptyCart());
                setTimeout(function () {
                    router.push('/thankyou/?id=' + orderid)
                }, 2000)
            }
        } else {
            
            // alert('response.error')
        }
    }

    function getPopupEmail(e) {
        setPopupEmail(e.target.value);
        hideerrrors()
    }
    
	function getPopupFName(e) {
        setPopupFName(e.target.value);
        hideerrrors()
    }
    
	function getPopupLName(e) {
        setPopupLName(e.target.value);
        hideerrrors()
    }
    
	function getPopupTelephone(e) {
        setPopupTelephone(e.target.value);
        hideerrrors()
    }
    
	function getPopupshiipingFName(e) {
        setPopupshiipingFName(e.target.value);
        hideerrrors()
    }
    
	function getPopupshiipingEmail(e) {
        setPopupshiipingEmail(e.target.value);
        hideerrrors()
    }
    
	function getPopupshiipingLName(e) {
        setPopupshiipingLName(e.target.value);
        hideerrrors()
    }
    
	function getPopupshiipingTelephone(e) {
        setPopupshiipingTelephone(e.target.value.replace(/\D/g, ""));
        hideerrrors()
    }
    
	function getPopupshiipingAddress(e) {
        setPopupshiipingAddress(e.target.value);
        hideerrrors()
    }
    
	function getCustomPopupshiipingCity(e) {
        setCustomPopupshiipingCity(e.target.value)
        hideerrrors()
    }
    
	async function saveCustomerBillinginformation(e) {

        if (!PopupFName) {
            setPopupFNameErr(true)
        } if (!PopupLName) {
            setPopupLNameErr(true)
        } else if (!PopupEmail) {
            setPopupEmailErr(true)
        } else if (!PopupTelephone) {
            setPopupTelephoneErr(true)
        }
        else {
            const registerResp = await fetch(`${config.apiUrl}auth/customer/savebillinginfo`, {
                method: "POST",
                body: JSON.stringify({
                    CustomerBillingName: PopupFName,
                    CustomerBillinglastName: PopupLName,
                    CustomerBillingEmail: PopupEmail,
                    CustomerBillingId: '',
                    CustomerNo: CustomerNo,
                    CustomerBillingPhone: PopupTelephone
                }),
                headers: {
                    "Content-Type": "application/json",
                },
            }).then(function (response) {
                if (response.status == 200) {

                    var cdata = {
                        'CustomerBillingFirstName': PopupFName,
                        'CustomerBillingLastName': PopupLName,
                        'CustomerBillingEmail': PopupEmail,
                        'CustomerBillingPhone': PopupTelephone
                    }

                    setBillingAddressData(cdata)
                    setFName(PopupFName)
                    setLName(PopupLName)
                    setEmail(PopupEmail)
                    setTelephone(PopupTelephone)
                    setBillingAddressCheck(true)

                } else {
                    // seterrorMsg(true)
                }
            });
        }
    }
    
	async function EditCustomerShippingformation(e) {    

        var fname = EditPopupshiipingFName
        var lname = EditPopupshiipingLName
        var state = EditPopupshiipingState
        var addrs = EditPopupshiipingAddress
        var scity = EditCustomPopupshiipingCity
        var pcode = EditCustomPopupshiipingPincode
        var spnone = EditPopupshiipingTelephone     

        if(EditPopupshiipingState ==''){
            state = EditCustomPopupshiipingState
        }        

        if(fname == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('First name is required')
            return false;
        }
        if(lname == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('Last name is required')
            return false;
        }
        if(state == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('State is required')
            return false;
        }
        if(addrs == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('Address is required')
            return false;
        }
        if(scity == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('City is required')
            return false;
        }
        if(pcode == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('Pincode is required')
            return false;
        }
        if(spnone == ''){
            setEditPopupErrors(true)
            setEditPopupErrorsMess('Phone number is required')
            return false;
        }
        
        // var lname = itemvals.CustomerShippingLastName
        // if(EditPopupshiipingLName){
        //     lname = EditPopupshiipingLName
        // }
        // var state = itemvals.CustomerShippingState
        // if(EditCustomPopupshiipingState){
        //     state = EditCustomPopupshiipingState
        // }
        // var addrs = itemvals.CustomerShippingAddress
        // if(EditPopupshiipingAddress){
        //     addrs = EditPopupshiipingAddress
        // }
        // var scity = itemvals.CustomerShippingCity
        // if(EditCustomPopupshiipingCity){
        //     scity = EditCustomPopupshiipingCity
        // }
        // var pcode = itemvals.CustomerShippingPincode
        // if(EditCustomPopupshiipingPincode){
        //     pcode = EditCustomPopupshiipingPincode
        // }
        // var spnone = itemvals.CustomerShippingPhone
        // if(EditPopupshiipingTelephone){
        //     spnone = EditPopupshiipingTelephone
        // }

        var ShippingEditId = EditPopupshiipingAddID;

        var formdata = JSON.stringify({
            "CustomerShippingName": fname,
            "CustomerShippingLastname": lname,
            "CustomerShippingAddress": addrs,
            "CustomerShippingCity": scity,
            "CustomerShippingState": state,
            "CustomerShippingPincode": pcode,
            "CustomerShippingPhone": spnone,
            "CustomerShippingCountry": EditPopupshiipingCountry,
            "ShippingEditId": ShippingEditId,
            "CustomerNo": CustomerNo,
            "AllCountry": '',
        })
        

        const registerResp = await fetch(`${config.apiUrl}auth/customer/saveshippinginfo`, {
            method: "POST",
            body: formdata,
            headers: {
                "Content-Type": "application/json",
            },
        }).then(function (response) {
            return response.json();  // <---- this is important
        }).then(response => {
            if (response.CODE == 200) {
                setShippingAddressData(response.shippingAddress)
                setShowShipEditPopUp(false)
                
            } else {

            }
        });
       
    }    
    
	async function saveCustomerShippingformation(e) {
        var pc = (PopupshiipingCity) ? PopupshiipingCity : CustomPopupshiipingCity
        var ps = (PopupshiipingState) ? PopupshiipingState : CustomPopupshiipingState
        var cpc = (PopupshiipingPincode) ? PopupshiipingPincode : CustomPopupshiipingPincode

        var mdelCountry = 2
        const serialState = localStorage.getItem('CartItemsList');
		if (serialState === null) {          
		}else{
			var storagedata = JSON.parse(serialState);
			if (storagedata.length > 0) {
				mdelCountry = storagedata[storagedata.length-1].country_id;
                if(mdelCountry === 33){
                    ps = 'Yes';
                }				
			}
		}

        if (!PopupshiipingFName) {
            setPopupshiipingFNameErr(true)
        } else if (!PopupshiipingLName) {
            setPopupshiipingLNameErr(true)
        } else if (!PopupshiipingAddress) {
            setPopupshiipingAddressErr(true)
        } else if (!PopupshiipingTelephone) {
            setPopupshiipingTelephoneErr(true)
        } else if (!pc) {
            setCustomPopupshiipingCityErr(true)
        } else if (!ps) {
            setCustomPopupshiipingStateErr(true)            
        }
        else if (!cpc) {
            setCustomPopupshiipingPincodeErr(true)
        }
        else {

            if(mdelCountry === 33){
                ps = '';
            }		
           
            const registerResp = await fetch(`${config.apiUrl}auth/customer/saveshippinginfo`, {
                method: "POST",
                body: JSON.stringify({
                    "CustomerShippingName": PopupshiipingFName,
                    "CustomerShippingLastname": PopupshiipingLName,
                    "CustomerShippingAddress": PopupshiipingAddress,
                    "CustomerShippingCity": pc,
                    "CustomerShippingState": ps,
                    "CustomerShippingPincode": cpc,
                    "CustomerShippingPhone": PopupshiipingTelephone,
                    "CustomerShippingCountry": PopupshiipingCountry,
                    "ShippingEditId": '',
                    "CustomerNo": CustomerNo,
                    "AllCountry": '',
                }),
                headers: {
                    "Content-Type": "application/json",
                },
            }).then(function (response) {
                return response.json();  // <---- this is important
            }).then(async response => {
                if (response.CODE == 200) {
                    setAddNewShipAddSucces(true);

                    setTimeout(()=>{
                        setAddNewShipAddSucces(false);
                    },3000)

                    setShippingAddressData(response.shippingAddress)                    
                    setRFName(PopupshiipingFName)
                    setRLName(PopupshiipingLName)
                    setStreetAdd(PopupshiipingAddress)
                    setCity(pc)
                    setState(ps)
                    setRPincode(cpc)
                    setCountry(PopupshiipingCountry)
                    setRTelephone(PopupshiipingTelephone)
                    setadditionalclass(response.shippingAddress.length-1)
                    setShippingAddressCheck(true)

                    setPopupshiipingFName('')
                    setPopupshiipingLName('')
                    setPopupshiipingAddress('')
                    setPopupshiipingTelephone('')
                } else {
                }
            });
        }
        setTimeout(function () {
        }, 2500);
    }    
    
	async function SelectPaymentGateway(e) {
        var selvalue = e.target.value;
        setOrderPaymentGateway(selvalue)
    }
    
	async function DeleteShippingAdd(item) {
        const registerResp = await fetch(`${config.apiUrl}auth/customer/deleteshippingadd`, {
            method: "POST",
            body: JSON.stringify({
                CustomerAddressBookId: item.CustomerAddressBookId,
            }),
            headers: {
                "Content-Type": "application/json",
            },
        }).then(function (response) {
            return response.json();  // <---- this is important
        }).then(response => {
            if (response.CODE == 200) {

                var allShippAdd = [...ShippingAddressData]

                const newitems = allShippAdd.filter(value => { return value.CustomerAddressBookId !== item.CustomerAddressBookId });
                setShippingAddressData(newitems);

            } else {
            }
        });
    }
    
	async function getShipAddresForPopUp(addID,sfname,slname,sadd,scity,sstate,spincode,scountry,sphone){   
        setadditionalclass('')
        setShippingAddressCheck(false)

        setEditPopupshiipingFName(sfname)
        setEditPopupshiipingLName(slname)
        setEditPopupshiipingAddress(sadd)
        setEditCustomPopupshiipingCity(scity)
        setEditCustomPopupshiipingPincode(spincode)
        setEditPopupshiipingTelephone(sphone)
        setEditPopupshiipingState(sstate)
        //setEditPopupshiipingFName(scountry)
        setEditPopupshiipingAddID(addID)
        setShowShipEditPopUp(true)
    }

    const closeEditShipModal = () => setShowShipEditPopUp(false);
    const closeAddShipModal = () => setShowShipAddPopUp(false);

    function displaypaypalerr(err){
		console.log(err)
	}

    const PaypalStyle = {"layout":"horizontal","color":"blue","marginTop":"14px"};

    // async function PayPalReturnAfterPayment(details,data){

    //     if(details.status === "COMPLETED"){
    //         var saveOrderDataDatabase = await saveOrderDataindatabase();

    //         await UpdateOrderStatusAfterPayment(saveOrderDataDatabase, Email, '12');

    //     }else{
    //         var saveOrderDataDatabase = await saveOrderDataindatabase();            
    //         await UpdateOrderStatusAfterPayment(saveOrderDataDatabase, Email, '11');
    //     }
        

    // }

	async function savePaypalsuccess(data, actions){
		return actions.order.capture().then( async function(details) {
			var paypalorderid = data.orderID
			var checklogunableurl = await checklogsenabled('2');
			if(checklogunableurl){
				await savepaymentlogs('2',paypalorderid,'',data)
			}
			await UpdateOrderStatusAfterPayment(SavedOrderId,Email,'12',paypalorderid);
		});
	}
	
    async function createOrder(data, actions){
		return actions.order.create({purchase_units: [
			{
				amount: {
					currency_code: CurrencyCode,
					value: CartSubTotalPaypal,
				},
			},
		],
		}).then( async (orderId) => {
			var paypaloid = orderId;
			var saveOrderDataDatabase = await saveOrderDataindatabase(paypaloid);
			if (!saveOrderDataDatabase) {
				return false;
			}else{
				SavedOrderId = saveOrderDataDatabase
				return orderId;
			}
			
		});
	}
    
    async function savepaymentlogs(savepaymentmethod,savetransactionid,saveOrderid,saveresponse){
		var savelogs = `${config.apiUrl}paymentlogs/savepaymentlog`;
		const savelogsresult = await fetch(savelogs, {
			method: "POST",
			headers: {
				'Content-Type': 'application/json',
			},
			body: JSON.stringify({
				'saveresponse':saveresponse,
				'orderid':saveOrderid,
				'paymentmethod':savepaymentmethod,
				'Transactionid':savetransactionid
			})
		});
	}

	async function checklogsenabled(id){
		var logunableurl = `${config.apiUrl}paymentlogs/?id=${id}`
		const res = await fetch(logunableurl)
		const data = await res.json()
		if(data.CODE == '200' && data.enablelog == '1'){
			return true
		}else{
			return false
		}
	}

	
	
	
	async function savepaypalpaymentfailed(err){
		var checklogunableurl = await checklogsenabled('2');
		if(checklogunableurl){
			await savepaymentlogs('1','',saveOrderDataDatabase,err)
		}
	}
	
	async function saveCancelPaypalstatus(data){
		var paypalorderid = data.orderID
		var checklogunableurl = await checklogsenabled('2');
		if(checklogunableurl){
			await savepaymentlogs('2',paypalorderid,'',data)
		}
		await UpdateOrderStatusAfterPayment('',Email,'2',data.orderID);
	}
	
	function loadpaypalbutton(){
		setPaypalScriptLoaded(true)
	}

	async function EditCustomPincode(e) {
		//setCustomPincode(e.target.value.replace(/\D/g, ""));
		var regex = /[`!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?~]/g;
		setEditCustomPopupshiipingPincode(e.target.value.replace(regex, ""));		
	}


    return (
        <>
			<div className = "">
				<form id="nonseamless" method="POST" name="redirect" action="https://secure.ccavenue.com/transaction/transaction.do?command=initiateTransaction">
				<input Type="hidden" id="encRequest" name="encRequest" value={CcabvenueEncrpypted} />
				<input Type="hidden" name="access_code" id="access_code" value={process.env.NEXT_PUBLIC_CCAVENUE_ACCESSCODE} />
				</form>
			</div>
            {(NotPlaceError) ?
                <>
                    <div className='md-effect-1'>
						<div className='errdiv'>

							<div className='errdivico'>
								<Info className='errdicon' />
								<div className='closebtnpop'>
									<button onClick={() => setNotPlaceError(false)}><CloseOutlined className='crossiconerr' /></button>
								</div>
								<p>
									{NotPlaceErrorMessage}
								</p>
							</div>

						</div>
					</div>
					<div className="md-overlay"></div>
                </>
                :
                ''
            }
            {(billingaddresscheckerr) ?
                <>
                    <div className='md-effect-1'>
                        <div className='errdiv'>
                            <div className='errdivico'>
                                <Info className='errdicon' />
                                <div className='closebtnpop'>
                                    <button onClick={() => setbillingaddresscheckerr(false)}><CloseOutlined className='crossiconerr' /></button>
                                </div>
                                <p>
                                    {'Please select billing address.'}
                                </p>
                            </div>

                            {/* <div className='btn_center_err_wrap'>
                                <button onClick={() => setbillingaddresscheckerr(false)} className='Top_header btn_center_err'>Try Again</button>
                            </div> */}

                        </div>
                    </div>
                    <div className='md-overlay'></div>
                </>
                :
                ''
            }

            {isLoader ?
                <span className={`${styles.ew_guest_loder} align-items-center justify-content-center d-flex w-100`} >

                    <img
                        src='/loading.gif' className={styles.loader} alt="loader"
                    />
                </span>
                :
                <>
                    <div className={styles.topcheckout}>
                        <div className={styles.tpcheckouttab}>
                            <h2>Secure Checkout<Lock width='15' className={styles.lock} /></h2>
                        </div>

                    </div>

                    <Grid container className={styles.checkoutwrapper}>
                        <Grid item md={4} sm={12} xs={12}>
                            {(!isLoading) ?
                                <>
                                    <div className={styles.senderinfocoint}>
                                        {(BillingAddressData) ?
                                            <>
                                                <div className={styles.loginsenderinfo}>
                                                    <div className={styles.innerlogininfo}>
                                                        <h3>Senders Info</h3>
                                                    </div>
                                                </div>
                                                <div className={styles.senderinfodetail}>
                                                    <div className={styles.senderinnerdetail}>
                                                        <div className={`${styles.sendermain} ${styles.sendertitle}`}>
                                                            <h2>
                                                                <p>{BillingAddressData.CustomerBillingFirstName} {BillingAddressData.CustomerBillingLastName}</p>
                                                            </h2>
                                                        </div>
                                                        <div className={`${styles.sendermain} ${styles.senderemail}`}>
                                                            <h2>
                                                                <p><EmailOutlined className={styles.emailsenderico} />{BillingAddressData.CustomerBillingEmail}</p>
                                                            </h2>
                                                        </div>
                                                        <div className={`${styles.sendermain} ${styles.senderphone}`}>
                                                            <h2>
                                                                <p><CallOutlined className={styles.phonesenderico} />{BillingAddressData.CustomerBillingPhone}</p>
                                                            </h2>
                                                        </div>
                                                    </div>
                                                </div>
                                            </>
                                            :
                                            <>
                                                <div classNamea={styles.recipent}>
                                                    <div className={styles.addnewuser}>
                                                        {/* <button>Add New</button> */}
                                                        <div className={styles.innerlogininfo}>
                                                            <h3>Senders Info</h3>
                                                        </div>
                                                        <Popup
                                                            trigger={<button className={styles.button}>Add </button>}
                                                            modal
                                                            nested>
                                                            {close => (
                                                                <div className={`${styles.modal} ${styles.modal_edit}`}>
                                                                    <button className={styles.close} onClick={close}>
                                                                        &times;
                                                                    </button>
                                                                    <div className={styles.header}> <h4>Add Billing Information</h4> </div>
                                                                    <div className={styles.errdivpopup}>
                                                                        {(PopupFNameErr) ?
                                                                            <span>First Name is required</span>
                                                                            :
                                                                            ''
                                                                        }
                                                                        {(PopupLNameErr) ?
                                                                            <span>Last Name is required</span>
                                                                            :
                                                                            ''
                                                                        }
                                                                        {(PopupEmailErr) ?
                                                                            <span>Email is required</span>
                                                                            :
                                                                            ''
                                                                        }
                                                                        {(PopupTelephoneErr) ?
                                                                            <span>Phone Number is required</span>
                                                                            :
                                                                            ''
                                                                        }
                                                                    </div>
                                                                    <div className={styles.content}>
                                                                        {' '}
                                                                        <div className={styles.edit_contact}>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="FirstName" value={PopupFName} onChange={(e) => getPopupFName(e)} />
                                                                                    <label>First Name</label>
                                                                                </div>
                                                                            </div>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="LastName" value={PopupLName} onChange={(e) => getPopupLName(e)} />
                                                                                    <label>Last Name</label>
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                        <div className={styles.edit_contact}>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="Email" value={PopupEmail} onChange={(e) => getPopupEmail(e)} />
                                                                                    <label>Email</label>
                                                                                </div>
                                                                            </div>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="Phone" value={PopupTelephone} onChange={(e) => getPopupTelephone(e)} />
                                                                                    <label>Phone</label>
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                        <div className={styles.checksavepop}>
                                                                            <button type="submit" className={`${styles.register_submit}  ${styles.procartbtn} procartbtn`} onClick={(e) => saveCustomerBillinginformation(e)}>Save</button>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            )}
                                                        </Popup>
                                                    </div>
                                                </div>

                                                <div className={styles.senderinfodetail}>
                                                    <div className={styles.senderinnerdetail}>
                                                        <div className={`${styles.sendermain} ${styles.sendertitle}`}>
                                                            <p>No Billing Address Set.Add Billing address</p>
                                                        </div>
                                                    </div>
                                                </div>
                                            </>
                                        }
                                    </div>

                                    {(ShippingAddressData.length > 0) ?
                                        <>
                                            <div className={styles.reacipientcont}>
                                                <div className={styles.addnewuser}>
                                                    {/* <button>Add New</button> */}
                                                    <div className={styles.recipeinttoptext}>
                                                        <h3>Recipient Info</h3>
                                                    </div>

                                                    <button className={styles.button} onClick={()=>setShowShipAddPopUp(true)}>Add</button>

                    
                                                </div>

                                                <div className={styles.deliverherescroll}>
                                                    <div className={styles.deliverscrollinner}>
                                                        {ShippingAddressData.map((item, ind) => {
                                                            var CustomerShippingAddress = item.CustomerShippingAddress;
                                                            CustomerShippingAddress = CustomerShippingAddress.replace(/^'(.*)'$/, '$1');
                                                            CustomerShippingAddress = CustomerShippingAddress.replace(/\\/g, '');       
                                                            
                                                            var CustomerShippingFirstName = item.CustomerShippingFirstName;
                                                            CustomerShippingFirstName = CustomerShippingFirstName.replace(/^'(.*)'$/, '$1');
                                                            CustomerShippingFirstName = CustomerShippingFirstName.replace(/\\/g, '');

                                                            var CustomerShippingLastName = item.CustomerShippingLastName;
                                                            CustomerShippingLastName = CustomerShippingLastName.replace(/^'(.*)'$/, '$1');
                                                            CustomerShippingLastName = CustomerShippingLastName.replace(/\\/g, '');

                                                            var CustomerShippingCity = item.CustomerShippingCity;
                                                            CustomerShippingCity = CustomerShippingCity.replace(/^'(.*)'$/, '$1');
                                                            CustomerShippingCity = CustomerShippingCity.replace(/\\/g, '');   
                                                            
                                                           // var selectdstate = item.CustomerShippingState
                                                            return (
                                                                <>
                                                                    <div className={styles.recipientinfo}>
                                                                        <div className={styles.recipientinfoinner}>
                                                                            <div className={styles.recipienttitle}>
                                                                                <HomeOutlined className={styles.homeico} /><p>{CustomerShippingFirstName} {CustomerShippingLastName}</p>
                                                                            </div>

                                                                            <div className={styles.recipientmdetail}>
                                                                                <div className={styles.recipientdetailinner}>
                                                                                    <div className={styles.recipientaddre}>
                                                                                        <div className={styles.recipientaddressmain}>

                                                                                            <p>{CustomerShippingAddress}, </p>
                                                                                            <p>{CustomerShippingCity}-{item.CustomerShippingState} ,{item.CountryName},{item.CustomerShippingPincode} </p>

                                                                                        </div>

                                                                                        <div className={styles.recipientphone}>
                                                                                            <p><CallOutlined className={styles.phonedelico} />{item.CustomerShippingPhone}</p>
                                                                                        </div>
                                                                                    </div>
                                                                                </div>

                                                                                <div className='btndeliverywrap'>
                                                                                    <Button className={`deliveraddress-bt  ${additionalclass === ind ? "delselectedlocation" : ''
                                                                                        }`} value="selectdeladd"

                                                                                        onClick={(e) => selectedShiippingAddress(e, item.CustomerShippingFirstName, item.CustomerShippingLastName, item.CustomerShippingAddress, item.CustomerShippingCity, item.CustomerShippingState, item.CustomerShippingPincode, item.CustomerShippingCountryNo, item.CustomerShippingPhone, ind)}>Deliver Here</Button>
                                                                                </div>

                                                                                <div className={styles.editshippingdetail} >
                                                                                    <button className={`${styles.button} ${styles.login_edit_btn}`}><EditIcon onClick={()=>getShipAddresForPopUp(item.CustomerAddressBookId, CustomerShippingFirstName,CustomerShippingLastName, CustomerShippingAddress, CustomerShippingCity, item.CustomerShippingState, item.CustomerShippingPincode, item.CustomerShippingCountryNo, item.CustomerShippingPhone)} width='10' className={styles.login_add_edit}/></button>

                                                                                    

                                                                                    <div onClick={() => DeleteShippingAdd(item)}><DeleteIcon width='10' className={styles.login_add_del}/></div>
                                                                                </div>
                                                                                

                                                                            </div>
                                                                        </div>
                                                                    </div>


                                                                </>

                                                            )
                                                        })}

                                                        <Popup                                                                                     
                                                            open={ShowShipEditPopUp}
                                                            onClose={closeEditShipModal}
                                                            modal
                                                            nested>
                                                            {close => (
                                                                <div className={`${styles.modal} ${styles.modal_edit}`}>
                                                                    <button className={styles.close} onClick={close}>
                                                                        &times;
                                                                    </button>
                                                                    <div className={styles.header}> <h4>Update Shipping Address</h4> </div>

                                                                    <div className={styles.errdivpopup}>
                                                                        {(EditPopupErrors) ?
                                                                            <span>{EditPopupErrorsMess}</span>
                                                                            :
                                                                            ''
                                                                        }
                                                                    </div>

                                                                    <div className={styles.content}>
                                                                        {' '}
                                                                        <div className={styles.edit_contact}>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required
                                                                                        name="FirstName" value={EditPopupshiipingFName}
                                                                                        onChange={(e) => setEditPopupshiipingFName(e.target.value)} />
                                                                                    <label>First Name</label>
                                                                                </div>
                                                                            </div>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="LastName" value={EditPopupshiipingLName} onChange={(e) => setEditPopupshiipingLName(e.target.value)} />
                                                                                    <label>Last Name</label> 
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                        
                                                                            <div className={styles.edit_contact}>

                                                                                <div className={styles.form_wrap_edit}>
                                                                                    <div className={styles.input_wrap_edit}>
                                                                                        {
                                                                                            (PopupshiipingCountry == 2) ?
                                                                                                <>
                                                                                                    <input type="text" required name="Country" value={'India'} />
                                                                                                </>
                                                                                                :
                                                                                                (PopupshiipingCountry == 3) ?
                                                                                                    <>
                                                                                                        <input type="text" required name="Country" value={'Australia'} />
                                                                                                    </>
                                                                                                    :
                                                                                                    (PopupshiipingCountry == 4) ?
                                                                                                        <>
                                                                                                            <input type="text" required name="Country" value={'USA'} />
                                                                                                        </>
                                                                                                        :
                                                                                                        (PopupshiipingCountry == 5) ?
                                                                                                            <>
                                                                                                                <input type="text" required name="Country" value={'Canada'} />
                                                                                                            </>
                                                                                                            :
                                                                                                            (PopupshiipingCountry == 30) ?
                                                                                                                <>
                                                                                                                    <input type="text" required name="Country" value={'UK'} />
                                                                                                                </>
                                                                                                                :
                                                                                                                (PopupshiipingCountry == 31) ?
                                                                                                                    <>
                                                                                                                        <input type="text" required name="Country" value={'UAE'} />
                                                                                                                    </>
                                                                                                                    :
                                                                                                                    (PopupshiipingCountry == 32) ?
                                                                                                                        <>
                                                                                                                            <input type="text" required name="Country" value={'Germany'} />
                                                                                                                        </>
                                                                                                                        :
                                                                                                                        (PopupshiipingCountry == 33) ?
                                                                                                                            <>
                                                                                                                                <input type="text" required name="Country" value={'Singapore'} />
                                                                                                                            </>
                                                                                                                            :
                                                                                                                            <>
                                                                                                                            </>
                                                                                        }

                                                                                        <label>Country</label>
                                                                                    </div>

                                                                                </div>
                                                                                <div className={styles.form_wrap_edit}>
                                                                                    
                                                                                    <div className={`${styles.input_wrap_edit} ${styles.input_wrap_Selecti}`}>
                                                                                        {ShowState ?
                                                                                        <>
                                                                                        <select 
                                                                                            className={styles.selectshipadd} required 
                                                                                            defaultValue={EditPopupshiipingState} 
                                                                                            onChange={(e) => setEditCustomPopupshiipingState(e.target.value)} 
                                                                                        >
                                                                                            {(PopupshiipingCountry == 2) ?
                                                                                                <>
                                                                                                    {IndiaStates.map((s, sind) => {
                                                                                                        return (
                                                                                                            <option value={s.value} key={sind}> {s.name}</option>
                                                                                                        )
                                                                                                    })}
                                                                                                </>
                                                                                                :
                                                                                                (PopupshiipingCountry == 3) ?
                                                                                                    <>
                                                                                                        {AustraliaStates.map((s, sind) => {
                                                                                                            return (
                                                                                                                <option value={s.value} key={sind} > {s.name}</option>
                                                                                                            )
                                                                                                        })}
                                                                                                    </>
                                                                                                    :
                                                                                                    (PopupshiipingCountry == 4) ?
                                                                                                        <>
                                                                                                            {UsaStates.map((s, sind) => {
                                                                                                                return (
                                                                                                                    <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                )
                                                                                                            })}
                                                                                                        </>
                                                                                                        :
                                                                                                        (PopupshiipingCountry == 5) ?
                                                                                                            <>
                                                                                                                {CanadaStates.map((s, sind) => {
                                                                                                                    return (
                                                                                                                        <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                    )
                                                                                                                })}
                                                                                                            </>
                                                                                                            :
                                                                                                            (PopupshiipingCountry == 30) ?
                                                                                                                <>
                                                                                                                    {UkStates.map((s, sind) => {
                                                                                                                        return (
                                                                                                                            <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                        )
                                                                                                                    })}
                                                                                                                </>
                                                                                                                :
                                                                                                                (PopupshiipingCountry == 31) ?
                                                                                                                    <>
                                                                                                                        {UaeStates.map((s, sind) => {
                                                                                                                            return (
                                                                                                                                <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                            )
                                                                                                                        })}
                                                                                                                    </>
                                                                                                                    :
                                                                                                                    (PopupshiipingCountry == 32) ?
                                                                                                                        <>
                                                                                                                            {GermanyStates.map((s, sind) => {
                                                                                                                                return (
                                                                                                                                    <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                                )
                                                                                                                            })}
                                                                                                                        </>
                                                                                                                        :
                                                                                                                        (PopupshiipingCountry == 33) ?
                                                                                                                            <>

                                                                                                                            </>
                                                                                                                            :
                                                                                                                            <>
                                                                                                                            </>
                                                                                            }
                                                                                        </select>
                                                                                            
                                                                                        <label>State</label></>

                                                                                        :

                                                                                        <></>
                                                                                        }
                                                                                    </div>                                                                                                       

                                                                            
                                                                            </div>
                                                                        </div>
                                                                        

                                                                        <div className={styles.edit_contact}>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="Address" value={EditPopupshiipingAddress} onChange={(e) => setEditPopupshiipingAddress(e.target.value)} />
                                                                                    <label>Street Address</label>
                                                                                </div>
                                                                            </div>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    
                                                                                    <input type="text" required name="City" value={EditCustomPopupshiipingCity} onChange={(e) => setEditCustomPopupshiipingCity(e.target.value)} />
                                                                                    
                                                                                    <label>City</label>
                                                                                </div>
                                                                            </div>

                                                                        </div>
                                                                        <div className={styles.edit_contact}>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    
                                                                                    <input type="text" required name="pincode1" value={EditCustomPopupshiipingPincode} onChange={(e) => EditCustomPincode(e)} />
                                                                                    
                                                                                    <label>Pincode</label>
                                                                                </div>
                                                                            </div>
                                                                            <div className={styles.form_wrap_edit}>
                                                                                <div className={styles.input_wrap_edit}>
                                                                                    <input type="text" required name="PhoneNumber" value={EditPopupshiipingTelephone} onChange={(e) => setEditPopupshiipingTelephone(e.target.value)} />
                                                                                    <label>Phone Number</label>
                                                                                </div>
                                                                            </div>

                                                                        </div>
                                                                        <div className={styles.logaddpop}>
                                                                            <button type="submit" className={`${styles.register_submit}  ${styles.procartbtn} procartbtn`} onClick={(e) => EditCustomerShippingformation(e)}>Save</button>
                                                                        </div>
                                                                    </div>

                                                                </div>
                                                            )}
                                                        </Popup>

                                                    </div>
                                                </div>
                                            </div>
                                        </>
                                        :
                                        <>
                                            <div className={styles.reacipientcont}>
                                                <div classNamea={styles.recipent}>

                                                    <div className={styles.addnewuser}>
                                                        {/* <button>Add New</button> */}
                                                        <div className={styles.recipeinttoptext}>
                                                            <h3>Recipient Info</h3>
                                                        </div>

                                                        <button className={styles.button} onClick={()=>setShowShipAddPopUp(true)}>Add</button>
                                                       
                                                        
                                                    </div>

                                                </div>

                                                <div className={styles.recipientinfo}>
                                                    <div className={styles.recipientinfoinner}>
                                                        <p>No Shipping Address Set.Add Shipping address</p>
                                                    </div>
                                                </div>
                                            </div>
                                        </>

                                    }

                                    <Popup                                                                                     
                                        open={ShowShipAddPopUp}
                                        onClose={closeAddShipModal}
                                        modal
                                        nested>
                                        {close => (
                                            <div className={`${styles.modal} ${styles.modal_edit}`}>
                                                <button className={styles.close} onClick={close}>
                                                    &times;
                                                </button>
                                                <div className={styles.header}> <h4>Shipping Address</h4> </div>                                                
                                                    {(PopupshiipingFNameErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>First Name is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                    {(PopupshiipingLNameErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>Last Name is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                    {(CustomPopupshiipingStateErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>State is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                    {(PopupshiipingAddressErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>Shipping Address is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                    {(CustomPopupshiipingCityErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>City is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                    {(CustomPopupshiipingPincodeErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>Pincode is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                    {(PopupshiipingTelephoneErr) ?
                                                        <div className={styles.errdivpopup}>
                                                            <span>Phone Number is required</span>
                                                        </div>
                                                        :
                                                        ''
                                                    }
                                                

                                                {(AddNewShipAddSucces) ?
                                                    <div className={styles.successdivpopup}>                                                    
                                                        <span>Shipping address successfully saved</span>                                                        
                                                    </div>
                                                    :
                                                    ''
                                                }

                                                <div className={styles.content}>
                                                    {' '}
                                                    <div className={styles.edit_contact}>
                                                        <div className={styles.form_wrap_edit}>
                                                            <div className={styles.input_wrap_edit}>
                                                                <input type="text" required name="FirstName" value={PopupshiipingFName} onChange={(e) => getPopupshiipingFName(e)} />
                                                                <label>First Name</label>
                                                            </div>

                                                        </div>
                                                        <div className={styles.form_wrap_edit}>
                                                            <div className={styles.input_wrap_edit}>
                                                                <input type="text" required name="LastName" value={PopupshiipingLName} onChange={(e) => getPopupshiipingLName(e)} />
                                                                <label>Last Name</label>
                                                            </div>

                                                        </div>
                                                    </div>                                                    
                                                        <div className={styles.edit_contact}>

                                                            <div className={styles.form_wrap_edit}>
                                                                <div className={styles.input_wrap_edit}>
                                                                    {
                                                                        (PopupshiipingCountry == 2) ?
                                                                            <>
                                                                                <input type="text" required name="Country" value={'India'} />
                                                                            </>
                                                                            :
                                                                            (PopupshiipingCountry == 3) ?
                                                                                <>
                                                                                    <input type="text" required name="Country" value={'Australia'} />
                                                                                </>
                                                                                :
                                                                                (PopupshiipingCountry == 4) ?
                                                                                    <>
                                                                                        <input type="text" required name="Country" value={'USA'} />
                                                                                    </>
                                                                                    :
                                                                                    (PopupshiipingCountry == 5) ?
                                                                                        <>
                                                                                            <input type="text" required name="Country" value={'Canada'} />
                                                                                        </>
                                                                                        :
                                                                                        (PopupshiipingCountry == 30) ?
                                                                                            <>
                                                                                                <input type="text" required name="Country" value={'UK'} />
                                                                                            </>
                                                                                            :
                                                                                            (PopupshiipingCountry == 31) ?
                                                                                                <>
                                                                                                    <input type="text" required name="Country" value={'UAE'} />
                                                                                                </>
                                                                                                :
                                                                                                (PopupshiipingCountry == 32) ?
                                                                                                    <>
                                                                                                        <input type="text" required name="Country" value={'Germany'} />
                                                                                                    </>
                                                                                                    :
                                                                                                    (PopupshiipingCountry == 33) ?
                                                                                                        <>
                                                                                                            <input type="text" required name="Country" value={'Singapore'} />
                                                                                                        </>
                                                                                                        :
                                                                                                        <>
                                                                                                        </>
                                                                    }

                                                                    <label>Country</label>
                                                                </div>
                                                            </div>
                                                            

                                                                <div className={styles.form_wrap_edit}>
                                                                    {ShowStateNew ?
                                                                        <div className={`${styles.input_wrap_edit} ${styles.input_wrap_Selecti}`}>
                                                                            {(PopupshiipingState) ?
                                                                                <input type="text" required name="State" value={PopupshiipingState} />

                                                                                :
                                                                                <>
                                                                                    <select className={styles.selectshipadd} value={CustomPopupshiipingState} onChange={(e) => getCustomPopupshiipingState(e)} >
                                                                                        {(PopupshiipingCountry == 2) ?
                                                                                            <>
                                                                                                {IndiaStates.map((s, sind) => {
                                                                                                    return (
                                                                                                        <option value={s.value} key={sind} > {s.name}</option>
                                                                                                    )
                                                                                                })}
                                                                                            </>
                                                                                            :
                                                                                            (PopupshiipingCountry == 3) ?
                                                                                                <>
                                                                                                    {AustraliaStates.map((s, sind) => {
                                                                                                        return (
                                                                                                            <option value={s.value} key={sind} > {s.name}</option>
                                                                                                        )
                                                                                                    })}
                                                                                                </>
                                                                                                :
                                                                                                (PopupshiipingCountry == 4) ?
                                                                                                    <>
                                                                                                        {UsaStates.map((s, sind) => {
                                                                                                            return (
                                                                                                                <option value={s.value} key={sind} > {s.name}</option>
                                                                                                            )
                                                                                                        })}
                                                                                                    </>
                                                                                                    :
                                                                                                    (PopupshiipingCountry == 5) ?
                                                                                                        <>
                                                                                                            {CanadaStates.map((s, sind) => {
                                                                                                                return (
                                                                                                                    <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                )
                                                                                                            })}
                                                                                                        </>
                                                                                                        :
                                                                                                        (PopupshiipingCountry == 30) ?
                                                                                                            <>
                                                                                                                {UkStates.map((s, sind) => {
                                                                                                                    return (
                                                                                                                        <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                    )
                                                                                                                })}
                                                                                                            </>
                                                                                                            :
                                                                                                            (PopupshiipingCountry == 31) ?
                                                                                                                <>
                                                                                                                    {UaeStates.map((s, sind) => {
                                                                                                                        return (
                                                                                                                            <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                        )
                                                                                                                    })}
                                                                                                                </>
                                                                                                                :
                                                                                                                (PopupshiipingCountry == 32) ?
                                                                                                                    <>
                                                                                                                        {GermanyStates.map((s, sind) => {
                                                                                                                            return (
                                                                                                                                <option value={s.value} key={sind} > {s.name}</option>
                                                                                                                            )
                                                                                                                        })}
                                                                                                                    </>
                                                                                                                    :
                                                                                                                    (PopupshiipingCountry == 33) ?
                                                                                                                        <>

                                                                                                                        </>
                                                                                                                        :
                                                                                                                        <>
                                                                                                                        </>
                                                                                        }
                                                                                    </select>
                                                                                </>

                                                                            }

                                                                            <label>State</label>
                                                                        </div>
                                                                    
                                                                        :

                                                                        <></>
                                                                    }
                                                                </div>

                                                        </div>
                                                    

                                                    <div className={styles.edit_contact}>
                                                        <div className={styles.form_wrap_edit}>
                                                            <div className={styles.input_wrap_edit}>
                                                                <input type="text" required name="Address" value={PopupshiipingAddress} onChange={(e) => getPopupshiipingAddress(e)} />
                                                                <label>Street Address</label>

                                                            </div>
                                                        </div>
                                                        <div className={styles.form_wrap_edit}>
                                                            <div className={styles.input_wrap_edit}>
                                                                {(PopupshiipingCity) ?
                                                                    <>
                                                                        <input type="text" required name="City" value={PopupshiipingCity} />
                                                                    </>
                                                                    :
                                                                    <>
                                                                        <input type="text" required name="City" value={CustomPopupshiipingCity} onChange={(e) => getCustomPopupshiipingCity(e)} />
                                                                    </>
                                                                }
                                                                <label>City</label>
                                                            </div>
                                                        </div>

                                                    </div>
                                                    <div className={styles.edit_contact}>
                                                        <div className={styles.form_wrap_edit}>
                                                            <div className={styles.input_wrap_edit}>
                                                                {(PopupshiipingPincode) ?
                                                                    <input type="text" required name="pincode2" value={PopupshiipingPincode} />
                                                                    :
                                                                    <input type="text" required name="pincode1" value={CustomPopupshiipingPincode} onChange={(e) => getCustomPopupshiipingPincode(e)} />
                                                                }

                                                                <label>Pincode</label>
                                                            </div>
                                                        </div>
                                                        <div className={styles.form_wrap_edit}>
                                                            <div className={styles.input_wrap_edit}>
                                                                <input type="text" required name="PhoneNumber" value={PopupshiipingTelephone} onChange={(e) => getPopupshiipingTelephone(e)} />
                                                                <label>Phone Number</label>
                                                            </div>

                                                        </div>

                                                    </div>
                                                    <div className={styles.checksavepop}>
                                                        <button type="submit" className={`${styles.register_submit}  ${styles.procartbtn} procartbtn`} onClick={(e) => saveCustomerShippingformation(e)}>Save</button>
                                                    </div>
                                                </div>

                                            </div>
                                        )}
                                    </Popup>                                                       

                                </>

                                :
                                <>
                                    {isLoading && (
                                        <span className={`${styles.ew_loader_loginchk} align-items-center justify-content-center d-flex w-100 `}>
                                            <img
                                                src='/loading.gif' className={styles.loader} alt="loader"
                                            />
                                        </span>
                                    )}
                                </>
                            }
                        </Grid>
                        <Grid item md={4} sm={12} xs={12}>

                            <div className={styles.messagesomeone}>
                                <div className={styles.infoheading}>
                                    <h2>Order</h2>
                                </div>
                                <div className={`${styles.msgsmsec} ${styles.inputfloat}`}>

                                    <textarea className={styles.vcart_input} name="customer_comment" cols="55" rows="5" maxLength="100" onChange={(e) => setGiftMessage(e.target.value.replace(/[^0-9a-z!.,\r\n ]/gi, ''))} value={GiftMessage} placeholder="none" required />
                                    <label className={styles.form_label}>
                                        Gift Message
                                    </label>

                                </div>
                                <div className={`${styles.msgsmsec} ${styles.msgspecial} ${styles.inputfloat}`}>

                                    <textarea name="customer_comment" className={`${styles.spaceilinst} ${styles.vcart_input}`} cols="55" rows="5" maxLength="100" onChange={(e) => setSpInstruction(e.target.value.replace(/[^0-9a-z!.,\r\n ]/gi, ''))} value={SpInstruction} placeholder="none" required />
                                    <label className={styles.form_label}>
                                        Special Instructions
                                    </label>
                                </div>

                            </div>

                            <div className={styles.paymentmethod_sec}>
                                <div className={styles.infoheading}>
                                    <h2>Payment Method</h2>
                                </div>
                                <div className={styles.paymentwrap}>
                                    <div className={styles.payementinner}>
										
                                        <div className={`${styles.payment_cards} ${styles.paymentmthd}`}>
                                            <input type="radio" name='payment' className={`${styles.card_option} ${styles.cardacc}`} value="1" onChange={(e) => SelectPaymentGateway(e)} checked={OrderPaymentGateway === "1"} />
                                            <img src='/credit-card-methods.webp' />
                                        </div>
										{(DisplayPayPalButton) ? 
												<>
													<div className={`${styles.payment_cards} ${styles.paymentmthd}`}>
														<input type="radio" name='payment' className={`${styles.card_option} ${styles.cardacc}`} value="2" onChange={(e) => SelectPaymentGateway(e)} checked={OrderPaymentGateway === "2"} />
														<img src='/paypal.webp' />
													</div>
													</>
												:
												<>
													<div className={`${styles.payment_cards} ${styles.paymentmthd}`}>
														<input type="radio" name='payment' className={`${styles.card_option} ${styles.cardacc}`} value="3" onChange={(e) => SelectPaymentGateway(e)} checked={OrderPaymentGateway === "3"} />
														<img src='/cvenue1.png' />
													</div>
												</>
											}
                                        {/*
                                        <div className={`${styles.payment_debitopt} ${styles.paymentmthd}`}>
                                            <input type="radio" name='payment' className={`${styles.debit_option} ${styles.cardacc} `} value="2" onChange={(e) => SelectPaymentGateway(e)} />
                                            <p>Debit / Credit Card / NetBanking / Wallet Payment Method</p>
                                        </div>
										*/}
                                    </div>

                                </div>
                                
                                {OrderPaymentGateway === '1' || OrderPaymentGateway === '3' ?
                                    <>
                                        <div className={styles.plceorder_vcartbtn}>

                                            <Button className={styles.plceorder_vcart} onClick={(e) => placeorder(e)}>
                                                Place Order
                                            </Button>
                                        </div>
                                    </>
                                :
                                    ''
                                }
								{OrderPaymentGateway === '2' ?
                                    <>
									{PaypalScriptLoaded ? null : 'Loading..' }
											<PayPalButton
												options={{clientId: process.env.NEXT_PUBLIC_PAYPAL_CLIENTID}}
												onError = {(err) => displaypaypalerr(err)}
												onClick = {async ()=>{
													 if(!await validatCheckoutForm()){
														 return false;
													 }else{
														return true;
													}
													 
												 }}
												createOrder={async (data, actions) => await createOrder(data, actions)}
												onApprove={async (data, actions) => await savePaypalsuccess(data, actions)}  //logs saved
												catchError = {(err) => savepaypalpaymentfailed(err)}
												onCancel={(data) => saveCancelPaypalstatus(data)} //logs saved
												style={PaypalStyle}
												onButtonReady={() => loadpaypalbutton()}
											/>
										</>
									:
									null
                                }
										{/*
                                        {PaypalScriptLoaded ? (
                                            <>  
                                                {(ShippingAddressCheck) ? 
                                                    <>
                                                        {CartSubTotal > 0 ?
                                                            <>
                                                                <div className={styles.paypalmargintop} >
                                                                    <PayPalButton
                                                                        options={{ clientId: process.env.NEXT_PUBLIC_PAYPAL_CLIENTID }}
                                                                        onError={(err) => displaypaypalerr(err)}
                                                                        onClick={async () => {
                                                                            if (!await validatCheckoutForm()) {
                                                                                return false;
                                                                            } else {
                                                                                return true;
                                                                            }

                                                                        }}
                                                                        createOrder={async (data, actions) => await createOrder(data, actions)}
                                                                        onApprove={async (data, actions) => await savePaypalsuccess(data, actions)}  //logs saved
                                                                        catchError={(err) => savepaypalpaymentfailed(err)}
                                                                        onCancel={(data) => saveCancelPaypalstatus(data)} //logs saved
                                                                        style={PaypalStyle}
                                                                        onButtonReady={() => loadpaypalbutton()}
                                                                    />
                                                                </div>
                                                            </>
                                                            :
                                                            <>
                                                                <div className={styles.paycustombtn}>
                                                                    <button onClick={(e) => placeorder(e)}>PayPal</button>
                                                                </div>                                                    
                                                            </>   
                                                        }                                                        
                                                    </>
                                                :
                                                    <>
                                                        <div className={styles.paycustombtn}>
                                                            <button onClick={(e) => placeorder(e)}>PayPal</button>
                                                        </div>                                                    
                                                    </>           
                                                }

                                            </>
                                        ) : (
                                            <span>Loading...</span>
                                        )}{" "}
										}
                                    </>
									
									}
                                :
                                    ''
                                }
                               */}

                            </div>

                        </Grid>
                        <Grid item md={4} sm={12} xs={12}>

                            <div className={styles.view_cart_sec}>
                                <div className={styles.viewcartwrap}>
                                    <div className={styles.top_box_check}>
                                        <div className={`${styles.top_box_head} ${styles.Top_header} Top_header`}>
                                            {/* <span><ShoppingCart /></span> */}
                                            <div className={styles.heading_vcart}>
                                                <h2>Order Summary</h2>

                                            </div>
                                        </div>
                                        <div className={styles.visualbox}>
                                            {CartItemsList && CartItemsList.map((item, indx) => {

                                                var daysInMonth = item.del_date.split("-");
                                                var productDelDate = daysInMonth[2] + '-' + daysInMonth[1] + '-' + daysInMonth[0];

                                                return (
                                                    <div className={styles.visualboxinner} key={indx}>
                                                        <h2>{item.name}</h2>
                                                        <div className={styles.cartrhttl}>
                                                            <div className={styles.cartitemname}>

                                                                {item.is_addon === '0' ?
                                                                    <span>
                                                                        <p>Delivery Date: {productDelDate}</p>
                                                                    </span>
                                                                    :
                                                                    <></>
                                                                }
                                                            </div>
                                                            <div className={styles.qtycrt}>
                                                                x {item.quantity}
                                                            </div>
                                                            <div className={styles.cartprice}>
                                                                {SelectedCurrencydata.CurrencySymbol} <span>{item.subtotal}</span>
                                                            </div>
                                                        </div>
                                                    </div>
                                                )
                                            })}
                                        </div>
                                    </div>


                                    <div className={styles.subtotal_vcart}>
                                        <div className={styles.billingdetailtitle}>
                                            <h2>billing details :-</h2>
                                        </div>
                                        <div className={`${styles.subtotalchkout} ${styles.chkoutsame}`}>
                                            <h3>Subtotal:</h3>
                                            <p>{SelectedCurrencydata.CurrencySymbol}<span> {CartSubTotal}</span></p>
                                        </div>
                                        <div className={`${styles.subtotalchkout} ${styles.chkoutsame}`}>
                                            <h3>Applied Coupon:</h3>
                                            <p>{SelectedCurrencydata.CurrencySymbol}<span> {CouponDiscount}</span></p>
                                        </div>

                                        {SelectedCurrencydata && (
                                            <div className={`${styles.subtotalchkout} ${styles.chkoutsame}`}>
                                                <h3>Delivery Charges:</h3>
                                                <p>{SelectedCurrencydata.CurrencySymbol}<span> {OrderDeliveryCharges}</span></p>
                                            </div>
                                        )}

                                        {GiftWrapperChargesTotal > 0 &&
                                            <>
                                                {SelectedCurrencydata && (
                                                    <div className={`${styles.subtotalchkout} ${styles.chkoutsame}`}>
                                                        <h3>Gift Wrapping Charges:</h3>
                                                        <p>{SelectedCurrencydata.CurrencySymbol}<span> {GiftWrapperChargesTotal}</span></p>
                                                    </div>

                                                )}
                                            </>
                                        }


                                        <div className={`${styles.grandtotalchkout} ${styles.chkoutsame}`}>
                                            <h3>Grand total:</h3>
                                            <p>{SelectedCurrencydata.CurrencySymbol} <span>{CartGrandTotal}</span></p>
                                        </div>
                                    </div>


                                </div>
                            </div>

                            <div className={styles.secureimg}>
                                <div className={styles.sceureinnerimg}>
                                    <img src="https://1800rakhis.com/secureimg.jpg" />
                                </div>
                            </div>

                        </Grid>
                    </Grid>

                </>
            }
        </>
    )

}