import { SessionProvider } from "next-auth/react";
import { Provider } from "react-redux";
import { createWrapper } from 'next-redux-wrapper';
import { createStore } from "redux";
import '../styles/style.css'
import '../styles/newstyles.css'
import { wrapper, store } from "../redux/store";
import { ThemeProvider } from 'styled-components'
import rootReducer from '../redux/reducers/rootReducer'
import {SocketContext, socket} from '../context/socket';
const theme = {
  primary: 'green',
}

const makeStore = () => {
  return createStore(rootReducer, {});
};


function MyApp({ Component,  pageProps: { session, ...pageProps } }) {
   return (
    <SocketContext.Provider value={socket}>
		<Provider store={store}>
		  <SessionProvider session={session}>
			<ThemeProvider theme={theme}>
				<Component {...pageProps} />
			</ThemeProvider>
		  </SessionProvider>
		</Provider>
	</SocketContext.Provider>
    
  )
}

export default wrapper.withRedux(MyApp);