import * as React from 'react';
import Document, { Html, Head, Main, NextScript } from 'next/document';
import { ServerStyleSheet as StyledComponentSheets } from 'styled-components'
import { ServerStyleSheets as MaterialUiServerStyleSheets } from '@material-ui/core/styles'
import config from '../config/config';

export default class MyDocument extends Document {
  render() {
    return (
      <Html lang="en">
        <Head>
        <script async src="https://www.googletagmanager.com/gtag/js?id=G-JPKGM4TRHT"></script>

        <script
			dangerouslySetInnerHTML={{
			__html: `window.dataLayer = window.dataLayer || []; function gtag() { dataLayer.push(arguments); } gtag('js', new Date()); gtag('config', 'G-JPKGM4TRHT')`,
			}}
		/>
		{/* <script
			dangerouslySetInnerHTML={{
			__html: `(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
})(window,document,'script','dataLayer','GTM-K8QBJZD')`,
			}}
		/> */}
  
          <link rel="shortcut icon" href="/static/favicon.ico" />
          <link rel="stylesheet"  href={config.themesettingsUrl} />
          <link rel="preload" as="style"  href={config.EditorstyleUrl} />
          {this.props.emotionStyleTags}
        </Head>
        <body>
		<script>0</script>
		{/* <noscript
			strategy="lazyOnload"
			dangerouslySetInnerHTML={{
				__html: `<iframe src="<iframe src="https://www.googletagmanager.com/ns.html?id=GTM-K8QBJZD" height="0" width="0" style="display:none;visibility:hidden"></iframe>`
			}}
		/> */}
		
          <Main />
          <NextScript />
		  <script
			dangerouslySetInnerHTML={{
			__html: `!function(){function e(e){var t=document.createElement("script");t.setAttribute("id","ze-snippet"),t.src="https://static.zdassets.com/ekr/snippet.js?key=db1cc401-aeec-468e-8040-d74f9e259f16",document.getElementsByTagName("body")[0].appendChild(t),window.zdonload=setInterval((function(){"undefined"!=typeof zE&&void 0!==zE.activate&&(clearInterval(window.zdonload),e())}),50,null)}window.loadAndOpenZendeskChat=function(){var t=document.getElementById("zdbutton");localStorage.setItem("ff_zd_hasOpened",!0),t.innerHTML="Loading...",e((function(){window.setTimeout((function(){zE.activate(),t.parentNode.removeChild(t)}),1e3)}))},localStorage.getItem("ff_zd_hasOpened")?e((function(){})):document.getElementsByTagName("body")[0].insertAdjacentHTML("beforeend",'<button id="zdbutton" class = "zendeskbtn" aria-label="Launch Help Chat Window" onClick="window.loadAndOpenZendeskChat();">Help</button>')}();`,
			}}
		/>
		
		
		</body>
      </Html>
    );
  }
}

MyDocument.getInitialProps = async (ctx) => {
 const styledComponentSheet = new StyledComponentSheets()
    const materialUiSheets = new MaterialUiServerStyleSheets()
    const originalRenderPage = ctx.renderPage
    try {
      ctx.renderPage = () =>
        originalRenderPage({
          enhanceApp: App => props =>
            styledComponentSheet.collectStyles(
              materialUiSheets.collect(<App {...props} />),
            ),
        })
      const initialProps = await Document.getInitialProps(ctx)
      return {
        ...initialProps,
        styles: [
          <React.Fragment key="styles">
            {initialProps.styles}
            {materialUiSheets.getStyleElement()}
            {styledComponentSheet.getStyleElement()}
          </React.Fragment>,
        ],
      }
    } finally {
      styledComponentSheet.seal()
    }
};

