import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';
import {getGeoByIp} from 'geoplugin';
var CryptoJS = require("crypto-js");

export default async function handler(req, res) {
	var EnOrderId = req.query.orderid
	var orderitems = [];
	var results = [];
	var countrylist = [];
	var coupondetails = [];
	var ordersdeldata = [];
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD   
		}
	})
	
	if(EnOrderId){
		
		try{
			var decoded = CryptoJS.enc.Hex.parse(EnOrderId).toString(CryptoJS.enc.Base64);
			var bytes  = CryptoJS.AES.decrypt(decoded, "Eways123");
			var decryptedData = JSON.parse(bytes.toString(CryptoJS.enc.Utf8));
			// console.log('decryptedId',decryptedData)
			var orderid  = decryptedData
			
			// console.log('orderid',orderid)
			
			let countrylist = await db.query(`SELECT CountryId,CountryName,CurrencyRate,CurrencySymbol,CountryCode,CurrencyCode,CurrencyName,CurrencyCode as name FROM delivery_coutries_master where Status = 1 and showinNavbar = 1 order By CountryId asc`) ;
			
			var sql = "select orders.*,CountryId,CountryName,CurrencyRate,CurrencySymbol,CountryCode,CurrencyCode,CurrencyName,CurrencyCode from orders left join delivery_coutries_master on orders.OrderCurrentCurrCode = delivery_coutries_master.CurrencyCode where OrderId = "+orderid
			results  = await db.query(sql)
			if(results.length > 0){
				var currencyRate =  results[0].CurrencyRate
				var orderitemssql = "SELECT * FROM (SELECT order_items.*,CONCAT(YEAR(order_items.ProductDeliveryDate),'-',LPAD(MONTH(order_items.ProductDeliveryDate),2,0),'-' ,LPAD(DAY(order_items.ProductDeliveryDate),2,0))  as pd,DATE(order_items.ProductDeliveryDate) as deliverydate, CONCAT('"+config.productPageproductImageurl+"',cm.ProductSmallImage) AS ProductImage, products.ProductPrice AS ProductPrice, products.ProductSalePrice AS ProductSalePrice, products.ProductVendorPrice AS ProductVendorPrice, ROUND("+currencyRate+" * ProductSalePrice) AS displaySalePrice, ROUND("+currencyRate+" * ProductVendorPrice) AS displayvendorPrice, ROUND("+currencyRate+" * ProductPrice) AS displayPrice,product_variations.VariationPrice AS VariationPriceINR,product_variations.VariationSalePrice AS VariationSalePricePriceINR,product_variations.VariationId,product_variations.VariationSku,'' as AddonProductId,'' as AddonProductSku,cps.CurrentDayCharges as cdc ,cps.NextDayCharges as ndc,cps.SaturdayDisable as satdisable,cps.SaturdayCharges as satcharges,cps.MondayDisable as mondisable,cps.MondayCharges as moncharges,cps.SundayDisable as sundisable,cps.SundayCharges as suncharges,cps.SettingEnable as SettingsEnable, cgs.SettingValue as GlobalSetting,cgs.StoreName as GlobalStore,cgs.extraCharge as Globalextracharge FROM order_items LEFT JOIN products ON  products.ProductSku = order_items.OrderItemProductSku LEFT JOIN product_media cm ON cm.ProductNo =  products.ProductId  LEFT JOIN product_variations  ON product_variations.VariationSku =  order_items.ItemVariationNo left join calender_product_setting as cps on cps.ProductSku  = products.ProductSku left join calender_global_settings as cgs on DATE(cgs.SettingDate) = DATE(order_items.ProductDeliveryDate) WHERE  ProductMediaNo = 1 AND OrderNo  = "+orderid+" UNION ALL SELECT order_items.*,CONCAT(YEAR(order_items.ProductDeliveryDate),'-',LPAD(MONTH(order_items.ProductDeliveryDate),2,0),'-' ,LPAD(DAY(order_items.ProductDeliveryDate),2,0)) as pd,DATE(order_items.ProductDeliveryDate) as deliverydate,CONCAT('"+config.Addonsproductimageurl+"',addon_products.AddonImage) AS ProductImage,addon_products.AddonPriceINR AS ProductPrice,0 AS ProductSalePrice,0 AS ProductVendorPrice,0 AS displaySalePrice,0 AS displayvendorPrice, ROUND("+currencyRate+" * addon_products.AddonPriceINR) AS displayPrice, 0 AS VariationPriceINR, 0 AS  VariationSalePricePriceINR,'' as VariationId,'' as VariationSku,AddonProductId,AddonProductSku,0 as cdc, 0 as ndc,0 as satdisable,0 as satcharges,0 as mondisable,0 as moncharges,0 as sundisable,0 as suncharges,0 as SettingsEnable,'' as GlobalSetting,'' as GlobalStore,0 as Globalextracharge  FROM order_items LEFT JOIN addon_products ON  order_items.OrderItemProductSku = addon_products.AddonProductSku WHERE  OrderNo  = "+orderid+"  ) AS xx WHERE ProductImage IS NOT NULL and DATE(xx.deliverydate) >= DATE(NOW()) ORDER BY xx.OrderItemId ASC"
				
				
				orderitems  = await db.query(orderitemssql)
				
				var couponsql = "SELECT * FROM `coupons` WHERE CouponId = 27"
				coupondetails  = await db.query(couponsql)
				
				var ordersdeldatasql = "SELECT CustomerOrderShippingPincode,CustomerOrderShippingCity,CustomerOrderShippingState,CustomerOrderShippingCountryNo,ProductpagePincodeStateCitySearch FROM orders_addres_book LEFT JOIN delivery_coutries_master ON CountryId =  CustomerOrderShippingCountryNo WHERE OrderNo = "+orderid
				ordersdeldata =  await db.query(ordersdeldatasql)
				
				res.status(200).json({'oderdetail':results,'orderitems':orderitems,'all_currency':countrylist,'coupondata':coupondetails,'ordersdeldata':ordersdeldata})			
			}else{
				res.status(200).json({'oderdetail':results,'orderitems':orderitems,'all_currency':countrylist,'coupondata':coupondetails,'ordersdeldata':ordersdeldata})
			}
			await db.end()
		
			
			}catch(e){
				res.status(200).json({'oderdetail':e})
			}
		
		}else{
		res.status(200).json({'oderdetail':results,'orderitems':orderitems,'all_currency':countrylist,'coupondata':coupondetails})
	}
	
}