import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';
const hbs = require('nodemailer-express-handlebars')
const nodemailer = require('nodemailer')
const path = require('path')
var CryptoJS = require("crypto-js");

export default async function handler(req, res) {
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD   
		}
	})
	
	// var getabondoncartorderssql = "SELECT orders.*,CustomerOrderBillingEmail,CustomerOrderBillingFirstName,CustomerOrderBillingLastName FROM orders left join orders_addres_book as oab on oab.OrderNo = orders.OrderId WHERE OrderCurrentStatus IN (1,2,11,15) AND CustomerNo NOT IN (SELECT CustomerNo FROM orders WHERE OrderCurrentStatus IN (3,4,5,12) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) ) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) and (AbondonCartEmailCount is NULL or AbondonCartEmailCount < 1 or AbondonCartEmailCount = '') union all SELECT orders.*,CustomerOrderBillingEmail,CustomerOrderBillingFirstName,CustomerOrderBillingLastName FROM orders left join orders_addres_book as oab on oab.OrderNo = orders.OrderId WHERE OrderCurrentStatus IN (1,2,11,15) AND CustomerNo NOT IN (SELECT CustomerNo FROM orders WHERE OrderCurrentStatus IN (3,4,5,12) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) ) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) AND (AbondonCartEmailTime is not NULL and HOUR(TIMEDIFF(NOW(), AbondonCartEmailTime)) > 12 ) and AbondonCartEmailCount = 1"
	
	
	var getabondoncartorderssql = "SELECT orders.*,CustomerOrderBillingEmail,CustomerOrderBillingFirstName,CustomerOrderBillingLastName,(HOUR(TIMEDIFF(NOW(), AbondonCartEmailTime))) AS td,delivery_coutries_master.CurrencyRate AS dCurrencyRate FROM orders LEFT JOIN orders_addres_book AS oab ON oab.OrderNo = orders.OrderId LEFT JOIN delivery_coutries_master on delivery_coutries_master.CurrencyCode = orders.OrderCurrentCurrCode  WHERE OrderCurrentStatus IN (1,2,11,15) AND CustomerNo NOT IN (SELECT CustomerNo FROM orders WHERE OrderCurrentStatus IN (3,4,5,12) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) ) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) AND (AbondonCartEmailCount IS NULL OR AbondonCartEmailCount < 1 OR AbondonCartEmailCount = '') AND orders.orderid IN ( SELECT MAX(orderid) AS orderid FROM orders WHERE DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) AND OrderCurrentStatus IN (1,2,11,15) GROUP BY CustomerNo   ) UNION ALL SELECT orders.*,CustomerOrderBillingEmail,CustomerOrderBillingFirstName,CustomerOrderBillingLastName,(HOUR(TIMEDIFF(NOW(), AbondonCartEmailTime))) AS td,delivery_coutries_master.CurrencyRate AS dCurrencyRate FROM orders LEFT JOIN orders_addres_book AS oab ON oab.OrderNo = orders.OrderId LEFT JOIN delivery_coutries_master on delivery_coutries_master.CurrencyCode = orders.OrderCurrentCurrCode WHERE OrderCurrentStatus IN (1,2,11,15) AND CustomerNo NOT IN ( SELECT CustomerNo FROM orders WHERE OrderCurrentStatus IN (3,4,5,12) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) ) AND DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) AND (AbondonCartEmailTime IS NOT NULL AND HOUR(TIMEDIFF(NOW(), AbondonCartEmailTime)) > 12 ) AND AbondonCartEmailCount < 2 AND orders.orderid IN ( SELECT MAX(orderid) AS orderid FROM orders WHERE DATE(OrderDate) >=  DATE(NOW() - INTERVAL 1 DAY) AND OrderCurrentStatus IN (1,2,11,15) GROUP BY CustomerNo   ) "
	
	var abondoncartorders  = await db.query(getabondoncartorderssql)
	
	if(abondoncartorders.length > 0){
		
		
		for (let i = 0; i < abondoncartorders.length; i++) {
			
			var OrderCurrencyRate = abondoncartorders[i].dCurrencyRate
			var OrderCurrencySymbol = abondoncartorders[i].OrderCurrentCurrSymbol
			
			var getcoupondata = "SELECT ROUND("+OrderCurrencyRate+" * CouponAmount) as CouponValue,CouponName FROM `coupons` WHERE CouponId = 27";
			var coupondata  = await db.query(getcoupondata)
			var coupandiscount = coupondata[0].CouponValue
			var coupanname = coupondata[0].CouponName
			
			var encryptedId  = await CryptoJS.AES.encrypt(abondoncartorders[i].OrderId.toString(), "Eways123").toString();
			var encoded = CryptoJS.enc.Base64.parse(encryptedId).toString(CryptoJS.enc.Hex);
			
			// var AbondoncartLink = config.WebSiteBaseURL+'abondoncart?orderid='+encryptedId
			var AbondoncartLink = config.WebSiteBaseURL+'abondoncart?orderid='+encoded
		
			console.log('encryptedId',encryptedId)
		
			var abondoncartordersitemssql ="select * from ( SELECT order_items.*,(order_items.ProductUnitrPrice * order_items.OrderItemQty) as itemqtyTotal,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,  CONCAT('"+config.callBackUrl+"adminapi/uploads/products', '/',product_media.ProductSmallImage) as image,orders.OrderCurrentCurrSymbol FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join product_media on product_media.ProductNo = order_items.ProductNo LEFT JOIN orders ON orders.OrderId=order_items.OrderNo where order_items.OrderNo = '"+abondoncartorders[i].OrderId+"' and ProductMediaNo = 1 and OrderItemIsAddon = 0 union all SELECT order_items.*,(order_items.ProductUnitrPrice * order_items.OrderItemQty) as itemqtyTotal,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,CONCAT('"+config.callBackUrl+"adminapi/uploads/addons', '/',ap.AddonImage) as image,orders.OrderCurrentCurrSymbol FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join addon_products ap on ap.AddonProductSku = order_items.orderitemproductsku LEFT JOIN orders ON orders.OrderId=order_items.OrderNo where order_items.OrderNo ='"+abondoncartorders[i].OrderId+"' and OrderItemIsAddon = 1 ) as x where x.image is not null and DATE(x.ProductDeliveryDate) >= DATE(NOW())";
			
			
			var abondoncartordersitems  = await db.query(abondoncartordersitemssql)
			if(abondoncartordersitems.length > 0){
				var OrderNo = abondoncartorders[i].OrderNo;
				var emailsubject = `A special FLAT ${OrderCurrencySymbol} ${coupandiscount}  Discount to finish your order.`
				var templatename = 'abondoncart'
				var toEmail = abondoncartorders[i].CustomerOrderBillingEmail;
				var customerName = abondoncartorders[i].CustomerOrderBillingFirstName+' '+abondoncartorders[i].CustomerOrderBillingLastName;
				var transporter = nodemailer.createTransport(
					{
						port: process.env.SmtpPort,
						secure: true,
						host: process.env.SmtpHost,
						auth:{
							user: process.env.SmtpUser,
							pass: process.env.SmtpPassword
						},
						from: process.env.SmtpUser
					}
				);
				const handlebarOptions = {
					viewEngine: {
						partialsDir: path.resolve('./emailslayout/'),
						defaultLayout: false,
					},
						viewPath: path.resolve('./emailslayout/'),
				};
				
				
				
				transporter.use('compile', hbs(handlebarOptions));
				var mailOptions = {
					from: process.env.SmtpUser,
					to: toEmail,
					subject: emailsubject,
					template: templatename,
					context:{
						track_order: '',
						img_url: '',
						product_img_url: '',
						orderData: abondoncartorders[i],
						abondoncartlink: AbondoncartLink,
						orderItemData: abondoncartordersitems,
						coupandiscount: coupandiscount,
						OrderCurrencySymbol: OrderCurrencySymbol,
						coupanname: coupanname,
						name: customerName,
						company: 'My Company'
					},
				}
				transporter.sendMail(mailOptions, async function(error, info){
					if(error){
						var sql = "UPDATE orders SET AbondonCartEmalSent = 0, AbondonCartEmailTime = NOW(), AbondonCartEmailCount =  AbondonCartEmailCount + 1  WHERE OrderId ="+abondoncartorders[i].OrderId
						await db.query(sql)
					}else{
						var sql = "UPDATE orders SET AbondonCartEmalSent = 1, AbondonCartEmailTime = NOW(), AbondonCartEmailCount =  AbondonCartEmailCount + 1  WHERE OrderId ="+abondoncartorders[i].OrderId
						await db.query(sql)
					}
				})
			}
		}
	}
	await db.end()
	res.status(200).json({'abondoncartorders':abondoncartorders})
}