import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../../config/config'



export default async function handler(req, res) {
	
	var CustomerBillingName  		= req.body.CustomerBillingName
	var CustomerBillinglastName 	= req.body.CustomerBillinglastName
	var CustomerBillingEmail 		= req.body.CustomerBillingEmail
	var CustomerBillingPhone 		= req.body.CustomerBillingPhone
	var CustomerBillingId 			= req.body.CustomerBillingId
	var CustomerNo 					= req.body.CustomerNo
	
	
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD  
		}
	})
	
	try {
		if(CustomerBillingId){
			var sql = `UPDATE customers_billing_address SET CustomerBillingFirstName = ?,CustomerBillingLastName = ? , CustomerBillingEmail= ?, CustomerBillingPhone = ? WHERE CustomerBillingAdressId = ?`

			var arr = [CustomerBillingName,CustomerBillinglastName,CustomerBillingEmail,CustomerBillingPhone, CustomerBillingId];

			var sqldata = [];
			sqldata.push(arr)


		}else{
			var sql =  "INSERT INTO customers_billing_address (CustomerNo,CustomerBillingFirstName,CustomerBillingLastName,CustomerBillingEmail, CustomerBillingPhone) VALUES (?,?,?,?,?) ON DUPLICATE KEY UPDATE CustomerBillingFirstName = ?, CustomerBillingLastName = ?, CustomerBillingEmail = ?, CustomerBillingPhone = ?"

			var arr = [CustomerNo,CustomerBillingName,CustomerBillinglastName,CustomerBillingEmail,CustomerBillingPhone, CustomerBillingName,CustomerBillinglastName,CustomerBillingEmail,CustomerBillingPhone];

			var sqldata = [];
			sqldata.push(arr)
		}
		
		let results = await db.query(sql,[sqldata])
		await db.end()	
		res.status(200).send({ 'CODE':200 ,'msg': 'Customer updated'})
		
	}
	catch (err) {
		res.status(200).send({ 'CODE':500 ,'msg': 'failed to fetch data',err,sql })
	}
  
	
	

}