import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../../config/config'

export default async function handler(req, res) {
	var queryData = req.body;

	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD  
		}	
	})

	var CustomerShippingName  		= queryData.CustomerShippingName;
	var CustomerShippingLastname 	= queryData.CustomerShippingLastname;
	var CustomerShippingAddress 	= queryData.CustomerShippingAddress;
	var CustomerShippingCity 		= queryData.CustomerShippingCity;
	var CustomerShippingState 		= queryData.CustomerShippingState
	var CustomerShippingPincode 	= queryData.CustomerShippingPincode
	var CustomerShippingPhone 		= queryData.CustomerShippingPhone
	var CustomerShippingCountry 	= queryData.CustomerShippingCountry
	var ShippingEditId 			    = queryData.ShippingEditId
	var CustomerNo 			        = queryData.CustomerNo	
	var AllCountry 			        = queryData.AllCountry	
	
	
	try {		
		if(ShippingEditId){			
			

			var sql = "UPDATE customer_shipping_book SET CustomerShippingFirstName = ?, CustomerShippingLastName=?,CustomerShippingCountryNo=?,CustomerShippingState=?,CustomerShippingCity=?,CustomerShippingAddress=?,CustomerShippingPincode=?,CustomerShippingPhone=? WHERE CustomerAddressBookId=?";

			var arr = [CustomerShippingName,CustomerShippingLastname,CustomerShippingCountry,CustomerShippingState, CustomerShippingCity,CustomerShippingAddress,CustomerShippingPincode,CustomerShippingPhone,ShippingEditId];

	

			var sqldata = [];
			sqldata.push(arr)


			
			var iseeror = false;
			let results = await db.query(sql,arr)


		}else{			
			

			var sql = "INSERT INTO customer_shipping_book(CustomerNo,CustomerShippingFirstName, CustomerShippingLastName,CustomerShippingCountryNo,CustomerShippingState,CustomerShippingCity, CustomerShippingAddress,CustomerShippingPincode,CustomerShippingPhone) VALUES ?";

			var custShipAddData = [CustomerNo,CustomerShippingName,CustomerShippingLastname,CustomerShippingCountry,CustomerShippingState,CustomerShippingCity,CustomerShippingAddress,CustomerShippingPincode,CustomerShippingPhone];

			var newsharrdta = []
			newsharrdta.push(custShipAddData)


			let results = await db.query(sql,[newsharrdta])
		}				

		if(CustomerShippingCountry && AllCountry){
			var shippingAddresssql = `SELECT * FROM customer_shipping_book left join delivery_coutries_master  on CountryId = CustomerShippingCountryNo where CustomerNo = '${CustomerNo}'`
		}else{
			var shippingAddresssql = `SELECT * FROM customer_shipping_book left join delivery_coutries_master  on CountryId = CustomerShippingCountryNo where CustomerNo = '${CustomerNo}' and CustomerShippingCountryNo = '${CustomerShippingCountry}'`
		}
		
		let shippingAddress = await db.query(shippingAddresssql)
		await db.end()	
		
		res.status(200).send({ 'CODE':200 ,'msg': 'Customer updated',shippingAddress })
		
	}
	catch (err) {
		res.status(200).send({ 'CODE':500 ,'msg': 'failed to fetch data',err,sql })
	}
}