import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';
export default async function handler(req, res) {
	// const { pid } = req.query
	var currencyRate = req.query.currencyRate
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD   
		}
	})
	var id = req.query.id
	var price = req.query.price
	var countrycode = req.query.countrycode
	var currencyRate = req.query.currencyRate
	var currencySymbol = req.query.currencySymbol
	var pageno = req.query.pageno
	var perPage = config.perPage;
	var searchtext = req.query.searchtext
	var cid = req.query.cid
	
	if(!pageno){
		pageno = 1
	}
	
	
	if(!countrycode){
		countrycode = 'IN';
	}	
	
	if(!currencyRate){
		currencyRate = 1;
	}	
	
	if(!currencySymbol){
		currencySymbol = '₹';
	}
	
	if(!cid){
		cid = '2';
	}	
	
	var sql = "SELECT ProductName,ProductSale,ImageAltTag,ProductSku,ProductSlug,ProductPrice,ProductSalePrice,ProductCountry,ProductSmallImage, '"+currencyRate+"' as currecyRate,'"+currencySymbol+"' as currecysymbol,'"+countrycode+"' as countrycode,ROUND("+currencyRate+" * ProductPrice) as displayProductPrice, ROUND("+currencyRate+" * ProductSalePrice) as displaySalePrice,ProductBestSeller,ProductNewArrival,TwoDayDelivery,NextDayDelivery,ThreeHourDelivery,PremiumDelivery,ProductPersonalised,ProductSameDayDel From products left join product_media cm on cm.ProductNo =  ProductId where ProductName like concat('%', ?, '%') and ProductMediaNo = 1 and ProductStatus = 1 and OutofStock <> 1 and SearchVisibility = 1 and ProductCountry = '"+cid+"'"
	
	if(price){
		sql += " order By displayProductPrice "+price+" ,ProductId asc"
	}
	else if(id){
		sql += " order By ProductId "+id
	}
	else{
		sql += " order By ShowOnTop desc ,ProductId asc"
	}
	
	var startAt = perPage * (pageno - 1);
	sql += " LIMIT "+startAt+","+ perPage
	
	var  results  = await db.query(sql,[searchtext])
	await db.end()
	if(results.length > 0){
		res.status(200).json(results)
	}else{
		res.status(200).json(['no data found'])
	}
	
}