import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config'
import bcrypt from 'bcrypt';


export default async function handler(req, res) {
	const hbs = require('nodemailer-express-handlebars')
	const nodemailer = require('nodemailer')
	const path = require('path')
	const saltRounds = 10;
	var name  			= req.body.name
	var email 			= req.body.email
	var pwd 		    = req.body.pwd
	var phone 			= req.body.phone
	var country 		= req.body.country
	var erormsg         = ''
	
	const transporter = nodemailer.createTransport(
		{
			port: process.env.SmtpPort,
			secure: true,
			host: process.env.SmtpHost,
			auth:{
				user: process.env.SmtpUser,
				pass: process.env.SmtpPassword
			},
				from: process.env.SmtpUser
		}
	);		
	
	const handlebarOptions = {
		viewEngine: {
			partialsDir: path.resolve('./emailslayout/'),
			defaultLayout: false,
		},
		viewPath: path.resolve('./emailslayout/'),
	};
	
	transporter.use('compile', hbs(handlebarOptions))
	
	var hashes = bcrypt.hashSync(pwd, saltRounds);	
	
	var mailOptions = {
		from:  process.env.SmtpUser,
		to: email, 
		subject: 'Registration email!',
		template: 'register',
		context:{
			name: name,
			company: ''
		}
	};
	
	var iseeror = false
	
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD  
		}
	})
	
	var sql = `INSERT INTO Customers (CustomerName,  CustomerEmail, CustomerPassword, CustomerStatus, isSocialLogin, CustomerPhone, CustomerCountry) VALUES  ('${name}','${email}','${hashes}','1','0','${phone}','${country}')`
	
	try {
		
		let results = await db.transaction().query(sql)
		.rollback(e => {  
			if(e.code == 'ER_DUP_ENTRY'){
				erormsg = 'You are already registered on 1800rakhis,';
			}
		}) 
		.commit()
		await db.end();
		
		if(!erormsg){
			transporter.sendMail(mailOptions, async function(error, info){			
				if(error){
					var delnewuser = `DELETE FROM Customers WHERE CustomerEmail= '${email}'`
					let results = await db.query(delnewuser)
					await db.end();
					erormsg = 'Oops something went wrong';
					return res.status(200).send({ 'CODE': '500', 'msg': erormsg,'error':error})
				}else{			
					return res.status(200).send({ 'CODE': '200', 'msg': 'Customer regstered successfully'})
				}
			});	
		}
	}
	catch (Error) {
		return res.status(200).send({ 'CODE': '500', 'msg': erormsg})
	}
  
	
	

}