import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';

const hbs = require('nodemailer-express-handlebars')
const nodemailer = require('nodemailer')
const path = require('path')

export default async function handler(req, res) {

	var queryData = JSON.parse(req.body);
	var name = queryData.name;
	var email = queryData.email;
	var Phone = queryData.Phone;
	var Comments = queryData.Comments;
    var transporter = nodemailer.createTransport(
		{
			port: process.env.SmtpPort,
			secure: true,
			host: process.env.SmtpHost,
			auth:{
				user: process.env.SmtpUser,
				pass: process.env.SmtpPassword
			},
			 from: process.env.SmtpUser
		}
	);
		// point to the template folder
		const handlebarOptions = {
			viewEngine: {
				partialsDir: path.resolve('./emailslayout/'),
				defaultLayout: false,
			},
		   viewPath: path.resolve('./emailslayout/'),
		};
		// use a template file with nodemailer
		transporter.use('compile', hbs(handlebarOptions));    
		var mailOptions = {
			from: process.env.SmtpUser,
			to: process.env.AdminEmail,
			subject: '1800rakhis contact us email',
			template: 'contact',
			context:{
				name: name,
				Phone: Phone,
				Comments: Comments,
				email: email
			},
		}
        transporter.sendMail(mailOptions, async function(error, info){
			if(error){
				return  res.status(500).json({ 'CODE':200,msg:'oops something went wrong'})
			}else{
				return  res.status(200).json({ 'CODE':200,msg:'Email sent successfully'})
			}
		})
}