import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';

const hbs = require('nodemailer-express-handlebars')
const nodemailer = require('nodemailer')
const path = require('path')

export default async function handler(req, res) {
	
	const db = mysql({
		config: {
			host: process.env.DB_HOST,
			port: process.env.DB_PORT,
			database: process.env.DB_DATABASE,
			user: process.env.DB_USER,
			password: process.env.DB_PASSWORD
		}
	})

	try {		
		var queryData = JSON.parse(req.body);
		var Productdata = queryData.prodcuts;

		var OrderDeliveryDate = queryData.DeliverDate

		var iseeror = false
		var orderId = '';

		if (req.method === 'POST') {
			var returnData = { CODE: '200', error: '', data: '' }
			var OrderCountryId = queryData.ProductCountry;
			var getCountrydata = await db.transaction().query("SELECT * FROM `delivery_coutries_master` WHERE `CountryId`='" + OrderCountryId + "'")
				.rollback(e => {
					iseeror = true
				})
				.commit();

			var CountryOrderPrefix = '';
			var lastOrderNo = 0;
			if (getCountrydata) {
				CountryOrderPrefix = getCountrydata[0][0].OrderPrefix;
				lastOrderNo = getCountrydata[0][0].LastOrderId;
			}
			var OrderNold = parseInt(lastOrderNo) + parseInt(1);
			var OrderNo = CountryOrderPrefix + '' + OrderNold;
			var subject = 'Your order ' + OrderNo + ' is confirmed';

			var SpecialInstructions = queryData.SpecialInstructions;
			var GiftMessage = queryData.GiftMessage;
			var CustomerBillingFirstName =queryData.CustomerBillingFirstName;
			var CustomerBillingLastName = queryData.CustomerBillingLastName;
			var CustomerShippingFirstName = queryData.CustomerShippingFirstName;
			var CustomerShippingLastName = queryData.CustomerShippingLastName;
			var CustomerShippingCity = queryData.CustomerShippingCity;
			var CustomerShippingAddress = queryData.CustomerShippingAddress;
			var paypalorderid = queryData.paypalorderid;

			if (queryData.login == '1') {
				var ordrQry = "INSERT INTO `orders`(`OrderNo`, `CustomerNo`, `OrderFromIP`, `OrderCurrentCurrRate`, `OrderCurrentCurrSymbol`, `OrderCurrentCurrCode`, `OrderCouponType`, `OrderCouponCode`, `OrderCouponPerORVal`, `OrderDiscount`, `OrderDiscountINR`, `OrderDeliveryCharges`, `OrderDeliveryChargesINR`, `OrderSubtotal`, `OrderSubtotalINR`, `OrderGrandTotal`, `OrderGrandTotalINR`, `OrderCurrentStatus`, `OrderPaymentGateway`, `SpecialInstructions`, `GiftMessage`,`PaypalOrderId`) VALUES ?";

				var orderarr = [OrderNo,queryData.CustomerNo,queryData.OrderFromIP, queryData.OrderCurrentCurrRate, queryData.OrderCurrentCurrSymbol, queryData.OrderCurrentCurrCode, queryData.OrderCouponType, queryData.OrderCouponCode, queryData.OrderCouponPerORVal, queryData.OrderDiscount, queryData.OrderDiscountINR, queryData.OrderDeliveryCharges, queryData.OrderDeliveryChargesINR, queryData.OrderSubtotal, queryData.OrderSubtotalINR, queryData.OrderGrandTotal, queryData.OrderGrandTotalINR,'1', queryData.OrderPaymentGateway,SpecialInstructions,GiftMessage,paypalorderid];

				var mainOrderdata = [];
				mainOrderdata.push(orderarr)

				let results = await db.transaction()
					.query(ordrQry, [mainOrderdata])
					.query((r) => {
						orderId = r.insertId;
						var ordrProdQry = "INSERT INTO `order_items`(`OrderNo`, `ProductNo`, `OrderItemProductSku`, `ProductName`, `OrderItemIsAddon`, `OrderItemQty`, `OrderItemVendorNo`, `OrderVendorPrice`, `OrderVendorPriceINR`, `ProductUnitrPrice`, `ProductUnitrPriceINR`, `OrderItemSalePrice`, `OrderItemSalePriceINR`, `ItemPurchasePrice`, `ItemPurchasePriceINR`, `OrderItemDiscountPrice`, `OrderItemDiscountPriceINR`, `ProductDeliveryDate`, `OrderProductDeliveryCharges`, `OrderProductDeliveryChargesINR`, `ItemGiftwrapped`, `ItemGiftWrappingCharges`, `ItemGiftWrappingChargesINR`, `ItemTypeCharges`, `ItemTypeChargesINR`, `RowTotal`, `RowTotalINR`, `OrderItemStatusNo`, `CakeMessage`, `PersonalisedImage`, `ItemVariationNo`, `ItemTypesNo`) VALUES ?";

						var returnArraydata = [];

						Productdata.map((val, ind) => {
							var qryData = [];

							qryData.push(orderId);

							if (val.is_addon == '1') {
								qryData.push(val.addon_product_id);
							} else {
								qryData.push(val.product_id);
							}
							if (val.is_addon == '1') {
								qryData.push(val.addon_product_sku);
							} else {
								qryData.push(val.product_sku);
							}
							qryData.push(val.name);
							qryData.push(val.is_addon);
							qryData.push(val.quantity);

							// Vendor no is missing
							qryData.push('1');


							qryData.push('0.00');
							qryData.push(val.vendor_price_inr + '.00');

							// Unit price is missing
							qryData.push(val.utprice + '.00');						
							qryData.push(val.price + '.00');

							qryData.push(val.product_sale_price + '.00');
							qryData.push(val.product_sale_price_inr + '.00');

							qryData.push(val.product_purchase_price + '.00');
							qryData.push(val.product_purchase_price_inr + '.00');
							
							qryData.push('0.00');
							qryData.push('0.00');

							qryData.push(val.del_date);

							var ProductDeliveryChargesINR = val.del_charges
							var ProductDeliveryCharges = val.new_del_charges
							var giftwrapper = val.new_giftwrapper

							qryData.push(val.new_del_charges);
							var delchinr = (val.del_charges* val.quantity);
							qryData.push(delchinr);

							if (val.giftwrapper) {
								qryData.push('1');
								qryData.push(val.new_giftwrapper);
								qryData.push(val.new_giftwrapper_inr);
							} else {
								qryData.push('0');
								qryData.push('0');
								qryData.push('0');
							}

							
							qryData.push('0');
							qryData.push('0');
							qryData.push(val.new_subtotal);
							qryData.push(val.new_subtotal_inr);
							qryData.push('6');

							qryData.push(val.cake_message);
							qryData.push(val.uploaded_image);
							qryData.push(val.variation_id);
							if (val.is_addon != '1') {
								var vartypes = '';
								if(val.variation_types){
									val.variation_types.map((varval, varind) => {
										vartypes += varval.TypeName+', ';
									})						
									vartypes = vartypes.replace(/,\s*$/, "");
								}else{
									vartypes = '';
								}
								
								qryData.push(vartypes);
							}else{
								qryData.push('');
							}
							
							
							// var vartypes = '';
							// val.variation_types.map((varval, varind) => {
								// vartypes += varval.TypeName+', ';
							// })						
							// vartypes = vartypes.replace(/,\s*$/, "");
							// qryData.push(vartypes);

							returnArraydata.push(qryData);
						})

						return [ordrProdQry, [returnArraydata]];
					}).query((r) => {
						var addressQry = "INSERT INTO `orders_addres_book`(`OrderNo`, `CustomerOrderBillingFirstName`, `CustomerOrderBillingLastName`, `CustomerOrderBillingEmail`, `CustomerOrderBillingPhone`, `CustomerOrderShippingFirstName`, `CustomerOrderShippingLastName`, `CustomerOrderShippingCompany`, `CustomerOrderShippingCountryNo`, `CustomerOrderShippingState`, `CustomerOrderShippingCity`, `CustomerOrderShippingAddress`, `CustomerOrderShippingPincode`, `CustomerOrderShippingPhone`) VALUES ?";

						var orderAddarr = [orderId, CustomerBillingFirstName, CustomerBillingLastName, queryData.CustomerBillingEmail, queryData.CustomerBillingPhone, CustomerShippingFirstName, CustomerShippingLastName, queryData.CustomerShippingCompany, queryData.CustomerShippingCountryNo, queryData.CustomerShippingState, CustomerShippingCity, CustomerShippingAddress, queryData.CustomerShippingPincode, queryData.CustomerShippingPhone];

						var newarrdta = []
						newarrdta.push(orderAddarr)

						return [addressQry, [newarrdta]];
					}).query((r) => {
						var updateqry = "UPDATE `delivery_coutries_master` SET `LastOrderId`='" + OrderNold + "' WHERE `CountryId`='" + OrderCountryId + "'";
						return [updateqry];
					}).rollback(e => {
						iseeror = true
					}).commit();

					await db.end();

				if (!iseeror) {
					return res.status(200).json({ 'CODE': 200, msg: 'Order placed succssfully', orderId: orderId })
				} else {
					return res.status(200).json({ 'CODE': 500, msg: 'Oops something went wrong', 'col': 1 })
				}
			}
			else {

				/* check customer exists or not */
				var Customerinseterror = false
				var CustomerNo = ''
				var customercheck = `SELECT * FROM Customers where CustomerEmail = '${queryData.CustomerBillingEmail}' LIMIT 1`
				var customercheckres = await db.query(customercheck)

				if (customercheckres.length < 1) {
					//var insertnewcustomer = `INSERT INTO Customers (CustomerName, CustomerLastname, CustomerEmail,  CustomerStatus,isSocialLogin, CustomerPhone, CustomerCountry) VALUES ('${CustomerBillingFirstName}','${CustomerBillingLastName}','${queryData.CustomerBillingEmail}','1','0','${queryData.CustomerBillingPhone}','${queryData.CustomerCountry}')`
					var insertnewcustomer = `INSERT INTO Customers (CustomerName, CustomerLastname, CustomerEmail,  CustomerStatus,isSocialLogin, CustomerPhone, CustomerCountry) VALUES ? `

					var customerbillingaddData = [CustomerBillingFirstName,CustomerBillingLastName,queryData.CustomerBillingEmail,1,0,queryData.CustomerBillingPhone,queryData.CustomerCountry];

					var newsBilldata = []
					newsBilldata.push(customerbillingaddData)
					

					
					var CountryId = await db.transaction().query(insertnewcustomer,[newsBilldata])
						.rollback(e => { iseeror = true })
						.commit();
					if (!iseeror) {
						var customercheck = `SELECT * FROM Customers where CustomerEmail = '${queryData.CustomerBillingEmail}' LIMIT 1`
						let results = await db.query(customercheck)

						CustomerNo = results[0].CustomerID
						var ordrQry = "INSERT INTO `orders`(`OrderNo`, `CustomerNo`, `OrderFromIP`, `OrderCurrentCurrRate`, `OrderCurrentCurrSymbol`, `OrderCurrentCurrCode`, `OrderCouponType`, `OrderCouponCode`, `OrderCouponPerORVal`, `OrderDiscount`, `OrderDiscountINR`, `OrderDeliveryCharges`, `OrderDeliveryChargesINR`, `OrderSubtotal`, `OrderSubtotalINR`, `OrderGrandTotal`, `OrderGrandTotalINR`, `OrderCurrentStatus`, `OrderPaymentGateway`, `SpecialInstructions`, `GiftMessage`,`PaypalOrderId`) VALUES ?";

						var orderarr = [OrderNo,CustomerNo,queryData.OrderFromIP, queryData.OrderCurrentCurrRate, queryData.OrderCurrentCurrSymbol, queryData.OrderCurrentCurrCode, queryData.OrderCouponType, queryData.OrderCouponCode, queryData.OrderCouponPerORVal, queryData.OrderDiscount, queryData.OrderDiscountINR, queryData.OrderDeliveryCharges, queryData.OrderDeliveryChargesINR, queryData.OrderSubtotal, queryData.OrderSubtotalINR, queryData.OrderGrandTotal, queryData.OrderGrandTotalINR,'1', queryData.OrderPaymentGateway,SpecialInstructions,GiftMessage,paypalorderid];

						var mainOrderdata = [];
						mainOrderdata.push(orderarr)
						let resultsss = await db.transaction()
							.query(ordrQry, [mainOrderdata])
							.query((r) => {
								orderId = r.insertId;
								var ordrProdQry = "INSERT INTO `order_items`(`OrderNo`, `ProductNo`, `OrderItemProductSku`, `ProductName`, `OrderItemIsAddon`, `OrderItemQty`, `OrderItemVendorNo`, `OrderVendorPrice`, `OrderVendorPriceINR`, `ProductUnitrPrice`, `ProductUnitrPriceINR`, `OrderItemSalePrice`, `OrderItemSalePriceINR`, `ItemPurchasePrice`, `ItemPurchasePriceINR`, `OrderItemDiscountPrice`, `OrderItemDiscountPriceINR`, `ProductDeliveryDate`, `OrderProductDeliveryCharges`, `OrderProductDeliveryChargesINR`, `ItemGiftwrapped`, `ItemGiftWrappingCharges`, `ItemGiftWrappingChargesINR`, `ItemTypeCharges`, `ItemTypeChargesINR`, `RowTotal`, `RowTotalINR`, `OrderItemStatusNo`, `CakeMessage`, `PersonalisedImage`, `ItemVariationNo`, `ItemTypesNo`) VALUES ?";

								var returnArraydata = [];

								Productdata.map((val, ind) => {
									var qryData = [];
			
									qryData.push(orderId);
			
									if (val.is_addon == '1') {
										qryData.push(val.addon_product_id);
									} else {
										qryData.push(val.product_id);
									}
									if (val.is_addon == '1') {
										qryData.push(val.addon_product_sku);
									} else {
										qryData.push(val.product_sku);
									}
									qryData.push(val.name);
									qryData.push(val.is_addon);
									qryData.push(val.quantity);
			
									// Vendor no is missing
									qryData.push('1');
			
			
									qryData.push('0.00');
									qryData.push(val.vendor_price_inr + '.00');
			
									// Unit price is missing
									qryData.push(val.utprice + '.00');						
									qryData.push(val.price + '.00');
			
									qryData.push(val.product_sale_price + '.00');
									qryData.push(val.product_sale_price_inr + '.00');
			
									qryData.push(val.product_purchase_price + '.00');
									qryData.push(val.product_purchase_price_inr + '.00');
									
									qryData.push('0.00');
									qryData.push('0.00');
			
									qryData.push(val.del_date);
			
									var ProductDeliveryChargesINR = val.del_charges
									var ProductDeliveryCharges = val.new_del_charges
									var giftwrapper = val.new_giftwrapper
			
									qryData.push(val.new_del_charges);
									var delchinr = (val.del_charges* val.quantity);
									qryData.push(delchinr);
			
									if (val.giftwrapper) {
										qryData.push('1');
										qryData.push(val.new_giftwrapper);
										qryData.push(val.new_giftwrapper_inr);
									} else {
										qryData.push('0');
										qryData.push('0');
										qryData.push('0');
									}
			
									
									qryData.push('0');
									qryData.push('0');
									qryData.push(val.new_subtotal);
									qryData.push(val.new_subtotal_inr);
									qryData.push('6');
			
									qryData.push(val.cake_message);
									qryData.push(val.uploaded_image);
									qryData.push(val.variation_id);
									
									if (val.is_addon != '1') {
										var vartypes = '';
										if(val.variation_types){
											val.variation_types.map((varval, varind) => {
												vartypes += varval.TypeName+', ';
											})						
											vartypes = vartypes.replace(/,\s*$/, "");
										}else{
											vartypes = '';
										}
										
										qryData.push(vartypes);
									}else{
										qryData.push('');
									}

									// var vartypes = '';
									// val.variation_types.map((varval, varind) => {
										// vartypes += varval.TypeName+', ';
									// })						
									// vartypes = vartypes.replace(/,\s*$/, "");
									// qryData.push(vartypes);
			
									returnArraydata.push(qryData);
								})

								return [ordrProdQry, [returnArraydata]];
							}).query((r) => {
								var addressQry = "INSERT INTO `orders_addres_book`(`OrderNo`, `CustomerOrderBillingFirstName`, `CustomerOrderBillingLastName`, `CustomerOrderBillingEmail`, `CustomerOrderBillingPhone`, `CustomerOrderShippingFirstName`, `CustomerOrderShippingLastName`, `CustomerOrderShippingCompany`, `CustomerOrderShippingCountryNo`, `CustomerOrderShippingState`, `CustomerOrderShippingCity`, `CustomerOrderShippingAddress`, `CustomerOrderShippingPincode`, `CustomerOrderShippingPhone`) VALUES ?";
								var orderAddarr = [orderId, CustomerBillingFirstName, CustomerBillingLastName, queryData.CustomerBillingEmail, queryData.CustomerBillingPhone, CustomerShippingFirstName, CustomerShippingLastName, queryData.CustomerShippingCompany, queryData.CustomerShippingCountryNo, queryData.CustomerShippingState, CustomerShippingCity, CustomerShippingAddress, queryData.CustomerShippingPincode, queryData.CustomerShippingPhone];
								var newarrdta = []
								newarrdta.push(orderAddarr)
								return [addressQry, [newarrdta]];
							})
							.query((r) => {

								var insrtcustomerbillingaddress = "INSERT INTO customers_billing_address (CustomerNo, CustomerBillingFirstName, CustomerBillingLastName, CustomerBillingEmail, CustomerBillingPhone) VALUES ? ";

								var customerbillingaddData = [CustomerNo,CustomerBillingFirstName,CustomerBillingLastName,queryData.CustomerBillingEmail,queryData.CustomerBillingPhone];

								var newsBilldata = []
								newsBilldata.push(customerbillingaddData)
								return [insrtcustomerbillingaddress, [newsBilldata]];


								// var insrtcustomerbillingaddress = "INSERT INTO customers_billing_address (CustomerNo, CustomerBillingFirstName, CustomerBillingLastName, CustomerBillingEmail, CustomerBillingPhone) VALUES ('" + CustomerNo + "','" + CustomerBillingFirstName + "','" +CustomerBillingLastName + "','" + queryData.CustomerBillingEmail + "','" + queryData.CustomerBillingPhone + "')";
								// return [insrtcustomerbillingaddress];
							})
							.query((r) => {							
								var insrtcustomershippingaddress = "INSERT INTO customer_shipping_book(CustomerNo,CustomerShippingFirstName, CustomerShippingLastName,CustomerShippingCountryNo,CustomerShippingState,CustomerShippingCity, CustomerShippingAddress,CustomerShippingPincode,CustomerShippingPhone) VALUES ?";

								var custShipAddData = [CustomerNo,CustomerShippingFirstName,CustomerShippingLastName,queryData.CustomerShippingCountryNo,queryData.CustomerShippingState,CustomerShippingCity,CustomerShippingAddress,queryData.CustomerShippingPincode,queryData.CustomerShippingPhone];

								var newsharrdta = []
								newsharrdta.push(custShipAddData)
								return [insrtcustomershippingaddress, [newsharrdta]];

							}).query((r) => {
								var insrtorderHistory = "INSERT INTO order_notes_history (OrderNo, OrderNotesHistoryComment,OrderStatus) VALUES ('" + orderId + "','Order was placed on ','5')";
								return [insrtorderHistory];
							}).query((r) => {
								var updateqry = "UPDATE `delivery_coutries_master` SET `LastOrderId`='" + OrderNold + "' WHERE `CountryId`='" + OrderCountryId + "'";
								return [updateqry];
							})
							.rollback(e => {
								iseeror = true
							})
							.commit()
							await db.end();
						if (!iseeror) {
							return res.status(200).json({ 'CODE': 200, msg: 'Order placed succssfully', orderId: orderId })
						} else {
							return res.status(200).json({ 'CODE': 500, msg: 'Oops something went wrong', 'col': 1 })
						}

					} else {
						await db.end();
						return res.status(200).json({ 'CODE': 500, msg: 'Oops something went wrong', 'col': 2 })
					}
				} else {
					CustomerNo = customercheckres[0].CustomerID
					
					var ordrQry = "INSERT INTO `orders`(`OrderNo`, `CustomerNo`, `OrderFromIP`, `OrderCurrentCurrRate`, `OrderCurrentCurrSymbol`, `OrderCurrentCurrCode`, `OrderCouponType`, `OrderCouponCode`, `OrderCouponPerORVal`, `OrderDiscount`, `OrderDiscountINR`, `OrderDeliveryCharges`, `OrderDeliveryChargesINR`, `OrderSubtotal`, `OrderSubtotalINR`, `OrderGrandTotal`, `OrderGrandTotalINR`, `OrderCurrentStatus`, `OrderPaymentGateway`, `SpecialInstructions`, `GiftMessage`,`PaypalOrderId`) VALUES ?";

					var orderarr = [OrderNo,CustomerNo,queryData.OrderFromIP, queryData.OrderCurrentCurrRate, queryData.OrderCurrentCurrSymbol, queryData.OrderCurrentCurrCode, queryData.OrderCouponType, queryData.OrderCouponCode, queryData.OrderCouponPerORVal, queryData.OrderDiscount, queryData.OrderDiscountINR, queryData.OrderDeliveryCharges, queryData.OrderDeliveryChargesINR, queryData.OrderSubtotal, queryData.OrderSubtotalINR, queryData.OrderGrandTotal, queryData.OrderGrandTotalINR,'1', queryData.OrderPaymentGateway,SpecialInstructions,GiftMessage,paypalorderid];

					var mainOrderdata = [];
					mainOrderdata.push(orderarr)
					let results = await db.transaction()
						.query(ordrQry, [mainOrderdata])
						.query((r) => {
							orderId = r.insertId;
							var ordrProdQry = "INSERT INTO `order_items`(`OrderNo`, `ProductNo`, `OrderItemProductSku`, `ProductName`, `OrderItemIsAddon`, `OrderItemQty`, `OrderItemVendorNo`, `OrderVendorPrice`, `OrderVendorPriceINR`, `ProductUnitrPrice`, `ProductUnitrPriceINR`, `OrderItemSalePrice`, `OrderItemSalePriceINR`, `ItemPurchasePrice`, `ItemPurchasePriceINR`, `OrderItemDiscountPrice`, `OrderItemDiscountPriceINR`, `ProductDeliveryDate`, `OrderProductDeliveryCharges`, `OrderProductDeliveryChargesINR`, `ItemGiftwrapped`, `ItemGiftWrappingCharges`, `ItemGiftWrappingChargesINR`, `ItemTypeCharges`, `ItemTypeChargesINR`, `RowTotal`, `RowTotalINR`, `OrderItemStatusNo`, `CakeMessage`, `PersonalisedImage`, `ItemVariationNo`, `ItemTypesNo`) VALUES ?";

								var returnArraydata = [];

								Productdata.map((val, ind) => {
									var qryData = [];
			
									qryData.push(orderId);
			
									if (val.is_addon == '1') {
										qryData.push(val.addon_product_id);
									} else {
										qryData.push(val.product_id);
									}
									if (val.is_addon == '1') {
										qryData.push(val.addon_product_sku);
									} else {
										qryData.push(val.product_sku);
									}
									qryData.push(val.name);
									qryData.push(val.is_addon);
									qryData.push(val.quantity);
			
									// Vendor no is missing
									qryData.push('1');		
			
									qryData.push('0.00');
									qryData.push(val.vendor_price_inr + '.00');
			
									// Unit price is missing
									qryData.push(val.utprice + '.00');						
									qryData.push(val.price + '.00');
			
									qryData.push(val.product_sale_price + '.00');
									qryData.push(val.product_sale_price_inr + '.00');
			
									qryData.push(val.product_purchase_price + '.00');
									qryData.push(val.product_purchase_price_inr + '.00');
									
									qryData.push('0.00');
									qryData.push('0.00');
			
									qryData.push(val.del_date);
			
									var ProductDeliveryChargesINR = val.del_charges
									var ProductDeliveryCharges = val.new_del_charges
									var giftwrapper = val.new_giftwrapper
			
									qryData.push(val.new_del_charges);
									var delchinr = (val.del_charges* val.quantity);
									qryData.push(delchinr);
			
									if (val.giftwrapper) {
										qryData.push('1');
										qryData.push(val.new_giftwrapper);
										qryData.push(val.new_giftwrapper_inr);
									} else {
										qryData.push('0');
										qryData.push('0');
										qryData.push('0');
									}		
									
									qryData.push('0');
									qryData.push('0');
									qryData.push(val.new_subtotal);
									qryData.push(val.new_subtotal_inr);
									qryData.push('6');
			
									qryData.push(val.cake_message);
									qryData.push(val.uploaded_image);								
									qryData.push(val.variation_id);
									
									if (val.is_addon != '1') {
										var vartypes = '';
										if(val.variation_types){
											val.variation_types.map((varval, varind) => {
												vartypes += varval.TypeName+', ';
											})						
											vartypes = vartypes.replace(/,\s*$/, "");
										}else{
											vartypes = '';
										}
										
										qryData.push(vartypes);
									}else{
										qryData.push('');
									}
	
									// var vartypes = '';
									// val.variation_types.map((varval, varind) => {
										// vartypes += varval.TypeName+', ';
									// })						
									// vartypes = vartypes.replace(/,\s*$/, "");
									// qryData.push(vartypes);
			
									returnArraydata.push(qryData);
								})
								return [ordrProdQry, [returnArraydata]];
						}).query((r) => {
							var addressQry = "INSERT INTO `orders_addres_book`(`OrderNo`, `CustomerOrderBillingFirstName`, `CustomerOrderBillingLastName`, `CustomerOrderBillingEmail`, `CustomerOrderBillingPhone`, `CustomerOrderShippingFirstName`, `CustomerOrderShippingLastName`, `CustomerOrderShippingCompany`, `CustomerOrderShippingCountryNo`, `CustomerOrderShippingState`, `CustomerOrderShippingCity`, `CustomerOrderShippingAddress`, `CustomerOrderShippingPincode`, `CustomerOrderShippingPhone`) VALUES ?";
							var orderAddarr = [orderId, CustomerBillingFirstName, CustomerBillingLastName, queryData.CustomerBillingEmail, queryData.CustomerBillingPhone, CustomerShippingFirstName, CustomerShippingLastName, queryData.CustomerShippingCompany, queryData.CustomerShippingCountryNo, queryData.CustomerShippingState, CustomerShippingCity, CustomerShippingAddress, queryData.CustomerShippingPincode, queryData.CustomerShippingPhone];
							var newarrdta = []
							newarrdta.push(orderAddarr)
							return [addressQry, [newarrdta]];
						}).query((r) => {
							
							var insrtcustomershippingaddress = "INSERT INTO customer_shipping_book(CustomerNo,CustomerShippingFirstName, CustomerShippingLastName,CustomerShippingCountryNo,CustomerShippingState,CustomerShippingCity, CustomerShippingAddress,CustomerShippingPincode,CustomerShippingPhone) VALUES ?";

							var custShipAddData = [CustomerNo,CustomerShippingFirstName,CustomerShippingLastName,queryData.CustomerShippingCountryNo,queryData.CustomerShippingState,CustomerShippingCity,CustomerShippingAddress,queryData.CustomerShippingPincode,queryData.CustomerShippingPhone];

							var newsharrdta = []
							newsharrdta.push(custShipAddData)
							return [insrtcustomershippingaddress, [newsharrdta]];

						}).query((r) => {
							var insrtorderHistory = "INSERT INTO order_notes_history (OrderNo, OrderNotesHistoryComment,OrderStatus) VALUES ('" + orderId + "','Order was placed on ','5')";
							return [insrtorderHistory];
						}).query((r) => {
							var updateqry = "UPDATE `delivery_coutries_master` SET `LastOrderId`='" + OrderNold + "' WHERE `CountryId`='" + OrderCountryId + "'";
							return [updateqry];
						}).rollback(e => {
							iseeror = true
						}).commit()

						await db.end();

					if (!iseeror) {
						
						return res.status(200).json({ 'CODE': 200, msg: 'Order placed succssfully', orderId: orderId })
					} else {
						return res.status(200).json({ 'CODE': 500, msg: 'Oops something went wrong', 'col': 3, orderId: orderId })
					}
				}
			}

		} else {
			await db.end();
			res.status(404).json({ results: '' })
		}
	} catch (err) {
		await db.end();
		res.status(200).send({ 'CODE':500 ,'msg': 'failed to fetch data',err })
	}

}
