import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';
export default async function handler(req, res) {

	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD   
		}
	})

    try{
        var queryData = JSON.parse(req.body);
        
        var orderno = queryData.orderno;
        var email = queryData.email;    
        
        var iseeror = false;
        if(req.method === 'POST'){      
            var orderdata = [];
            var orderitems = [];
            var status = [];

            //var sql = "SELECT orders.*,orders.OrderNo as orderNumber,orders_addres_book.*,order_status.OrderStatusName from orders_addres_book LEFT JOIN orders ON orders.OrderId=orders_addres_book.OrderNo LEFT JOIN order_status ON order_status.OrderStatusId=orders.OrderCurrentStatus WHERE orders.OrderNo='"+orderno+"' and orders_addres_book.CustomerOrderBillingEmail = '"+email+"'";            

            var sql = "SELECT CustomerName,CustomerLastname,CustomerEmail,OrderStatusName,payment_methods.PaymentMethodName,oab.*,orders.*,DATE_FORMAT(orders.OrderDate,'%d %b %Y') as od,DATE_FORMAT(orders.OrderDeliveryDate,'%d %b %Y') as del_date,dcm.CountryName FROM orders left join Customers on CustomerID = CustomerNo  left join order_status on OrderStatusId = OrderCurrentStatus  left join orders_addres_book as oab on oab.OrderNo = orders.OrderId left join delivery_coutries_master dcm on oab.CustomerOrderShippingCountryNo = dcm.CountryId left join payment_methods on PaymentId = orders.OrderPaymentGateway WHERE orders.OrderNo ='"+orderno+"' and oab.CustomerOrderBillingEmail = '"+email+"'";

            let results = await db.transaction()	
            .query(sql)	        			
            .query((r) => {
                orderdata = r;
                if(r.length > 0){
                    var id = r[0].OrderId;

                    //var sql2 = "select * from (select * from ( SELECT order_items.*,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,product_media.ProductSmallImage as image FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join product_media on product_media.ProductNo = order_items.ProductNo where OrderNo ='"+id+"' and ProductMediaNo = 1 union all SELECT order_items.*,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,ap.AddonImage FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join addon_products ap on ap.AddonProductSku = order_items.orderitemproductsku where OrderNo = "+id+"  and OrderItemIsAddon = 1) as x where x.image is not null ) as x where x.image is not null"; 
                    
                    var sql2 = "select * from ( SELECT order_items.*,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,  CONCAT('', '/',product_media.ProductSmallImage) as image,DATE_FORMAT(order_items.ProductDeliveryDate,'%d-%m-%Y') as ProductDeldate,(ItemPurchasePrice * OrderItemQty) as itemtotal,((ItemPurchasePrice * OrderItemQty) +  ifnull (OrderProductDeliveryCharges,0) + ifnull (ItemGiftWrappingCharges,0) ) as GrandTotal  FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join product_media on product_media.ProductNo = order_items.ProductNo where OrderNo = "+id+" and ProductMediaNo = 1 and OrderItemIsAddon = 0 union all SELECT order_items.*,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,CONCAT('', '/',ap.AddonImage) as image,DATE_FORMAT(order_items.ProductDeliveryDate,'%d-%m-%Y') as ProductDeldate,(ItemPurchasePrice * OrderItemQty) as itemtotal,((ItemPurchasePrice * OrderItemQty) +  ifnull (OrderProductDeliveryCharges,0) + ifnull (ItemGiftWrappingCharges,0) ) as GrandTotal FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join addon_products ap on ap.AddonProductSku = order_items.orderitemproductsku where OrderNo = "+id+" and OrderItemIsAddon = 1 ) as x where x.image is not null;"
                    return [sql2];   
                }                
            })		
            .query((r1) => {
                orderitems = r1;
                var sql3 = "SELECT * FROM `order_status` WHERE `IsOrderLevel`='1'";            
                return [sql3];   
            }).query((r2) => {
                status = r2;                 
            }).rollback(e => { 
                iseeror = true
            }) 
            .commit()
            await db.end();
            if(!iseeror){
                return  res.status(200).json({ 'CODE':200,'orderdata':orderdata,'orderitems':orderitems,'status':status})
            }else{
                return  res.status(200).json({ 'CODE':500,msg:'Oops something went wrong','orderdata':orderdata,'orderitems':orderitems,'status':status})
            }	
        }
    } catch(err){
        await db.end()	
		res.status(200).send({ 'CODE':500 ,'msg': 'failed to fetch data',err })
    }
	
}