import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';

const hbs = require('nodemailer-express-handlebars')
const nodemailer = require('nodemailer')
const path = require('path')

export default async function handler(req, res) {

	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD   
		}
	})

	try {

		var queryData = JSON.parse(req.body);

		var orderdata = [];
		var orderItemsData = [];

		var OrderId = queryData.orderid;
		var paymentstatus = queryData.paymentstatus;
		var iseeror = false;
		if(!paymentstatus){
			paymentstatus = '5'
		}
		if(req.method === 'POST' && OrderId){      
			var returnData = { CODE: '200', error: '', data: '' }
			var OrderCountryId = queryData.ProductCountry;
			
			var sql = "SELECT CustomerName,CustomerLastname,CustomerEmail,OrderStatusName,payment_methods.PaymentMethodName,oab.*,orders.*,DATE_FORMAT(orders.OrderDate,'%d %b %Y') as od,DATE_FORMAT(orders.OrderDeliveryDate,'%d %b %Y') as del_date ,dcm.CountryName,(SELECT SUM(ItemGiftWrappingCharges) as gw  FROM `order_items` where OrderNo = '"+OrderId+"' group by OrderNo) as giftwrappingcharges FROM orders left join Customers on CustomerID = CustomerNo  left join order_status on OrderStatusId = OrderCurrentStatus  left join orders_addres_book as oab on oab.OrderNo = orders.OrderId left join delivery_coutries_master dcm on oab.CustomerOrderShippingCountryNo = dcm.CountryId left join payment_methods on PaymentId = orders.OrderPaymentGateway where OrderId ='"+OrderId+"'"
			orderdata  = await db.query(sql);
			
		
			var itemsql = "select * from ( SELECT order_items.*,(order_items.ProductUnitrPrice * order_items.OrderItemQty) as itemqtyTotal,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,  CONCAT('"+config.callBackUrl+"adminapi/uploads/products', '/',product_media.ProductSmallImage) as image,orders.OrderCurrentCurrSymbol FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join product_media on product_media.ProductNo = order_items.ProductNo LEFT JOIN orders ON orders.OrderId=order_items.OrderNo where order_items.OrderNo = '"+OrderId+"' and ProductMediaNo = 1 and OrderItemIsAddon = 0 union all SELECT order_items.*,(order_items.ProductUnitrPrice * order_items.OrderItemQty) as itemqtyTotal,VendorName, VendorLastName,VendorEmail,VendorPhone,VendorLogo,OrderStatusId,OrderStatusName,CONCAT('"+config.callBackUrl+"adminapi/uploads/addons', '/',ap.AddonImage) as image,orders.OrderCurrentCurrSymbol FROM order_items left join vendors on OrderItemVendorNo = VendorId left join order_status on OrderItemStatusNo = OrderStatusId left join addon_products ap on ap.AddonProductSku = order_items.orderitemproductsku LEFT JOIN orders ON orders.OrderId=order_items.OrderNo where order_items.OrderNo ='"+OrderId+"' and OrderItemIsAddon = 1 ) as x where x.image is not null"

			orderItemsData  = await db.query(itemsql);
		
			var updateqry = "UPDATE `orders` SET `OrderCurrentStatus`='"+paymentstatus+"' WHERE `OrderId`='"+OrderId+"'";
			var result  = await db.query(updateqry);

			var orderitemstatus = '';
			if(paymentstatus === '12'){
				orderitemstatus = '14';
			}else if(paymentstatus === '11'){
				orderitemstatus = '13'
			}else if(paymentstatus === '2'){
				orderitemstatus = '7'
			}else{
				orderitemstatus = '6';
			}
			
			var updateitemqry = "UPDATE `order_items` SET OrderItemStatusNo='"+orderitemstatus+"' WHERE OrderNo='"+OrderId+"'";
			var result1  = await db.query(updateitemqry);
			var statussql = "SELECT EmailEnabled,EmailTemplate,EmailSubject from  order_status where OrderStatusId = "+paymentstatus
			var statusresult  = await db.query(statussql);
			if(statusresult.length > 0){
					if(statusresult[0].EmailEnabled == '1' && statusresult[0].EmailTemplate != '' && statusresult[0].EmailSubject){
						var OrderCurrentStatus = orderdata[0].OrderCurrentStatus;
						var OrderNo = orderdata[0].OrderNo;
						var emailsubject = ''
						var templatename = statusresult[0].EmailTemplate
						if(statusresult[0].EmailSubject){
							emailsubject  = statusresult[0].EmailSubject.replace("<OrderNo>", OrderNo);
						}
						var toEmail = orderdata[0].CustomerOrderBillingEmail;
						var customerName = orderdata[0].CustomerOrderBillingFirstName+' '+orderdata[0].CustomerOrderBillingLastName;
						var transporter = nodemailer.createTransport(
							{
								port: process.env.SmtpPort,
								secure: true,
								host: process.env.SmtpHost,
								auth:{
									user: process.env.SmtpUser,
									pass: process.env.SmtpPassword
								},
								from: process.env.SmtpUser
							}
						);
						// point to the template folder
						const handlebarOptions = {
							viewEngine: {
								partialsDir: path.resolve('./emailslayout/'),
								defaultLayout: false,
							},
								viewPath: path.resolve('./emailslayout/'),
						};
						// use a template file with nodemailer
						transporter.use('compile', hbs(handlebarOptions));    
						var mailOptions = {
							from: process.env.SmtpUser,
							to: toEmail,
							subject: emailsubject,
							template: templatename,
							context:{
								track_order: '',
								img_url: '',
								product_img_url: '',
								orderData: orderdata[0],
								orderItemData: orderItemsData,
								name: customerName,
								company: 'My Company'
							},
						}
						transporter.sendMail(mailOptions, async function(error, info){
						if(error){}else{}
						})	
					}
				}
				await db.end()

			return  res.status(200).json({ 'CODE':200,msg:'Order update succssfully'})
				
		}
		else{
			return  res.status(200).json({ 'CODE':500,msg:'Oops something went wrong' ,'col':1})
		}
	}
	catch (err) {
		await db.end()	
		return res.status(200).send({ 'CODE':500 ,'msg': 'failed to fetch data',err})
	}
	
}