import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';
export default async function handler(req, res) {
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD  
		}
	})
	
	var saveresponse = req.body.saveresponse
	var orderid = req.body.orderid
	var paymentmethod = req.body.paymentmethod
	var savetransactionid = req.body.savetransactionid
	
	if(saveresponse){
		saveresponse = JSON.stringify(saveresponse)
	}
	
	var sqldata= []
	
	sqldata.push(paymentmethod)
	sqldata.push(orderid)
	sqldata.push(saveresponse)
	sqldata.push(savetransactionid)
	
	var sql = "Insert into payment_logs (`PyamentMethodNo`, `OrderNo`, `PaymentResponse`, `TransactionId`) VALUES (? , ?, ? ,?)"
	try {
		var  results  = await db.query(sql,sqldata)
		var message = 'success';
	}catch(err){
		var message = 'error';
	}
	
	res.status(200).send({ 'message':message })
	
}