import { getGeo } from 'geoplugin';
import {getGeoByIp} from 'geoplugin';
import mysql from 'serverless-mysql';
import config from '../../config/config';

export default async function handler(req, res) {

    const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD   
		}
	})


	var ip = req.query.ip
	let itemsList = await db.query(`SELECT CountryId,CountryName,CurrencyRate,CurrencySymbol,CountryCode,CurrencyCode,CurrencyName,CurrencyCode as name FROM delivery_coutries_master where Status = 1 and showinNavbar = 1 order By CountryId asc`) ;
	
	var default_currency = itemsList[0];
	var current_currency = default_currency;
	var x = {}
	if(ip){
		x = await getGeoByIp(ip)
		const nccode = await x.countryCode
		await Promise.all(itemsList.map(async (vals, inds) => {
			if (vals.CountryCode.trim() == nccode) {
				  vals.index = inds
				  vals.geo = x
				  current_currency = await vals
				}
		}));
		res.status(200).json({current_currency:current_currency, all_currency:itemsList, GeoData:x })
	}else{
		res.status(200).json({current_currency:current_currency, all_currency:itemsList, GeoData:x })
	}

	await db.end();
}