import { useRouter } from 'next/router';
import mysql from 'serverless-mysql';
import config from '../../../config/config';
export default async function handler(req, res) {
	const db = mysql({
		config: {  
			host: process.env.DB_HOST,   
			port: process.env.DB_PORT,  
			database: process.env.DB_DATABASE, 
			user: process.env.DB_USER, 
			password: process.env.DB_PASSWORD  
		}
	})
	var reqSlug = req.query.furl
	var pageLayout = []
	var sresults = []
	var PageStatus = ''
	var PageCountry = ''
	var PageFooterContent = []
	var PageMetaDescription = []
	var PageMetaKeywords = []
	var TwitterCard = []
	var TwitterTitle = []
	var TwitterDescription = []
	var TwitterImage = []
	var PageOgtitle = []
	var PageOgDescription = []
	var PageSeoSchema = []
	var PageMetaTitle = ''
	var pageImage = ''
	var PageFooterContentArray = []
	var CatCountry = ''
	var pageslug = ''
	var rootbreadcrumbText = ''
	var rootbreadcrumbLink = ''
	var breadcrumbtext = ''	
	
	var slug = db.escape(reqSlug);

	let results  = await db.query(`SELECT * FROM core_url_rewrite where Slug = ${slug} LIMIT 1`)
	
	if(results.length > 0){
		var CoreType = results[0].CoreType
		var TypeId   = results[0].TypeId
		if( CoreType == 2 ){
			var pagesql = "SELECT * FROM `pages` p left join page_content pc on pc.pageNo  = p.PageId left join page_seo_content psc on psc.pageNo  = p.PageId where p.PageId = "+TypeId
			var presults  = await db.query(pagesql)
			if(presults.length > 0){
				pageLayout = JSON.parse(presults[0].PageLayout)
				PageStatus = presults[0].PageStatus
				PageCountry = presults[0].PageCountry
				PageFooterContentArray = JSON.parse(presults[0].PageFooterContent)
				PageFooterContent = PageFooterContentArray[0].Footercontent
				if(PageFooterContent == 'null'){
					PageFooterContent = ''
				}
				PageSeoSchema = presults[0].PageSeoSchema
				if(PageSeoSchema == 'null'){
					PageSeoSchema = ''
				}
				PageMetaTitle = presults[0].PageMetaTitle
				if(PageMetaTitle == 'null'){
					PageMetaTitle = ''
				}
				PageMetaDescription = presults[0].PageMetaDesc
				if(PageMetaDescription == 'null'){
					PageMetaDescription = ''
				}
				PageMetaKeywords = presults[0].PageMetaKeywords
				if(PageMetaKeywords == 'null'){
					PageMetaKeywords = ''
				}
				TwitterCard = presults[0].TwitterCard
				if(TwitterCard == 'null'){
					TwitterCard = ''
				}
				TwitterTitle = presults[0].TwitterTitle
				if(TwitterTitle == 'null'){
					TwitterTitle = ''
				}
				TwitterDescription = presults[0].TwitterDescription
				if(TwitterDescription == 'null'){
					TwitterDescription = ''
				}
				TwitterImage = presults[0].TwitterImage
				if(TwitterImage == 'null'){
					TwitterImage = ''
				}
				pageslug = presults[0].PageSlug
				rootbreadcrumbText = presults[0].PageName
				
				if(TwitterImage){
					TwitterImage = config.occassionPageTwitterimageurl+TwitterImage
				}
				PageOgtitle = presults[0].PageOgtitle
				
				PageOgDescription = presults[0].PageOgDescription
				pageImage = presults[0].PageOgImage
				if(pageImage){
					pageImage = config.occassionPageOgimageurl+pageImage
				}
				if(PageStatus !== 1){
					res.status(404).json({ results: '' })
				}
				
				var sliderid = presults[0].PageSlider
				if(sliderid){
					var slidersql = "SELECT * FROM `slider_slides` where SliderNo = "+sliderid+" order By SliderPos asc"
					sresults  = await db.query(slidersql)
				}
				
			}
			await db.end()
			res.status(200).json({
				pageLayout,
				PageStatus,
				Countryid:PageCountry,
				PageFooterContent,
				SeoSchema:PageSeoSchema,
				MetaTitle:PageMetaTitle,
				MetaDescription:PageMetaDescription,
				MetaKeywords:PageMetaKeywords,
				TwitterCard,
				TwitterTitle,
				TwitterDescription,
				TwitterImage,
				ogTitle:PageOgtitle,
				ogDescription:PageOgDescription,
				ogImage:pageImage,
				CoreType:CoreType,
				TypeId:TypeId,
				TypeId:TypeId,
				pageslug:pageslug,
				rootbreadcrumbText:'',
				rootbreadcrumbLink:'',
				breadcrumbtext:'',
				sliderData:sresults
				})
		}else{
			var  pr_results = []
			var  CatName = '';
			var  CategorySlug = '';
			var  CategoryTitle = '';
			var  CategoryFooterContent = '';
			var  CategoryHeaderContent = '';
			var  CatgeorySeoSchema = '';
			var  CategoryMetaTitle = '';
			var  CategoryMetaDesc = '';
			var  CatgeoryMetaKeywords = '';
			var  TwitterCard = '';
			var  TwitterTitle = '';
			var  TwitterDescription = '';
			var  TwitterImage = '';
			var  CatStatus = '';
			var  CatOgTitle = '';
			var  CatOgDescription = '';
			var  CatOgImage = '';
			var  CatImage = '';
			var  CategoryTopSectionlayoutArray = [];
			var  CategoryTopSectionlayout = [];
			var  CatCountry = '';
			var rootbreadcrumbText = ''
			var rootbreadcrumbLink = ''
			var breadcrumbtext = ''
			
			var catsql = "SELECT * FROM `categories` where CatId = "+TypeId
			var cresults  = await db.query(catsql)
			
			if(cresults.length > 0){
				
				
					CatName = cresults[0].CatName
					CatCountry = cresults[0].CatCountry
					CategorySlug = cresults[0].CategorySlug
					CategoryTitle = cresults[0].CategoryTitle
					if(CategoryTitle == 'null'){
						CategoryTitle = '';
					}
					PageFooterContent = cresults[0].CategoryFooterContent
					if(PageFooterContent == 'null'){
						PageFooterContent = '';
					}
					CategoryHeaderContent = cresults[0].CategoryHeaderContent
					if(CategoryHeaderContent == 'null'){
						CategoryHeaderContent = '';
					}
					CatgeorySeoSchema = cresults[0].CatgeorySeoSchema
					if(CatgeorySeoSchema == 'null'){
						CatgeorySeoSchema = '';
					}
					CategoryMetaTitle = cresults[0].CategoryMetaTitle
					if(CategoryMetaTitle == 'null'){
						CategoryMetaTitle = '';
					}
					CategoryMetaDesc = cresults[0].CategoryMetaDesc
					if(CategoryMetaDesc == 'null'){
						CategoryMetaTitle = '';
					}
					CatgeoryMetaKeywords = cresults[0].CatgeoryMetaKeywords
					if(CatgeoryMetaKeywords == 'null'){
						CatgeoryMetaKeywords = '';
					}
					TwitterCard = cresults[0].TwitterCard
					if(TwitterCard == 'null'){
						TwitterCard = '';
					}
					TwitterTitle = cresults[0].TwitterTitle
					if(TwitterTitle == 'null'){
						TwitterTitle = '';
					}
					TwitterDescription = cresults[0].TwitterDescription
					if(TwitterDescription == 'null'){
						TwitterDescription = '';
					}
					TwitterImage = cresults[0].TwitterImage
					if(TwitterImage == 'null'){
						TwitterImage = '';
					}
					pageslug = cresults[0].CategorySlug
					if(cresults[0].ParentId =='0'){
						rootbreadcrumbText = cresults[0].CatName
						rootbreadcrumbLink = ''
						breadcrumbtext = ''
					}else{
						var hierarchy = (cresults[0].Category).split("/")
						var parenthierarchycat = hierarchy[0];
						if(parenthierarchycat){
							var breadcrumbsql = "SELECT CatName,CategorySlug FROM `categories` where CatName = '"+parenthierarchycat+"' limit 1";
							var breadcrumresult  = await db.query(breadcrumbsql)
							if(breadcrumresult.length > 0){
								rootbreadcrumbText = breadcrumresult[0].CatName
								rootbreadcrumbLink = breadcrumresult[0].CategorySlug
								breadcrumbtext = cresults[0].CatName
							}else{
								rootbreadcrumbText = cresults[0].CatName
								rootbreadcrumbLink = ''
								breadcrumbtext = ''
							}
						}else{
							rootbreadcrumbText = cresults[0].CatName
							rootbreadcrumbLink = ''
							breadcrumbtext = ''
						}
					}
					
					if(TwitterImage){
						TwitterImage = config.catPageTwitterimageurl+TwitterImage
					}
					CatStatus = cresults[0].CatStatus
					CatOgTitle = cresults[0].CatOgTitle
					CatOgDescription = cresults[0].CatOgDescription
					CatOgImage = cresults[0].CatOgImage
					if(CatOgImage){
						CatOgImage = CatOgImage
					}
					CatImage = cresults[0].CatImage
					CategoryTopSectionlayoutArray = cresults[0].CategoryTopSectionlayout
					if(CategoryTopSectionlayoutArray){
						CategoryTopSectionlayout = JSON.parse(CategoryTopSectionlayoutArray)
					}
					
					if(CatStatus == 0){
						res.status(404).json({ results: '' })
					}
				
				
			}
			await db.end()
			
			res.status(200).json({
				CatName,
				CategorySlug,
				Countryid:CatCountry,
				CategoryTitle,
				PageFooterContent,
				CategoryHeaderContent,
				SeoSchema:CatgeorySeoSchema,
				MetaTitle:CategoryMetaTitle,
				MetaDescription:CategoryMetaDesc,
				MetaKeywords:CatgeoryMetaKeywords,
				TwitterCard,
				TwitterTitle,
				TwitterDescription,
				TwitterImage,
				ogTitle:CatOgTitle,
				ogDescription:CatOgDescription,
				ogImage: CatOgImage,
				CatImage,
				CategoryTopSectionlayout:CategoryTopSectionlayout,
				CoreType:CoreType,
				CatId:TypeId,
				CategorySlug:CategorySlug,
				pageslug:pageslug,
				products:[],
				rootbreadcrumbText:rootbreadcrumbText,
				rootbreadcrumbLink:rootbreadcrumbLink,
				breadcrumbtext:breadcrumbtext,
				})
		}
	}else{
		await db.end()
		res.status(404).json({ results: '','a':'' })
	}
	
	
	
	
}