import React, { useState, useEffect } from 'react';
import { getCsrfToken } from "next-auth/react"
import Footer from '../../components/Footer/Footer';
import Navbar from "../../components/Navbar/Navbar";
import Grid from '@material-ui/core/Grid';
import Head from 'next/head';
import { AiOutlineMail } from "react-icons/ai";
import { BsTelephone } from "react-icons/bs";
import Accordion from '@mui/material/Accordion';
import AccordionSummary from '@mui/material/AccordionSummary';
import Typography from '@mui/material/Typography';
import { MdExpandMore } from "react-icons/md";
import Popup from 'reactjs-popup';
import 'reactjs-popup/dist/index.css';
import { AiOutlineHome } from "react-icons/ai";
import { useSession, getSession, signIn, signOut } from "next-auth/react";
import config from '../../config/config'
import Link from 'next/link';
import Image from 'next/image'
import { AustraliaStates } from '../../components/CommonFunctions/Adress/AustraliaStates';
import { IndiaStates } from '../../components/CommonFunctions/Adress/IndiaStates';
import { UsaStates } from '../../components/CommonFunctions/Adress/UsaStates';
import { GermanyStates } from '../../components/CommonFunctions/Adress/GermanyStates';
import { UkStates } from '../../components/CommonFunctions/Adress/UkStates';
import { CanadaStates } from '../../components/CommonFunctions/Adress/CanadaStates';
import { UaeStates } from '../../components/CommonFunctions/Adress/UaeStates';
export default function Dashboard({ csrfToken, providers, currentCurrency, AllCurrencyData, GeoData }) {

	const { data: session } = useSession();
	const [loading, setloading] = useState(true)
	const [open, setOpen] = useState(false);
	const closeModal = () => setOpen(false);
	const [ShowState, setShowState] = useState(true);

	const [ContactId, setContactId] = useState('')
	const [ContactName, setContactName] = useState('')
	const [ContactEmail, setContactEmail] = useState('')
	const [ContactPassword, setContactPassword] = useState('')
	const [ContactConfirmPassword, setContactConfirmPassword] = useState('')
	const [PassConfirmPasswordnomatch, setPassConfirmPasswordnomatch] = useState(false)
	const [ContactData, setContactData] = useState([])

	const [ContactNameErr, setContactNameErr] = useState(false)
	const [ContactEmailErr, setContactEmailErr] = useState(false)
	const [ContactPasswordErr, setContactPasswordlErr] = useState(false)
	const [ContactSuccessmesage, setContactSuccessmesage] = useState(false)

	const [CustomerBillingButton, setCustomerBillingButton] = useState('Add')
	const [CustomerBillingName, setCustomerBillingName] = useState('')
	const [CustomerBillingId, setCustomerBillingId] = useState('')
	const [CustomerBillingLastName, setCustomerBillingLastName] = useState('')
	const [CustomerBillingEmail, setCustomerBillingEmail] = useState('')
	const [CustomerBillingPhone, setCustomerBillingPhone] = useState('')
	const [CustomerBillingData, setCustomerBillingData] = useState('')

	const [CustomerBillingNameErr, setCustomerBillingNameErr] = useState(false)
	const [CustomerBillingEmailErr, setCustomerBillingEmailErr] = useState(false)
	const [CustomerBillingPhoneErr, setCustomerBillingPhoneErr] = useState(false)
	const [CustomerBillingSuccessmesage, setCustomerBillingSuccessmesage] = useState(false)

	const [CustomerShippingName, setCustomerShippingName] = useState('')
	const [CustomerShippingLastname, setCustomerShippingLastname] = useState('')
	const [CustomerShippingAddress, setCustomerShippingAddress] = useState('')
	const [CustomerShippingCity, setCustomerShippingCity] = useState('')
	const [CustomerShippingState, setCustomerShippingState] = useState('')
	const [CustomerShippingPincode, setCustomerShippingPincode] = useState('')
	const [CustomerShippingPhone, setCustomerShippingPhone] = useState('')
	const [CustomerShippingCountry, setCustomerShippingCountry] = useState('')
	const [CustomerShippingData, setCustomerShippingData] = useState('')
	const [ShippingEditId, setShippingEditId] = useState('')

	const [CustomerShippingNameerr, setCustomerShippingNameerr] = useState('')
	const [CustomerShippingLastnameerr, setCustomerShippingLastnameerr] = useState('')
	const [CustomerShippingAddresserr, setCustomerShippingAddresserr] = useState('')
	const [CustomerShippingCityerr, setCustomerShippingCityerr] = useState('')
	const [CustomerShippingPincodeerr, setCustomerShippingPincodeerr] = useState('')
	const [CustomerShippingPhoneerr, setCustomerShippingPhoneerr] = useState('')
	const [CustomerShippingStateerr, setCustomerShippingStateerr] = useState('')
	const [CustomerShippingCountryerr, setCustomerShippingCountryerr] = useState('')

	const [DeliveryCountries, setDeliveryCountries] = useState('')

	const [bilopen, setbilopen] = useState(false)
	const [contactopen, setcontactopen] = useState(false)

	const ShippingModal = () => (<Popup trigger={<button className="button"> Open Modal </button>} modal>    <span> Modal content </span>  </Popup>);

	useEffect(() => {
		const securepage = async () => {
			const session = await getSession()
			if (!session) {
				signIn()
			} else {
				setloading(false)
				var email = session.user.email
				getCustomerdata(email)
			}
		}
		securepage()
		getdelcountries()
	}, [])

	async function getCustomerdata(email) {
		var url = `${config.apiUrl}auth/customer/?customeremail=${email}`
		const res = await fetch(url)
		const data = await res.json()
		if (data.results.length > 0) {
			setContactId(data.results[0].CustomerID)
			setContactName(data.results[0].CustomerName)
			setContactEmail(data.results[0].CustomerEmail)
			setContactData(data.results[0])

		}
		if (data.billingAddress.length > 0) {
			setCustomerBillingButton('Edit')
			setCustomerBillingData(data.billingAddress[0])
			setCustomerBillingName(data.billingAddress[0].CustomerBillingFirstName)
			setCustomerBillingId(data.billingAddress[0].CustomerBillingAdressId)
			setCustomerBillingLastName(data.billingAddress[0].CustomerBillingLastName)
			setCustomerBillingEmail(data.billingAddress[0].CustomerBillingEmail)
			setCustomerBillingPhone(data.billingAddress[0].CustomerBillingPhone)
		}
		if (data.shippingAddress.length > 0) {
			setCustomerShippingData(data.shippingAddress)
		}
	}

	function HideErrmsgs() {
		setContactNameErr(false)
		setContactEmailErr(false)
		setContactPasswordlErr(false)
		setCustomerBillingNameErr(false)
		setCustomerBillingEmailErr(false)
		setCustomerBillingPhoneErr(false)
		setCustomerShippingNameerr(false)
		setCustomerShippingLastnameerr(false)
		setCustomerShippingAddresserr(false)
		setCustomerShippingCityerr(false)
		setCustomerShippingPincodeerr(false)
		setCustomerShippingPhoneerr(false)
		setCustomerShippingStateerr(false)
		setCustomerShippingCountryerr(false)
	}

	function hidesuccessmsgs() {
		setContactSuccessmesage(false)
		setCustomerBillingSuccessmesage(false)
	}

	function getContactName(e) {
		var value = e.target.value
		setContactName(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getContactEmail(e) {
		var value = e.target.value
		setContactEmail(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getContactPassword(e) {
		var value = e.target.value
		setContactPassword(value);
		matchPassword(value, ContactConfirmPassword)
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getContactConfirmPassword(e) {
		var value = e.target.value
		setContactConfirmPassword(value);
		HideErrmsgs()
		hidesuccessmsgs()
		matchPassword(ContactPassword, value)
	}

	function matchPassword(passs, confrimpass) {
		if (!passs && !confrimpass) {

			setPassConfirmPasswordnomatch(false)
		}
		else if (passs != confrimpass) {
			setPassConfirmPasswordnomatch(true)
		}
		else {
			setPassConfirmPasswordnomatch(false)
		}
	}

	async function saveContatctinformation(e) {
		if (!ContactName) {
			setContactNameErr(true)

		} else if (!ContactEmail) {
			setContactEmailErr(true)

		}
		else if (PassConfirmPasswordnomatch) {
			setContactPasswordlErr(true)
		} else {
			const registerResp = await fetch(`${config.apiUrl}auth/customer/savecontactinfo`, {
				method: "POST",
				body: JSON.stringify({ ContactName: ContactName, ContactEmail: ContactEmail, pwd: ContactPassword, ContactId: ContactId }),
				headers: {
					"Content-Type": "application/json",
				},
			}).then(function (response) {
				if (response.status == 200) {
					setcontactopen(false);

					var data = {
						'CustomerName': ContactName,
						'CustomerEmail': ContactEmail
					}
					setContactData(data)

				} else {

				}
			});
		}
	}

	function getCustomerBillingName(e) {
		var value = e.target.value
		setCustomerBillingName(value);

		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerBillingEmail(e) {
		var value = e.target.value
		setCustomerBillingEmail(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerBillingPhone(e) {
		var value = e.target.value
		setCustomerBillingPhone(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerBillingLastName(e) {
		var value = e.target.value
		setCustomerBillingLastName(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	async function getdelcountries() {
		var url = `${config.apiUrl}deliverycountry/`
		const res = await fetch(url)
		const data = await res.json()
		setDeliveryCountries(data.results)
	}

	async function saveCustomerBillinginformation(e) {

		if (!CustomerBillingName) {
			setCustomerBillingNameErr(true)
		} else if (!CustomerBillingEmail) {
			setCustomerBillingEmailErr(true)
		}
		else if (!CustomerBillingPhone) {
			setCustomerBillingPhoneErr(true)
		} else {
			const registerResp = await fetch(`${config.apiUrl}auth/customer/savebillinginfo`, {
				method: "POST",
				body: JSON.stringify({
					CustomerBillingName: CustomerBillingName,
					CustomerBillinglastName: CustomerBillingLastName,
					CustomerBillingEmail: CustomerBillingEmail,
					CustomerBillingId: CustomerBillingId,
					CustomerNo: ContactId,
					CustomerBillingPhone: CustomerBillingPhone
				}),
				headers: {
					"Content-Type": "application/json",
				},
			}).then(function (response) {
				if (response.status == 200) {
					setbilopen(false);

					var data = {
						'CustomerBillingFirstName': CustomerBillingName,
						'CustomerBillingLastName': CustomerBillingLastName,
						'CustomerBillingEmail': CustomerBillingEmail,
						'CustomerBillingPhone': CustomerBillingPhone,
					}
					setCustomerBillingData(data)

				} else {

				}
			});
		}
	}

	async function saveCustomerShippingformation(e) {	

		if (!CustomerShippingName) {
			setCustomerShippingNameerr(true)
		} else if (!CustomerShippingLastname) {
			setCustomerShippingLastnameerr(true)
		}
		else if (!CustomerShippingAddress) {
			setCustomerShippingAddresserr(true)
		}
		else if (!CustomerShippingCity) {
			setCustomerShippingCityerr(true)
		}
		else if (!CustomerShippingPincode) {
			setCustomerShippingPincodeerr(true)
		}
		else if (!CustomerShippingState) {
			if(CustomerShippingCountry === 33){
			}else{
				setCustomerShippingStateerr(true)
			}			
		}
		else if (!CustomerShippingCountry) {
			setCustomerShippingCountryerr(true)
		}
		else if (!CustomerShippingPhone) {
			setCustomerShippingPhoneerr(true)
		}

		else {
			const registerResp = await fetch(`${config.apiUrl}auth/customer/saveshippinginfo`, {
				method: "POST",
				body: JSON.stringify({
					CustomerShippingName: CustomerShippingName,
					CustomerShippingLastname: CustomerShippingLastname,
					CustomerShippingAddress: CustomerShippingAddress,
					CustomerShippingCity: CustomerShippingCity,
					CustomerShippingState: CustomerShippingState,
					CustomerShippingPincode: CustomerShippingPincode,
					CustomerShippingPhone: CustomerShippingPhone,
					CustomerShippingCountry: CustomerShippingCountry,
					ShippingEditId: ShippingEditId,
					CustomerNo: ContactId,
					AllCountry: 'Yes',

				}),
				headers: {
					"Content-Type": "application/json",
				},
			}).then(response => {
				return response.json();  // <---- this is important
			}).then(function (response) {
				
				if (response.CODE == 200) {
					setCustomerShippingData(response.shippingAddress)
					setOpen(o => !o)
				} else {
				}
			});
		}
	}

	function showContactPopup(e) {
		e.preventDefault();
		setcontactopen(true);
	}

	function showBillPopup(e) {
		e.preventDefault();
		setbilopen(true);
	}

	function showPopup(e, CustomerShippingFirstName, CustomerShippingLastName, CustomerShippingCompany, CustomerShippingAddress, CustomerShippingCity, CustomerShippingState, CustomerShippingPincode, CustomerShippingPhone, CustomerShippingCountryNo, ShippingEditId) {
		e.preventDefault();
		setCustomerShippingPhone(CustomerShippingPhone)
		setCustomerShippingPincode(CustomerShippingPincode)
		setCustomerShippingCity(CustomerShippingCity)
		setCustomerShippingState(CustomerShippingState)
		setCustomerShippingCountry(CustomerShippingCountryNo)
		setCustomerShippingLastname(CustomerShippingLastName)
		setCustomerShippingName(CustomerShippingFirstName)
		setCustomerShippingAddress(CustomerShippingAddress)
		setShippingEditId(ShippingEditId)
		setOpen(o => !o)

		if(CustomerShippingCountryNo === 33){
			setShowState(false)
		}else{
			setShowState(true)
		}
	}

	function getCustomerShippingPhone(e) {
		var value = e.target.value
		setCustomerShippingPhone(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippingPincode(e) {
		var regex = /[`!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?~]/g;
		setCustomerShippingPincode(e.target.value.replace(regex, ""));
		// var value = e.target.value
		// setCustomerShippingPincode(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippingCity(e) {
		var value = e.target.value
		setCustomerShippingCity(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippingState(e) {
		var value = e.target.value
		setCustomerShippingState(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippingCountry(e) {
		var value = e.target.value
		setCustomerShippingCountry(value);
		setCustomerShippingState('')
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippinglastName(e) {
		var value = e.target.value
		setCustomerShippingLastname(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippingName(e) {
		var value = e.target.value
		setCustomerShippingName(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	function getCustomerShippingAddress(e) {
		var value = e.target.value
		setCustomerShippingAddress(value);
		HideErrmsgs()
		hidesuccessmsgs()
	}

	return (
		<>
			{(loading) ?
				<>
					<span className="ew-guest-loder align-items-center justify-content-center d-flex w-100 ">
						<img
							src='/loading.gif' className="loader" alt="loader"
						/>
					</span>
				</>
				:
				<>
					<div className='maincointainer' key='div1'>
						<Head>
							<title>Accounts - 1800rakhis</title>
						</Head>
						<div className='somehideflag'>
							<Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />
						</div>
						<div className='dashboard_main_container'>
							<Grid item md={12} sm={12} xs={12} className="dashbord_acc_sec"  >

								<div className='dashboard_according'>
									<Accordion className='dashboard_acc'>
										<AccordionSummary

											aria-controls="panel1a-content"
											id="panel1a-header"
										>
											<Typography className='acc_head'>Contact-Information</Typography>
											<MdExpandMore width="13" className='ExpandMore' />
										</AccordionSummary>

										<Typography className='Expand_data'>
											<div className='Contact-box-body'>
												{(ContactData) ?
													<>
														<div className='billingeditwrapper'>
															<div className='billingeditinnerwrapper'>
																<p>{ContactData.CustomerName}</p>
																<div className='customer_billing_email'>
																	<AiOutlineMail width="15" /><p>{ContactData.CustomerEmail}</p>
																</div>
																<div className='customer_billing_phone'>
																	<BsTelephone width="15" /><p>{ContactData.CustomerPhone}</p>
																</div>
															</div>

															<div className="editcontainer">
																<button onClick={(e) => showContactPopup(e)} >Edit</button>
															</div>
														</div>

													</>
													:
													<>
														<div className="editcontainer">
															<button onClick={(e) => showContactPopup(e)} >Add</button>
														</div>
													</>
												}
											</div>
											<Popup
												open={contactopen}
												modal
												nested>
												{close => (
													<div className="modal modal_edit">
														<button className="close" onClick={close}>
															&times;
														</button>
														<div className="header"> <h4>Edit Contact Information</h4> </div>


														<div className="errdivpopup">
															{(ContactNameErr) ?
																<span>First Name is required</span>
																:
																''
															}
															{(ContactEmailErr) ?
																<span>Contact Email is required</span>
																:
																''
															}
															{(ContactPasswordErr) ?
																<span>password does not match</span>
																:
																''
															}
														</div>



														<div className="dashboard_content">
															{' '}
															<div className='edit-contact'>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={ContactName} onChange={(e) => getContactName(e)} />
																		<label>First Name</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={ContactEmail} onChange={(e) => getContactEmail(e)} />
																		<label>Email Address</label>
																	</div>
																</div>
															</div>
															<div className='edit-contact'>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="password" required name="username" value={ContactPassword} onChange={(e) => getContactPassword(e)} />
																		<label>New Password</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={ContactConfirmPassword} onChange={(e) => getContactConfirmPassword(e)} />
																		<label>Confirm New Password</label>
																	</div>
																</div>

															</div>

															<button type="submit" className="register_submit  procartbtn" onClick={(e) => saveContatctinformation(e)}>Save</button>

														</div>

													</div>
												)}
											</Popup>

										</Typography>

									</Accordion>

									<Accordion className='dashboard_acc'>
										<AccordionSummary

											aria-controls="panel1a-content"
											id="panel1a-header"
										>
											<Typography>Billing Information</Typography>
											<MdExpandMore width="13" className='ExpandMore' />
										</AccordionSummary>

										<Typography className='Expand_data'>
											<div className='Contact-box'>
												<div className='Contact-box-body'>

													{(CustomerBillingData) ?
														<>
															<div className='billingeditwrapper'>
																<div className='billingeditinnerwrapper'>
																	<p>{CustomerBillingData.CustomerBillingFirstName} {CustomerBillingData.CustomerBillingLastName}</p>
																	<div className='customer_billing_email'>
																		<AiOutlineMail width="15" /><p>{CustomerBillingData.CustomerBillingEmail}</p>
																	</div>
																	<div className='customer_billing_phone'>
																		<BsTelephone width="15" /><p>{CustomerBillingData.CustomerBillingPhone}</p>
																	</div>
																</div>
																<div className="editcontainer">
																	<button onClick={(e) => showBillPopup(e)} >Edit</button>
																</div>
															</div>
														</>
														:
														<>
															<div className="editcontainer">
																<button onClick={(e) => showBillPopup(e)} >Add</button>
															</div>
														</>
													}

												</div>
											</div>


											<Popup
												open={bilopen}
												modal
												nested>
												{close => (
													<div className="modal modal_edit">
														<button className="close" onClick={close}>
															&times;
														</button>
														<div className="header"> <h4>Edit Billing Information</h4> </div>

														<div className="errdivpopup">
															{(CustomerBillingNameErr) ?
																<span>Customer Billing Name is required</span>
																:
																''
															}
															{(CustomerBillingEmailErr) ?
																<span>Customer Billing Email is required</span>
																:
																''
															}
															{(CustomerBillingPhoneErr) ?
																<span>Customer Billing Phone is required</span>
																:
																''
															}
														</div>

														<div className="dashboard_content">
															{' '}
															<div className='edit-contact'>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerBillingName} onChange={(e) => getCustomerBillingName(e)} />
																		<label>First Name</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerBillingLastName} onChange={(e) => getCustomerBillingLastName(e)} />
																		<label>Last Name</label>
																	</div>
																</div>
															</div>

															<div className='edit-contact'>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerBillingEmail} onChange={(e) => getCustomerBillingEmail(e)} />
																		<label>Email</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerBillingPhone} onChange={(e) => getCustomerBillingPhone(e)} />
																		<label>Phone</label>
																	</div>
																</div>

															</div>

															<button type="submit" className="register_submit  procartbtn" onClick={(e) => saveCustomerBillinginformation(e)}>Save</button>

														</div>

													</div>
												)}
											</Popup>
										</Typography>

									</Accordion>

									<Accordion className='dashboard_acc'>
										<AccordionSummary
											aria-controls="panel1a-content"
											id="panel1a-header"
										>
											<Typography>Shipping Information</Typography>
											<MdExpandMore width="13" className='ExpandMore' />
										</AccordionSummary>

										<Typography className='Expand_data'>

											{CustomerShippingData ?
												<>
													{CustomerShippingData.map((val, ind) => {
														
														var CustomerShippingAddress = val.CustomerShippingAddress;
														CustomerShippingAddress = CustomerShippingAddress.replace(/^'(.*)'$/, '$1');
														CustomerShippingAddress = CustomerShippingAddress.replace(/\\/g, '');

														var CustomerShippingFirstName = val.CustomerShippingFirstName;
														CustomerShippingFirstName = CustomerShippingFirstName.replace(/^'(.*)'$/, '$1');
														CustomerShippingFirstName = CustomerShippingFirstName.replace(/\\/g, '');

														var CustomerShippingLastName = val.CustomerShippingLastName;
														CustomerShippingLastName = CustomerShippingLastName.replace(/^'(.*)'$/, '$1');
														CustomerShippingLastName = CustomerShippingLastName.replace(/\\/g, '');

														var CustomerShippingCity = val.CustomerShippingCity;
														CustomerShippingCity = CustomerShippingCity.replace(/^'(.*)'$/, '$1');
														CustomerShippingCity = CustomerShippingCity.replace(/\\/g, ''); 


														return (
															<>
																<div className='contactshipflx' key={ind} >
																	<div className='Contact-box-body'>
																		<p>{CustomerShippingFirstName} {CustomerShippingLastName}</p>
																		<div className='ship_add'>
																			<AiOutlineHome width="15" />
																			<p>{CustomerShippingAddress} {CustomerShippingCity}, {val.CustomerShippingState}, {val.CountryName}, {val.CustomerShippingPincode}</p>
																		</div>
																		<div className='ship_phn'>
																			<BsTelephone width="15" />
																			<p>{val.CustomerShippingPhone}</p>
																		</div>
																	</div>
																	<div className="editcontainer">
																		<button onClick={(e) => showPopup(e, CustomerShippingFirstName, CustomerShippingLastName, val.CustomerShippingCompany, CustomerShippingAddress, CustomerShippingCity, val.CustomerShippingState, val.CustomerShippingPincode, val.CustomerShippingPhone, val.CustomerShippingCountryNo, val.CustomerAddressBookId)} >edit</button>
																	</div>
																</div>
															</>
														)
													}
													)}
												</>
												:
												<>
													<div className="editcontainer">
														<button onClick={(e) => showPopup(e, '', '', '', '', '', '', '', '', '', '')} >edit</button>
													</div>
												</>
											}
											<Popup open={open} onClose={closeModal}
												modal
												nested>
												{close => (
													<div className="modal modal_edit">
														<button className="close" onClick={close}>
															&times;
														</button>
														<div className="header"> <h4>Shipping Address</h4> </div>

														<div className="errdivpopup">
															{(CustomerShippingNameerr) ?
																<span>Shipping Name is required</span>
																:
																''
															}
															{(CustomerShippingLastnameerr) ?
																<span>Shipping Last Name is required</span>
																:
																''
															}
															{(CustomerShippingCountryerr) ?
																<span>Shipping Country is required</span>
																:
																''
															}
															{(CustomerShippingStateerr) ?
																<span>Shipping State is required</span>
																:
																''
															}
															{(CustomerShippingAddresserr) ?
																<span>Shipping Address is required</span>
																:
																''
															}
															{(CustomerShippingCityerr) ?
																<span>Shipping City is required</span>
																:
																''
															}
															{(CustomerShippingPincodeerr) ?
																<span>Shipping Pincode is required</span>
																:
																''
															}

															{(CustomerShippingPhoneerr) ?
																<span>Shipping Phone is required</span>
																:
																''
															}

														</div>

														<div className="dashboard_content">
															{' '}
															<div className='edit-contact'>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerShippingName} onChange={(e) => getCustomerShippingName(e)} />
																		<label>First Name</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerShippingLastname} onChange={(e) => getCustomerShippinglastName(e)} />
																		<label>Last Name</label>
																	</div>
																</div>
															</div>

															<div className='edit-contact'>

																<div className="form_wrap_edit">
																	<div className="input_wrap_edit inputslectedit">
																		<select className='inputshipselect' value={CustomerShippingCountry} onChange={(e) => getCustomerShippingCountry(e)}  >
																			{DeliveryCountries && DeliveryCountries.map((delcountry, delind) => {
																				return (
																					<option value={delcountry.CountryId} key={delind}>{delcountry.CountryName}</option>
																				)
																			})

																			}
																		</select>

																		<label>Country</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		{ShowState ? 
																		<>
																			<select className='inputshipselect' value={CustomerShippingState} onChange={(e) => getCustomerShippingState(e)}  >
																				<option value=""></option>
																				{(CustomerShippingCountry == 2) ?
																					<>
																						{IndiaStates.map((s, sind) => {
																							return (
																								<option value={s.value} key={sind} > {s.name}</option>
																							)
																						})}
																					</>
																					:
																					(CustomerShippingCountry == 3) ?
																						<>
																							{AustraliaStates.map((s, sind) => {
																								return (
																									<option value={s.value} key={sind} > {s.name}</option>
																								)
																							})}
																						</>
																						:
																						(CustomerShippingCountry == 4) ?
																							<>
																								{UsaStates.map((s, sind) => {
																									return (
																										<option value={s.value} key={sind} > {s.name}</option>
																									)
																								})}
																							</>
																							:
																							(CustomerShippingCountry == 5) ?
																								<>
																									{CanadaStates.map((s, sind) => {
																										return (
																											<option value={s.value} key={sind} > {s.name}</option>
																										)
																									})}
																								</>
																								:
																								(CustomerShippingCountry == 30) ?
																									<>
																										{UkStates.map((s, sind) => {
																											return (
																												<option value={s.value} key={sind} > {s.name}</option>
																											)
																										})}
																									</>
																									:
																									(CustomerShippingCountry == 31) ?
																										<>
																											{UaeStates.map((s, sind) => {
																												return (
																													<option value={s.value} key={sind} > {s.name}</option>
																												)
																											})}
																										</>
																										:
																										(CustomerShippingCountry == 32) ?
																											<>
																												{GermanyStates.map((s, sind) => {
																													return (
																														<option value={s.value} key={sind} > {s.name}</option>
																													)
																												})}
																											</>
																											:
																											(CustomerShippingCountry == 33) ?
																												<>
																												</>
																												:
																												<>
																												</>
																				}
																			</select>

																			<label className="country_selected">State</label>
																		</>

																		:
																			<>
																				
																			</>
																		}
																	</div>
																</div>
															</div>

															<div className='edit-contact'>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerShippingAddress} onChange={(e) => getCustomerShippingAddress(e)} />
																		<label>Street Address</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerShippingCity} onChange={(e) => getCustomerShippingCity(e)} />
																		<label>City</label>
																	</div>
																</div>

															</div>
															<div className='edit-contact'>

																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerShippingPincode} onChange={(e) => getCustomerShippingPincode(e)} />
																		<label>Pincode</label>
																	</div>
																</div>
																<div className="form_wrap_edit">
																	<div className="input_wrap_edit">
																		<input type="text" required name="username" value={CustomerShippingPhone} onChange={(e) => getCustomerShippingPhone(e)} />
																		<label>Phone Number</label>
																	</div>
																</div>

															</div>

															<button type="submit" className="register_submit  procartbtn" onClick={(e) => saveCustomerShippingformation(e)}>Save</button>

														</div>

													</div>
												)}
											</Popup>
										</Typography>

									</Accordion>


								</div>
							</Grid>
						</div>

						<Footer footerdata={''} />
					</div>
				</>

			}
		</>
	)


}

export async function getServerSideProps(context) {
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	} else {
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
		const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);
		var geoapiresponse = await res.json();

		var currentCurrency = geoapiresponse.current_currency
		var AllCountryData = geoapiresponse.all_currency
		var GeoData = geoapiresponse.GeoData
	}

	return {
		props: {
			currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData
		}
	}
}

