import React, { useState, useEffect } from 'react';
import { getCsrfToken } from "next-auth/react"
import Footer from "../../components/Footer/Footer";
import Navbar from "../../components/Navbar/Navbar";
import Grid from "@material-ui/core/Grid";
import { useRouter } from "next/router";
import Head from "next/head";
import { useSession, getSession, getProviders, signIn, signOut } from "next-auth/react";
import { AiFillGoogleCircle } from "react-icons/ai";
import { BsFacebook } from "react-icons/bs";
import CategorySlider from '../../components/Component/CategorySlider';
import Carousel from "react-multi-carousel";
import PropTypes from 'prop-types'
import { makeStyles, useTheme } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';
import Box from '@material-ui/core/Box';
import Link from "next/link";
import config from '../../config/config'
import Button from '@mui/material/Button'
import Image from 'next/image'
import PersonOutlineIcon from '@material-ui/icons/PersonOutline';
import LockOpenIcon from '@material-ui/icons/LockOpen';
import CallIcon from '@material-ui/icons/Call';
import MailOutlineIcon from '@material-ui/icons/MailOutline';
import PublicIcon from '@material-ui/icons/Public';
import styles from './Signinstyle/Signin.module.css'
import { AiFillEyeInvisible, AiFillEye } from "react-icons/ai";


function TabPanel(props) {
	const { children, value, index, ...other } = props;

	return (
		<div
			role="tabpanel"
			hidden={value !== index}
			id={`full-width-tabpanel-${index}`}
			aria-labelledby={`full-width-tab-${index}`}
			{...other}
		>
			{value === index && (
				<Box p={3}>
					<Typography>{children}</Typography>
				</Box>
			)}
		</div>
	);
}

TabPanel.propTypes = {
	children: PropTypes.node,
	index: PropTypes.any.isRequired,
	value: PropTypes.any.isRequired,
};

function a11yProps(index) {
	return {
		id: `full-width-tab-${index}`,
		'aria-controls': `full-width-tabpanel-${index}`,
	};
}

const useStyles = makeStyles((theme) => ({
	root: {
		backgroundColor: theme.palette.background.paper,
		padding: "0 !important"
	},
}));

export default function SignIn({ csrfToken, providers, currentCurrency, AllCurrencyData, GeoData }) {
	const { error } = useRouter().query;
	const { data: session } = useSession();
	const classes = useStyles();
	const theme = useTheme();
	const [value, setValue] = React.useState(0);
	const router = useRouter()

	const handleChange = (event, newValue) => {
		setValue(newValue);
	};

	const handleChangeIndex = (index) => {
		setValue(index);
	};

	const ChangeForm = (e, index) => {
		setValue(1);
	};
	const [CustomerName, setCustomerName] = useState('')
	const [CustomerEmail, setCustomerEmail] = useState('')
	const [CustomerPassword, setCustomerPassword] = useState('')
	const [CustomerCountry, setCustomerCountry] = useState('')
	const [CustomerPhone, setCustomerPhone] = useState('')
	const [Clicked, setClicked] = useState(false)
	const [checkagree, setcheckagree] = useState(false)
	const [isloading, setisloading] = useState(false)

	const [successMsg, setsuccessMsg] = useState(false)
	const [errorMsg, seterrorMsg] = useState(false)
	const [errorMsgtxt, seterrorMsgtxt] = useState('')

	const [CustomerNameErr, setCustomerNameErr] = useState(false)
	const [CustomerEmailErr, setCustomerEmailErr] = useState(false)
	const [CustomerPasswordErr, setCustomerPasswordErr] = useState(false)
	const [CustomerPhoneErr, setCustomerPhoneErr] = useState(false)
	const [CustomerCountryErr, setCustomerCountryErr] = useState(false)

	const [ForgetpassWordCustomerEmail, setForgetpassWordCustomerEmail] = useState('')
	const [ForgetpassWordCustomerEmailErr, setForgetpassWordCustomerEmailErr] = useState('')
	const [ForgetpassWordsuccessMsg, setForgetpassWordsuccessMsg] = useState(false)
	const [ForgetpassWorderrorMsg, setForgetpassWorderrorMsg] = useState(false)

	const [username, setusername] = useState('')
	const [password, setpassword] = useState('')

	const [usernameErr, setusernameErr] = useState(false)
	const [passwordErr, setpasswordErr] = useState(false)

	const [passwordType, setPasswordType] = useState("password");
	const togglePassword = () => {
		if (passwordType === "password") {
			setPasswordType("text")
			return;
		}
		setPasswordType("password")
	}


	const [passwordsignup, setpasswordsignup] = useState("password");

	const [GuestBtnShow, setGuestBtnShow] = useState(false);


	const togglepwsignup = () => {
		if (passwordsignup === "password") {
			setpasswordsignup("text")
			return;
		}
		setpasswordsignup("password")
	}


	const [toggleState, setToggleState] = useState(1);
	const toggleTab = (index) => {
		setToggleState(index);
	};

	var callbackurl = router.query.callbackUrl;

	useEffect(() => {
		var chkstr = config.WebSiteBaseURL + 'cart';
		var chekd = (callbackurl || '').includes(chkstr);
		if (chekd) {
			setGuestBtnShow(true)
		}

	}, [callbackurl])




	function disableAllerrors() {
		setCustomerNameErr(false)
		seterrorMsg(false)
		setCustomerEmailErr(false)
		setCustomerPasswordErr(false)
		setCustomerPhoneErr(false)
		setCustomerCountryErr(false)
		setForgetpassWordCustomerEmailErr(false)
		setForgetpassWorderrorMsg(false)
		seterrorMsgtxt('')
	}

	function disableallSuccessmessage() {
		setsuccessMsg(false)
		setForgetpassWordsuccessMsg(false)
	}

	function getCustomerName(e) {
		var n = e.target.value
		setCustomerName(n);
		disableAllerrors()
		disableallSuccessmessage()
		setCustomerNameErr(false)
	}

	function getCustomerEmail(e) {
		var n = e.target.value
		setCustomerEmail(n);
		disableAllerrors()
		disableallSuccessmessage()
		setCustomerEmailErr(false)
	}

	function getCustomerPassword(e) {
		var n = e.target.value
		setCustomerPassword(n);
		disableAllerrors()
		disableallSuccessmessage()
		setCustomerPasswordErr(false)
	}

	function getCustomerPhone(e) {
		var n = e.target.value
		setCustomerPhone(n);
		disableAllerrors()
		disableallSuccessmessage()
		setCustomerPhoneErr(false)
	}

	function getCustomerCountry(e) {
		var n = e.target.value
		setCustomerCountry(n);
		disableAllerrors()
		disableallSuccessmessage()
		setCustomerCountryErr(false)
	}

	function getForgetpassWordCustomerEmail(e) {
		var n = e.target.value
		setForgetpassWordCustomerEmail(n);
		disableAllerrors()
		disableallSuccessmessage()
	}

	function getusename(e) {
		var n = e.target.value
		setusername(n);
		setusernameErr(false)
	}

	function getpassword(e) {
		var n = e.target.value
		setpassword(n);
		setpasswordErr(false)
	}
	function getcheckagree(e) {
		var n = e.target.value
		setcheckagree(true);
	}

	async function login(e) {


		if (!username) {
			e.preventDefault()
			setusernameErr(true)
		} else if (!password) {
			e.preventDefault()
			setpasswordErr(true)
		}
	}

	async function registerCustomer(e) {
		e.preventDefault()
		seterrorMsg(false)
		seterrorMsg(false)

		if (!CustomerName) {
			setCustomerNameErr(true)
		} else if (!CustomerEmail) {
			setCustomerEmailErr(true)
		} else if (!CustomerPassword) {
			setCustomerPasswordErr(true)
		} else if (!CustomerCountry) {
			setCustomerCountryErr(true)
		} else if (!CustomerPhone) {
			setCustomerPhoneErr(true)
		} else {
			setisloading(true)
			const registerResp = await fetch(`${config.apiUrl}auth/register`, {
				method: "POST",
				body: JSON.stringify({ name: CustomerName, email: CustomerEmail, pwd: CustomerPassword, phone: CustomerPhone, country: CustomerCountry }),
				headers: {
					"Content-Type": "application/json",
				},
			}).then(response => {
				return response.json();  // <---- this is important
			}).then(function (response) {
				if (response.CODE == '200') {
					setisloading(false)
					setsuccessMsg(true)
					setCustomerName('')
					setCustomerEmail('')
					setCustomerPassword('')
					setCustomerPhone('')
					setCustomerCountry('')
					setcheckagree('')
				} else {
					setisloading(false)
					seterrorMsg(true)
					seterrorMsgtxt(response.msg)
				}
			});


		}
		setTimeout(function () {
			setsuccessMsg(false)
			seterrorMsg(false)
		}, 15000);

	}

	async function forgetpasswordApi(e) {
		e.preventDefault()
		seterrorMsg(false)
		setsuccessMsg(false)
		seterrorMsgtxt('')
		if (!ForgetpassWordCustomerEmail) {
			setForgetpassWordCustomerEmailErr(true)
		} else {
			setisloading(true)
			const registerResp = await fetch(`${config.apiUrl}auth/forgetpassword`, {
				method: "POST",
				body: JSON.stringify({ email: ForgetpassWordCustomerEmail }),
				headers: {
					"Content-Type": "application/json",
				},
			}).then(function (response) {
				if (response.status == 200) {
					setisloading(false)
					setForgetpassWordsuccessMsg(true)
					setForgetpassWordCustomerEmail('')
				} else {
					setisloading(false)
					setForgetpassWorderrorMsg(true)
				}
			});
		}
		setTimeout(function () {
			setForgetpassWordsuccessMsg('')
		}, 15500);
	}

	useEffect(() => {
		const securepage = async () => {
			const session = await getSession()
			if (session) {
				router.push('/', null, { shallow: true })
			}
		}
		securepage()
	}, [])

	return (
		<>
			<div className={styles.maincointainer} key="div1">
				<Head>
					<title>User Login - 1800rakhis</title>
				</Head>

				<div className='somehideflag'>
					<Navbar countryId={``} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />
				</div>
				{/* add new */}
				<Grid container className={styles.login}  >

					<Grid className={styles.logininner}>

						<div className={styles.login_register}>
							<div className={styles.login_left}>
								<div className={styles.login_slider}>
									<div className={styles.singimg}>
										<Image src="/Egift/cakes/login.webp" width='500' height="420" alt='' title='Black Forest Cakes' type="image/jpeg" />
									</div>
								</div>
							</div>

							<div className={styles.login_right}>
								{isloading && (
									<span className='ew_loader_contact align-items-center justify-content-center d-flex w-100' >
										<img
											src='/loading.gif' className='loader_contact' alt="loader"
										/>
									</span>
								)}
								<Image width="120" height="48" className='sign-img' src='/logo.png' />

								<div className={styles.bloc_tabs}>
									<button
										className={toggleState === 1 ? "tabs active-tabs" : "tabs"}
										onClick={() => toggleTab(1)}
									>
										Sign In
									</button>
									<button
										className={toggleState === 2 ? "tabs active-tabs" : "tabs"}
										onClick={() => toggleTab(2)}
									>
										Sign Up
									</button>


								</div>
								<div className={styles.loginsec}>
									<div
										className={toggleState === 1 ? "content  active-content" : "content"}
									>

										<form method="post" action="/api/auth/callback/credentials" >
											<input name="csrfToken" type="hidden" defaultValue={csrfToken} />
											<div className={styles.form_inner} key="div2">
												{/* <h2>Sign in</h2> */}
												<div className={styles.eror_signin}>
													{(error) ?
														<p className={styles.signin_error} key="err1">{error}</p>
														:
														<>
														</>
													}
												</div>


												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<PersonOutlineIcon width="15" className={styles.login_icon} />
														<input className={'' + (usernameErr ? 'inputsignuperr' : '')} onChange={(e) => getusename(e)} value={username} type="text" name="username" title="" required />
														<label>Email Address</label>
													</div>
													<div className={styles.errsign}>
														{(usernameErr) ?
															<p className={styles.errmsg}>Email is required</p>
															: ''
														}
													</div>
												</div>

												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<LockOpenIcon width="15" className={styles.login_icon} />
														<input className={'' + (passwordErr ? 'inputsignuperr' : '')} onChange={(e) => getpassword(e)} value={password} type={passwordType} name="password" title="" required />
														<label> {'Password'}</label>
														<button type='button' className={styles.paswordeyebtn} onClick={togglePassword}>
															{passwordType === "password" ? <AiFillEyeInvisible width="15" className={styles.eye_close} /> : <AiFillEye width="15" className={styles.eye_open} />}
														</button>
													</div>
													<div className={styles.errsign}>
														{(passwordErr) ?
															<p className={styles.errmsg}>Password is required</p>
															: ''
														}
													</div>
												</div>

												<div className={styles.remember}>
													<div className={styles.remember_inner}>
														<div id='signn' className={`${styles.checkboxsigng} checkboxsigng`}>
															<input type="checkbox" value="" />
															<label htmlFor="checkbox2"><span className={styles.reme}>Remember Me</span></label>
														</div>

													</div>

													<button type='button'
														className={toggleState === 3 ? "tabs active-tabs btnfrgtpss" : "tabs btnfrgtpss"}
														onClick={() => toggleTab(3)}
													>
														forgot password?
													</button>

												</div>
												{(!username && !password) ?
													<button type='submit' onClick={(e) => login(e)} className={`${styles.account_submit} ${styles.procartbtn} procartbtn`}><span>Sign in</span></button>

													:
													<button className={`${styles.account_submit} ${styles.procartbtn} procartbtn`} type='submit'><span>Sign in</span></button>

												}

											</div>
										</form>

										<div className={styles.newaacount}>
											<p>New on our platform?
												<button
													className={toggleState === 2 ? "tabs active-tabs createanccnt" : "tabs createanccnt"}
													onClick={() => toggleTab(2)}
												>
													Create an account
												</button>
											</p>
										</div>

										<div className={styles.signinor}>
											<p className={styles.or}>or</p>
										</div>
										<p className={styles.sn}>With your social network</p>

										<Grid item md={12}>
											<div className={styles.socialbtn} key="div3">
												{Object.values(providers).map((provider, providerkey) => {
													return (
														(provider.name !== "Credentials") ?
															<>
																{(provider.name === "Google") ?
																	<>
																	<div className={styles.sociallogin_btn} key={providerkey} >
																	<button onClick={() => signIn(provider.id)}>																			
																			<Image src='/Egift/cakes/google-icon.png' alt='' width="30" height="30" />																				
																		</button>

																	</div>

																	</>
																	:
																	<>
																	</>

																}
															</>
															:
															<>
															</>
													)
												})}
											</div>

											{(GuestBtnShow) ?

												<Link href="/cart/checkout"><a>
													<Button className={`${styles.checkout_btn} ${styles.login_page_cheackout_btn}`} type="button">Continue as Guest</Button>
												</a></Link>
												:
												<>
												</>
											}

										</Grid>
									</div>

									<div
										className={toggleState === 2 ? "content2 active-content" : "content2"}
									>



										<form method="post">
											<div className={styles.form_inner}>
												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<PersonOutlineIcon width="15" className={styles.login_icon} />
														<input className={'' + (CustomerNameErr ? 'inputsignuperr' : '')} type="text" required onChange={(e) => getCustomerName(e)} value={CustomerName} />
														<label>Your Name</label>
													</div>
													<div className={styles.errsign}>
														{(CustomerNameErr) ?
															<p className={styles.errmsg}>Name is required</p>
															: ''
														}
													</div>
												</div>
												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<MailOutlineIcon width="15" className={styles.login_icon} />
														<input className={'' + (CustomerEmailErr ? 'inputsignuperr' : '')} type="text" required onChange={(e) => getCustomerEmail(e)} value={CustomerEmail} />
														<label>Email Address</label>
													</div>
													<div className={styles.errsign}>
														{(CustomerEmailErr) ?
															<p className={styles.errmsg}>Email is required</p>
															: ''
														}
													</div>
												</div>

												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<LockOpenIcon width="15" className={styles.login_icon} />
														<input className={'' + (CustomerPasswordErr ? 'inputsignuperr' : '')} type={passwordsignup} required onChange={(e) => getCustomerPassword(e)} value={CustomerPassword} />
														<label>{'Password'}</label>
														<button type='button' className={styles.paswordeyebtn} onClick={togglepwsignup}>
															{passwordsignup === "password" ? <AiFillEyeInvisible className={styles.eye_close} /> : <AiFillEye className={styles.eye_open} />}
														</button>
													</div>
													<div className={styles.errsign}>
														{(CustomerPasswordErr) ?
															<p className={styles.errmsg}>Password is required</p>
															: ''
														}
													</div>
												</div>

												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<PublicIcon width="15" className={styles.login_icon} />
														<input className={'' + (CustomerCountryErr ? 'inputsignuperr' : '')} type="text" required onChange={(e) => getCustomerCountry(e)} value={CustomerCountry} />
														<label>Country</label>
													</div>
													<div className={styles.errsign}>
														{(CustomerCountryErr) ?
															<p className={styles.errmsg}>Country is required</p>
															: ''
														}
													</div>
												</div>

												<div className={styles.form_wrap}>
													<div className={styles.input_wrap}>
														<CallIcon width="15" className={styles.login_icon} />
														<input className={'' + (CustomerPhoneErr ? 'inputsignuperr' : '')} type="text" required onChange={(e) => getCustomerPhone(e)} value={CustomerPhone} />
														<label>Phone No.</label>
													</div>
													<div className={styles.errsign}>
														{(CustomerPhoneErr) ?
															<p className={styles.errmsg}>Phone no. is required</p>
															: ''
														}
													</div>
												</div>

												<div id='signupp' className={`${styles.checkboxsigng2} checkboxsigng`}>

													<label htmlFor="checkbox" ><span className={styles.agree}>By continuing, I agree to 1800rakhis terms of use and privacy policy.</span></label>
												</div>

												{(successMsg) ?
													<div className='successmsgsup'>
														<p>Thank you for registering , <button type='button'
															className={toggleState === 1 ? "tabs active-tabs signupsucces" : "tabs signupsucces"}
															onClick={() => toggleTab(1)}
														>
															Login Now
														</button> to order quickly.</p>
													</div>
													:
													''

												}
												{(errorMsg) ?
													<div className='errormsg'>
														<p>{errorMsgtxt}<button type='button'
															className={toggleState === 1 ? "tabs active-tabs signuperror" : "tabs signuperror"}
															onClick={() => toggleTab(1)}>
															Login Now</button>
														</p>
													</div>
													:
													''

												}

												<button type="submit" className={`${styles.register_submit}  ${styles.procartbtn} procartbtn`} onClick={(e) => registerCustomer(e)}><span>Submit</span></button>

											</div>
										</form>

									</div>
								</div>

								<div
									className={toggleState === 3 ? "content  active-content" : "content"}
								>


									<form method="post">
										<p className='forgottext'>Enter the email associated with your account and we will get back to you with the next steps.</p>
										<div className={`${styles.form_inner} ${styles.form_inner}`}>

											<div className={styles.form_wrap}>
												<div className={styles.input_wrap}>
													<MailOutlineIcon width='15' className={styles.login_icon} />

													<input className={'' + (ForgetpassWordCustomerEmailErr ? 'inputsignuperr' : '')} type="text" required onChange={(e) => getForgetpassWordCustomerEmail(e)} value={ForgetpassWordCustomerEmail} />
													<label>Email Address</label>
												</div>
												<div className={styles.errsign}>
													{(ForgetpassWordCustomerEmailErr) ?
														<p className={styles.errmsg}>Email is Required</p>
														: ''
													}
												</div>
											</div>
											<div className={styles.button_back}>
												<button type='button'
													className={toggleState === 1 ? "tabs active-tabs backtlog" : "tabs backtlog"}
													onClick={() => toggleTab(1)}
												>
													Back to Login
												</button>
											</div>

											{(ForgetpassWordsuccessMsg) ?
												<div className='successmsgsforgot'>
													<p>Check your email for the password reset link.</p>
												</div>
												:
												''

											}

											<button type="submit" className={`${styles.register_submit} ${styles.backtolgo}  ${styles.procartbtn} procartbtn`} onClick={(e) => forgetpasswordApi(e)} ><span>Submit</span></button>
										</div>
									</form>
								</div>



							</div>{/*right */}
						</div>

					</Grid>
				</Grid>

				{/* add new */}
				<Footer footerdata="" />
			</div>

		</>
	)


}

export async function getServerSideProps(context) {
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	} else {
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
		const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);
		var response = await res.json();

		var currentCurrency = response.current_currency
		var AllCountryData = response.all_currency
		var GeoData = response.GeoData
	}

	const providers = await getProviders()
	return {
		props: {
			csrfToken: await getCsrfToken(context),
			providers: providers,
			currentCurrency: currentCurrency,
			AllCurrencyData: AllCountryData,
			GeoData: GeoData
		},
	}
}

