import React, { useState, useEffect, AwesomeSlider } from 'react';
import Grid from '@material-ui/core/Grid';
import Navbar from '../components/Navbar/Navbar';
import Footer from '../components/Footer/Footer';
import Image from 'next/image';
import config from "../config/config";
import Head from "next/head";

export default function Partner({ currentCurrency, AllCurrencyData, GeoData, selectedCountryFlag }) {


	const [Name, setName] = useState('')
	const [Email, setEmail] = useState('')
	const [Phone, setPhone] = useState('')
	const [Enquiry, setEnquiry] = useState('')
	const [City, setCity] = useState('')
	const [Area, setArea] = useState('')
	const [Message, setMessage] = useState('')

	const [NameErr, setNameErr] = useState(false)
	const [EmailErr, setEmailErr] = useState(false)
	const [PhoneErr, setPhoneErr] = useState(false)
	const [EnquiryErr, setEnquiryErr] = useState(false)
	const [CityErr, setCityErr] = useState(false)
	const [AreaErr, setAreaErr] = useState(false)
	const [MessageErr, setMessageErr] = useState(false)

	const [isloading, setisloading] = useState(false)

	const [successMsg, setsuccessMsg] = useState(false)
	const [errMsg, seterrMsg] = useState(false)

	// const validDomains = ["gmail.com", "yahoo.com", "hotmail.com"];
	// const re = /^[A-Z0-9._+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i;

	function hidemessages() {
		setNameErr(false)
		setEmailErr(false)
		setPhoneErr(false)
		setCityErr(false)
		setEnquiryErr(false)
		setAreaErr(false)
		setMessageErr(false)
		setsuccessMsg(false)
		seterrMsg(false)
	}

	function validateEmail(Email) {
		const re = /^[A-Z0-9._+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i;
		return re.test(String(Email).toLowerCase());
	  }
	function getName(e) {
		var n = e.target.value
		setName(n);
		hidemessages()
	}
	function getEmail(e) {
		var n = e.target.value
		setEmail(n);
		hidemessages()
	}
	function getPhone(e) {
		var n = e.target.value
		setPhone(n);
		hidemessages()
	}
	function getEnquiry(e) {
		var n = e.target.value
		setEnquiry(n);
		hidemessages()
	}
	function getCity(e) {
		var n = e.target.value
		setCity(n);
		hidemessages()
	}
	function getArea(e) {
		var n = e.target.value
		setArea(n);
		hidemessages()
	}
	function getMessage(e) {
		var n = e.target.value
		setMessage(n);
		hidemessages()
	}
	async function sendPartnerMail(e) {
		e.preventDefault()
		if (!Name) {
			setNameErr(true)
		} else if (!Email) {
			setEmailErr('Email is required')
		}
		else if (!validateEmail(Email)) {
			setEmailErr("Invalid email address");
			return false;
		}
		else if (!Phone) {
			setPhoneErr(true)
		}
		else if (!Enquiry) {
			setEnquiryErr(true)
		}
		else if (!City) {
			setCityErr(true)
		}
		else if (!Area) {
			setAreaErr(true)
		} else {
			setisloading(true)
			var fetchurl = `${config.apiUrl}becomeapartner`;
			var uformData = {
				'name': Name,
				'email': Email,
				'Phone': Phone,
				'Enquiry': Enquiry,
				'City': City,
				'Area': Area,
				'Comments': Message
			}
			const result = await fetch(fetchurl, {
				method: "POST",
				headers: {
				},
				body: JSON.stringify(uformData)
			});
			const response = await result.json();
			if (response.CODE == '200') {
				setisloading(false)
				setsuccessMsg(true)
				setName('')
				setEmail('')
				setPhone('')
				setCity('')
				setEnquiry('')
				setArea('')
				setMessage('')

			} else {
				seterrMsg(true)
			}
		}
		setTimeout(function () {
			setsuccessMsg('')
			seterrMsg('')
		}, 3000);
	}

	return (
		<>

			<Head>
				<title> Partner with us - 1800rakhis</title>
				<link rel="canonical" href="https://1800rakhis.com/become-a-partner" />
			</Head>

			<Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} selectedCountryFlag={selectedCountryFlag} />

			<Grid item md={12} sm={12} xs={13}>
				<Grid container className=''>
					<div className='partner_with_us'>

						<div className='webwrapper'>
							<div className='banner-content'>
								<h2>Become a 1800rakhis

									<span>  Partner today!</span></h2>

								<div className='partnerBenefits'>
									<h3>Benefits to 1800rakhis  Partner</h3>

									<ul>
										<li>
											<Image height='150' width='150' src='/brand_name.webp' alt="" />
											<p>Use of brand name</p>
										</li>
										<li>
											<Image height='150' width='150' src='/website_support.webp' alt="" />
											<p>1800rakhis Website Support</p>
										</li>
										<li>
											<Image height='150' width='150' src='/timely_payments.webp' alt="" />
											<p>Timely payments</p>
										</li>
										<li>
											<Image height='150' width='150' src='/cities_coverage.webp' alt="" />
											<p>1000+cities coverage</p>
										</li>
									</ul>
								</div>
							</div>

							<div className='banner-content-form'>
								{isloading && (
									<span className='ew_loader_contact align-items-center justify-content-center d-flex w-100' >
										<img src='/loading.gif' className='loader_contact' alt="loader"
										/>
									</span>
								)}

								{(successMsg) ?
									<div className='contacterrcont'>
										<div className='contacterrdiv'>
											<p className='signin_error_con'>{'Thanks for contacting us!'}<br /> {"We'll be in touch very soon!"}</p>
										</div>
									</div>
									:
									<>
									</>
								}

								{(errMsg) ?
									<div className='contacterrcont'>
										<div className='contactsucdiv'>
											<p className='signin_error_con'>Form submissiion Failed!</p>
										</div>
									</div>
									:
									<>
									</>
								}
								<h3>Get in touch with us</h3>
								<form id="contact_form">
									<div className="user-input-wrp">
										<br />
										<input type="text" className={'inputText ' + (NameErr ? 'inputsignuperr' : '')} required onChange={(e) => getName(e)} value={Name} />
										<div className='error_div_contact'>
											{(NameErr) ?
												<p className="errmsg_contact">Name is required</p>
												: ''
											}
										</div>
										<span className="floating-label">Name</span>
									</div>
									<div className="user-input-wrp">
										<br />
										<input type="text" className={'inputText ' + (EmailErr ? 'inputsignuperr' : '')} required onChange={(e) => getEmail(e)} value={Email} />
										<div className='error_div_contact'>
											{(EmailErr) ?
												<p className="errmsg_contact">{EmailErr}</p>
												: ''
											}
											{(EmailErr) ?
												<p className="errmsg_contact">{EmailErr}</p>
												: ''
											}
										</div>
										<span className="floating-label">Email</span>
									</div>

									<div className="user-input-wrp">
										<br />
										<input type="text" className={'inputText ' + (PhoneErr ? 'inputsignuperr' : '')} required onChange={(e) => getPhone(e)} value={Phone} />
										<div className='error_div_contact'>
											{(PhoneErr) ?
												<p className="errmsg_contact">Phone No required</p>
												: ''
											}
										</div>
										<span className="floating-label">Phone</span>
									</div>

									<div className="user-input-wrp">
										<select className={'inputText ' + (EnquiryErr ? 'inputsignuperr' : '')} name="category" id="partner_Categories" onChange={(e) => getEnquiry(e)} value={Enquiry}>
											<option value="">Category Enquiry</option>
											<option value="Flowers">Flowers</option>
											<option value="Cakes">Cakes</option>
											<option value="Plants">Plants</option>
											<option value="Chocolates">Chocolates</option>
											<option value="Balloon Decoration">Balloon Decoration</option>
											<option value="Restaurants">Restaurants</option>
											<option value="Cushions">Cushions</option>
											<option value="Mugs">Mugs</option>
											<option value="Accessories">Accessories</option>
											<option value="Sweets">Sweets</option>
											<option value="Guitarists">Guitarists</option>
											<option value="Soft Toys">Soft Toys</option>
											<option value="Planters">Planters</option>
											<option value="Vases">Vases</option>
											<option value="Greeting Cards">Greeting Cards</option>
											<option value="Packaging">Packaging</option>
										</select>
										<div className='error_div_contact'>
											{(EnquiryErr) ?
												<p className="errmsg_contact">Enquiry is required</p>
												: ''
											}
										</div>
									</div>

									<div className="user-input-wrp">
										<br />
										<input type="text" className={'inputText ' + (CityErr ? 'inputsignuperr' : '')} required onChange={(e) => getCity(e)} value={City} />
										<div className='error_div_contact'>
											{(CityErr) ?
												<p className="errmsg_contact">City is required</p>
												: ''
											}
										</div>
										<span className="floating-label">City</span>
									</div>

									<div className="user-input-wrp">
										<br />
										<input type="text" className={'inputText ' + (AreaErr ? 'inputsignuperr' : '')} required onChange={(e) => getArea(e)} value={Area} />
										<div className='error_div_contact'>
											{(AreaErr) ?
												<p className="errmsg_contact">Area is required</p>
												: ''
											}
										</div>
										<span className="floating-label">Area</span>
									</div>

									<div className="user-input-wrp">
										<br />
										<textarea rows="1" className="inputText" required onChange={(e) => getMessage(e)} value={Message} />
										<span className="floating-label">Comments</span>
									</div>


									<button type="submit" className="contact_submit procartbtn" onClick={(e) => sendPartnerMail(e)}><span>Submit</span></button>



								</form>
							</div>
						</div>


					</div>
				</Grid>
			</Grid>
			<Footer />

		</>

	)
}



export async function getServerSideProps(context) {
	var selectedCountryFlag = ''
	if (typeof (context.req.cookies.FlagData) !== 'undefined') {
		var selectedCountryFlagID = JSON.parse(context.req.cookies.FlagData)
		var selectedCountryFlag = selectedCountryFlagID.id
	} else {
		var selectedCountryFlag = '2';
	}
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	} else {
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
		const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);

		var geoapiresponse = await res.json();

		var currentCurrency = geoapiresponse.current_currency
		var AllCountryData = geoapiresponse.all_currency
		var GeoData = geoapiresponse.GeoData
	}
	return {
		props: {
			currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData, selectedCountryFlag: selectedCountryFlag
		}
	}

}