import React, { useState, useEffect, AwesomeSlider } from 'react';
import Grid from '@material-ui/core/Grid';
import Navbar from '../components/Navbar/Navbar';
import Footer from '../components/Footer/Footer';
import config from "../config/config";
import Head from 'next/head';
import Breadcrumb from '../components/Component/Breadcrumbs'
export default function CancellationRefundPolicy({ currentCurrency, AllCurrencyData, GeoData, selectedCountryFlag }) {



    return (
        <>
            <Head>
                <title>Cancellation-Refund-Policy - 1800rakhis</title>
                <link rel="canonical" href="https://1800rakhis.com/cancellation-refund-policy" />

            </Head>
            <Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} selectedCountryFlag={selectedCountryFlag} />
            <Breadcrumb proclass="" rootbreadcrumbtext='cancellation-refund-policy' rootbreadcrumblink='' countryId='' breadcrumbtext='' selectedCountryFlag={selectedCountryFlag}/>
            <Grid item md={12} sm={12} xs={13}>

                <Grid container className='policy-container'>
                    <div>
                        <h2>Cancellation Policy</h2>

                    <p>Please read the below stated points for any cancellations.</p>
					<p>Please understand that the points mentioned in the policies are with reference to the  time slots on the 1800rakhis.com selected by the user in checkout process. </p> 
					<p>Orders are processed in time slots and we accept cancellation requests with reference to time slot selected by customer in order placed. Consider conditions stated below -</p>
					
					
					<p><span>1.</span>	If the cancellation request comes to 1800rakhis before 24 hours to the start of time slot selected - 10% of order value is charged as cancellation charges. 90% refund to Bank Account. NOTE - 100% refund can be requested in 1800rakhis wallet, where we waive off cancellation charges.</p>
					<p><span>2.</span>	If the cancellation request comes to 1800rakhis between 12 - 24 hours before the start of time slot selected then - 20% of order value will be deducted as cancellation charges. 80% refund to Bank Account. NOTE - 100% refund can be requested in 1800rakhis wallet, where we waive off cancellation charges.</p>
					<p><span>3.</span>If cancellation is request comes to 1800rakhis within 12 hours to the start of time slot selected - 100% of order value will be deducted as cancellation charges. 0% refund to Bank account or 0% to 1800rakhis wallet applicable.</p>
					
					
					
					
					<p>In any of the cases above Wallet refunds and Bank refunds can be initiated only at the discretion of company considering the reasons of cancellation like unfortunate events, calamities or unavoidable circumstances. No claims to refund can be made by customer to overrule above stated clause.</p>
					
					<p><span>NO cancellation requests are accepted on order placed in following categories.</span></p>
					
					
					
					<p><span>1.</span>Same day delivery category - If your date of placing an order and delivery date of that order are same, we do not accept cancellation request. If you cancel it, or receiver does not receive it - you are not entitled to any refund.</p>
					<p><span>2.</span>Same day mid-night delivery orders can not be cancelled.</p>
					<p><span>3.</span>Special day orders can not be cancelled and no refund is initiated for them.</p>
					
					
					
                 <h4>Same day Orders</h4>
				 <p>We allow users to select the same date of delivery on which he/she is placing the order i.e. order delivery and order placed date is same. We attempt to do same day delivery of the requested products but DO NOT PROMISE so.</p>
				 <p>We will process same day delivery orders within 24 hours of requested date and time slot.</p>
				 
				 
				 <p><span>1.</span>1800rakhis takes same day orders for day and evening time slots till 5 pm. It is attempt to do same day delivery and not a promise, though we make our 100% effort to deliver on the same date as order placed.</p>
				 <p><span>2.</span>1800rakhis takes order for same day mid-night (00:00) delivery till 7:00 pm. It is attempt to do same day mid-night delivery and not a promise, though we make our 100% effort to deliver on the same date as order placed.</p>
				 <p><span>3.</span>Order placed for courier products cannot be canceled after they are acknowledged at our end.</p>
				 <p><span>4.</span>Delivery date selected for courier products is tentative as the delivery depends on logistics/ courier partners.</p>
				 <p><span>5.</span>Usually courier products are dispatched within 2 days of placing order. It may take extra time depending on nature of product and its preparation.</p>

				 
                
				
				
                    <h2>Refund Policy</h2>

                    <p>Refund in cases of Cancellations are mentioned in Cancellation policy, kindly refer the same.</p>
					<p>The acceptance of order is subject to availability of products, delivery areas and time. The order may or may not be accepted. The order might be cancelled after assessing the circumstances and communicated to customer. In such case amount paid by customer is fully refunded to 1800rakhis wallet or bank account.</p> 
					<p>Only one attempt for delivery will be made. Please confirm availability of recipient before choosing delivery time. If recipient is not available at the time of delivery, second attempt will not be made and order will be cancelled. No refund will be made in such case.</p>
					
					
	
					<p>The refunds are only initiated once the customer confirms over mail that where the refund has to be done - 1800rakhis wallet or bank account.</p>
					<p>Refund will be credited in 1800rakhis Wallet on orders which are processing within 48 hours of delivery date</p>
					<p>Refunds are processed to your payment method within 15 working days.</p>
					<p>Address Change requests</p>
					
					
					
					<p><span>Change in the address is permitted free of cost only before 24 hours of delivery.</span></p>
					
					<p><span>1.</span>Within 24 hours period before delivery , if address is changed we charge Rs 200/-.</p>
                    <p><span>2.</span>Sometimes the address change request can not be accepted, in that case order will not be refunded or cancelled.</p>

					
					

                    </div>


                </Grid>








            </Grid>

            <Footer />


        </>

    )
}

export async function getServerSideProps(context) {
    var selectedCountryFlag = ''
 if(typeof (context.req.cookies.FlagData) !== 'undefined'){
	 var selectedCountryFlagID =  JSON.parse(context.req.cookies.FlagData)
	 var selectedCountryFlag =  selectedCountryFlagID.id
 }else{
	var selectedCountryFlag  = '2'; 
 }
    if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
        var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
        var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
        var GeoData = JSON.parse(context.req.cookies.GeoData)
    } else {
        const forwarded = context.req.headers["x-forwarded-for"]
        const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
        const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);

        var geoapiresponse = await res.json();

        var currentCurrency = geoapiresponse.current_currency
        var AllCountryData = geoapiresponse.all_currency
        var GeoData = geoapiresponse.GeoData
    }
    return {
        props: {
            currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData, selectedCountryFlag: selectedCountryFlag
        }
    }


}