import React, { useState, useEffect, AwesomeSlider } from 'react';
import Grid from '@material-ui/core/Grid';
import Navbar from '../components/Navbar/Navbar';
import Footer from '../components/Footer/Footer';
import config from "../config/config";
import Head from 'next/head';
import Breadcrumb from '../components/Component/Breadcrumbs'
export default function Career({ currentCurrency, AllCurrencyData, GeoData, selectedCountryFlag }) {

	return (
		<>
			<Head>
				<title>Careers - 1800rakhis</title>
				<link rel="canonical" href="https://1800rakhis.com/careers" />

			</Head>
			<Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} selectedCountryFlag={selectedCountryFlag}/>
			<Breadcrumb proclass="" rootbreadcrumbtext='Careers' rootbreadcrumblink='' countryId='' breadcrumbtext='' selectedCountryFlag={selectedCountryFlag}/>
			<Grid item md={12} sm={12} xs={13}>
				<Grid container className=''>
					<div className='career_acc'>
						<h2>Career</h2>
						<div className="faq-content">
							<div className="faq-question">
								<input id="q1" type="checkbox" className="panel" />
								<div className="plus">+</div>
								<label htmlFor="q1" className="panel-title">Content Marketing </label>
								<div className="panel-content"></div>
							</div>

							<div className="faq-question">
								<input id="q2" type="checkbox" className="panel" />
								<div className="plus">+</div>
								<label htmlFor="q2" className="panel-title">Social Media Manager</label>
								<div className="panel-content"></div>
							</div>

							<div className="faq-question">
								<input id="q3" type="checkbox" className="panel" />
								<div className="plus">+</div>
								<label htmlFor="q3" className="panel-title">Category Lead</label>
								<div className="panel-content"></div>
							</div>
						</div>






					</div>
				</Grid>
			</Grid>
			<Footer />

		</>

	)
}



export async function getServerSideProps(context) {
	var selectedCountryFlag = ''
 if(typeof (context.req.cookies.FlagData) !== 'undefined'){
	 var selectedCountryFlagID =  JSON.parse(context.req.cookies.FlagData)
	 var selectedCountryFlag =  selectedCountryFlagID.id
 }else{
	var selectedCountryFlag  = '2'; 
 }
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	} else {
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
		const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);

		var geoapiresponse = await res.json();

		var currentCurrency = geoapiresponse.current_currency
		var AllCountryData = geoapiresponse.all_currency
		var GeoData = geoapiresponse.GeoData
	}
	return {
		props: {
			currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData, selectedCountryFlag:selectedCountryFlag
		}
	}

}