import Link from "next/link";
import "react-multi-carousel/lib/styles.css";
import Grid from '@material-ui/core/Grid';
import Footer from '../../components/Footer/Footer';
import Navbar from '../../components/Navbar/Navbar';
import Button from '@mui/material/Button'
import "react-multi-carousel/lib/styles.css";
import { Delete, ArrowForwardIos, Info, CloseOutlined, Close } from '@material-ui/icons';
import { useSelector, useDispatch } from 'react-redux';
import React, { useState, useEffect } from 'react'
import { updateAllItems, removeItem, applyCouponOnCart, removeCouponFromCart, updateItemQty, setFirstTimeData } from '../../redux/actions/cart';
import config from '../../config/config';
import { useSession, signIn } from "next-auth/react"
import Image from 'next/image'
import styles from './Cartstyle/Cartstyle.module.css'
import { useRouter } from 'next/router';
import Head from 'next/head'
import {GetStorage} from '../../redux/lib/localstorage'

function handleClick(event) {
  event.preventDefault();
}

export default function Cart({ currentCurrency, AllCurrencyData, GeoData }) {
  const dispatch = useDispatch();
  const router = useRouter()
  const [couponsList, setcouponsList] = useState([])
  const updateItemsInCart = (Itemdata) => dispatch(updateAllItems(Itemdata))
  const deleteItemFromCart = (item) => dispatch(removeItem(item))
  const { data: session } = useSession();
  const [buttons, setButtons] = React.useState([
    { name: "Select", id: 1 },
    { name: "Select", id: 2 },
    { name: "Select", id: 3 },
  ]);

  const applyCoupon = (Itemdata) => dispatch(applyCouponOnCart(Itemdata))
  const CartTotalItem = useSelector(state => state.cartReducer.TotalItems);
  const CartItemsList = useSelector(state => state.cartReducer.CartItemsList);
  const CartExtraDetail = useSelector(state => state.cartReducer.CartExtraDetail);
  const CouponDiscount = useSelector(state => state.cartReducer.CouponDiscounts);
  const CouponDiscountsData = useSelector(state => state.cartReducer.CouponDiscountsData);
  const [errcoupon, seterrcoupon] = useState(false)
  const [CouponResp, setCouponResp] = useState(false)
  const CartSubTotal = useSelector(state => state.cartReducer.SubTotal);
  const CartGrandTotal = useSelector(state => state.cartReducer.GrandTotal);
  const DeliveryChargesTotal = useSelector(state => state.cartReducer.DeliveryChargesTotal);
  const GiftWrapperChargesTotal = useSelector(state => state.cartReducer.GiftWrapperChargesTotal);
  const SelectedCurr = useSelector(state => state.cartReducer.CurrencyData);
  const [SelectedCurrencydata, setSelectedCurrencydata] = useState('');
  const [CartItems, setCartItems] = useState(CartItemsList);
  const [Coupons, setCoupons] = useState([]);
  const [hideCouponLoader, sethideCouponLoader] = useState(false);
  const [CouponInput, setCouponInput] = useState('');
  const [DiscountPrice, setDiscountPrice] = useState('');
  const [SelectedCouponMinimumCartTotal, setSelectedCouponMinimumCartTotal] = useState('');
  const [errcart, seterrcart] = useState(false);
  const [CartErrMessage, setCartErrMessage] = useState('');
  const [toggled, toggle] = useState("");
  const [num, setNum] = useState(0);
  const [buttonText, setButtonText] = useState('"Add To Cart"');
  var countryid = 2
  
  if (CartExtraDetail.length > 0) {
    var countryid = CartExtraDetail[0].country_id;
  }
  else {
    var countryid = 2
  }

  useEffect(() => {
	if(CartItems.length > 0){
		if(!SelectedCurr){
			var AllCountryData = AllCurrencyData
			setcurrencydadtanew()
			async function setcurrencydadtanew(){
				await dispatch(setFirstTimeData(currentCurrency, AllCountryData, GeoData))
			}
			setSelectedCurrencydata(currentCurrency)
		}else{
			setSelectedCurrencydata(SelectedCurr)
		}
	}   
    setCartItems(CartItemsList)
    updatestates()
    gerCouponCodes()
  }, [CartItems,SelectedCurr])

  function updatestates() {
    setCouponResp(false)
  }
  
  let incNum = () => {
    if (num < 10) {
      setNum(Number(num) + 1);
    }
  };
  
  let decNum = () => {
    if (num > 0) {
      setNum(num - 1);
    }
  }
  
  let handleChange = (e) => {
    setNum(e.target.value);
  }
  
  useEffect(() => {
    gerCouponCodes()
  }, [])
  
  function gerCouponCodes() {
    sethideCouponLoader(false)

    if (countryid) {
      var url = `${config.apiUrl}coupon/?countryid=${countryid}`
      fetch(url, {
        method: 'GET',
      }).then(response => {
        return response.json();
      }).then(response => {
        setCouponResp(true)
        if (response.nodata == 'yes') {
          setCoupons([])
          sethideCouponLoader(true)
        } else {
          setCoupons(response.coupons)
        }
      });
    }
  }

  async function changeQantity(value, unique_id) {
    var olddata = [...CartItems];

    var newhhsds = olddata.map((val, ind) => {
      if (val.unique_id === unique_id) {
        olddata[ind].quantity = value
      }
    })
    setCartItems(olddata)
  }

  async function UpdateCart() {
    await updateItemsInCart(CartItems);
  }

  async function deleteItem(item) {
    dispatch(removeItem(item));
  }

  async function CheckCartLessToZero(itemData) {        
    const OldItemsSess = GetStorage('CartItemsList'); 
      if( !OldItemsSess ){
        return 0;
      }else{ 
        var discount = 0;
        var Coupontype = itemData.Coupontype;
        var coupon_amount = itemData.CouponAmount;
        var MinimumCartTotal = itemData.MinimumCartTotal;   
        var CurrencyRate = SelectedCurrencydata.CurrencyRate;
        var newMiniAmont = (CurrencyRate*MinimumCartTotal).toFixed();   
        var SubTotals = 0;
        const OldItems = OldItemsSess;
        var jsdhds = OldItems.map((item,inds)=>{
          var unit_price = (item.price*CurrencyRate).toFixed();
          var pric1 = (item.quantity * unit_price);
          SubTotals += parseInt(pric1);
        });
		if(SubTotals < newMiniAmont){
          discount = 0;
          return discount
        }else{
          var newdiscount = 0;
          if(Coupontype == 1){
            var newdiscount1 = SubTotals*coupon_amount;  
            var newdiscount2 = (newdiscount1/100);
            newdiscount = newdiscount2.toFixed();            
          }else{
            newdiscount = (CurrencyRate*coupon_amount).toFixed();  
          }
            
          if(newdiscount <= 1){
            discount = 1;
            return discount
          }else if(newdiscount > 1){
            discount = newdiscount;
            return discount
          }else{
            discount = 0;
            return discount
          }
        }
      }   
    }

  async function ApplyCoupon(itemData) {
    var retDiscount = await CheckCartLessToZero(itemData);
	var grandtotals = ((CartSubTotal + DeliveryChargesTotal + GiftWrapperChargesTotal)-retDiscount);    
    if(grandtotals < 0){
      var msg = 'The coupon code is not valid. Please try another code';
      setCartErrMessage(msg)
      seterrcart(true)
    }else{
      var arrayitem = []
	  var subtotal = (itemData.MinimumCartTotal * SelectedCurrencydata.CurrencyRate).toFixed();
      if (subtotal < 1) {
        subtotal = 1;
      }
      if (CartSubTotal >= subtotal) {
        arrayitem.push(itemData)
        dispatch(applyCouponOnCart(itemData));
      } else {
        var msg = 'This code is applicable only on order above '+SelectedCurrencydata.CurrencySymbol+' '+subtotal
        setCartErrMessage(msg)
		seterrcart(true)
      }
    }
  }

  async function RemoveCoupon(itemData) {
    dispatch(removeCouponFromCart(itemData));
  }

  async function checkCoupon() {    
      if (CouponInput) {
        var countryid = CartExtraDetail[0].country_id;
        var url = `${config.apiUrl}coupon/?couponCode=${CouponInput}&country=${countryid}`
        fetch(url, {
          method: 'GET',
        }).then(response => {
          return response.json();
        }).then(async response => {

          if (response.data != '') {
            var itemData = response.data[0];            
            var retDiscount = await CheckCartLessToZero(itemData);
            var grandtotals = ((CartSubTotal + DeliveryChargesTotal + GiftWrapperChargesTotal)-retDiscount); 
            

            if(grandtotals < 0){
              var msg = 'The coupon code is not valid. Please try another code';
              setCartErrMessage(msg)
              seterrcart(true)
            }else{
              var subtotal = (itemData.MinimumCartTotal * SelectedCurrencydata.CurrencyRate).toFixed();

              if (subtotal < 1) {
                subtotal = 1;
              }

              if (CartSubTotal >= subtotal) {
                dispatch(applyCouponOnCart(itemData));
              } else {
                seterrcart(true)
                setSelectedCouponMinimumCartTotal(subtotal)
              }
            }
          } else {
            // alert('Coupon does not valid !.');
          }
        });
      }
    

    
  }

  async function UpdateQuantity(unique_id, itemData, qty) {
    var olddata = [...CartItemsList];

    var newhhsds = olddata.map((val, ind) => {
      if (val.unique_id === unique_id) {
        olddata[ind].quantity = qty;
        if (qty > 0) {
          var newItemdata = olddata[ind];

          dispatch(updateItemQty(newItemdata));
        }
      }
    })
  }

  const handleButtonClick = i => {
    setButtons(prevState => {
      const nextState = prevState.map(btn => ({
        ...btn, name: "Select"
      }));
      nextState[i].name = "Selected";
      return nextState;
    });
  };

  return (
    <>
      <Head>
        <title>Cart - 1800rakhis</title>
        <link rel="canonical" href="https://1800rakhis.com/cart" />
      </Head>
      <div className="somehideflag">
        <Navbar countryId={``} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />
      </div>
      {(errcart) ?
        <>
          <div className='md-effect-1'>
            <div className='errdiv errdiv_coupon_cart'>

              <div className='errdivico'>
                <Info className='errdicon' />
                <div className='closebtnpop'>
                  <button onClick={() => seterrcart(false)}><CloseOutlined className='crossiconerr' /></button>
                </div>
                <p>{CartErrMessage}
                </p>
              </div>

            </div>
          </div>
          <div className="md-overlay"></div>
        </>
        :
        ''
      }

      {(!CartTotalItem) ?
        <>
          <div className={styles.cart_empty_content}>
            <div className={styles.imgKT}>
              <img src="/cart_1.svg" className={styles.emptycartimg} />
            </div>
            <p className={styles.cart_empty}>Your cart is currently empty.</p>
            <div className={styles.empty_cart_text}>Before proceed to checkout you must add some products to your shopping cart.<br />{' You will find a lot of interesting products on our "Shop" page.'}</div>
            <div className={styles.wrapcartempty}>
              <Link href="/"><a><button className={`${styles.Top_header} ${styles.cartbtnemp} Top_header`}>Return To Shop</button></a></Link>
            </div>
          </div>
        </>
        :
        <>

          <div className={styles.cartouter_wrap}>
            <div className={styles.cart_container}>
              <div className={styles.cart_inner}>
                <Grid container className={styles.heading_sec_cart}>
                  <Grid item md={8} sm={12} xs={12}>
                    <h3>Shopping Cart<span>({CartTotalItem})</span></h3>
                  </Grid>
                </Grid>

                <Grid container className={styles.cartconatiner}>
                  <Grid item md={8} sm={12} xs={12}>
                    <div className={styles.cartcontleft}>
                      {CartItemsList.length > 0 && CartItemsList.map((item, indx) => {
                        var itemQty = item.quantity;
                        if (itemQty > 0) {
                          itemQty = item.quantity;
                        } else {
                          itemQty = 1;
                        }


                        if (item.is_addon == '0') {
                          var uploaded_image = ''
                          if (item.uploaded_image) {
                            uploaded_image = config.PersonalisedURL + item.uploaded_image
                          }

                          var dateFuntion = new Date(item.del_date);
                          var year = dateFuntion.getFullYear();
                          var month = dateFuntion.getMonth()+1;
                          var day = dateFuntion.getDate();

                          if(day < 10){
                            day = '0'+day
                          }
                          if(month < 10){
                            month = '0'+month
                          }

                          var delivrydate = day+'-'+month+'-'+year; 

                          return (

                              <div className={styles.cartinnerdetail} key={indx}>
                                <div className={styles.cartimgsec}>
                                  <img src={item.p_image} alt="" />
                                </div>
                                <div className={styles.cartdetailwrapper}>
                                  <div className={styles.cartdetailsall}>
                                    <div className={styles.productname}>
                                      <span>{item.name}</span>
                                    </div>
                                    <div className={styles.cartprotype}>
                                      <p>{item.variation_title}
                                      
                                      {item.variation_types && item.variation_types.map((valtype, valind) => {
                                        return(
                                          <p key={valind}>,{valtype.TypeName}</p>
                                        )
                                      })}
                                      </p>

                                      
                                    </div>

                                    <div className={styles.input_group}>
                                      <h2>Qty:</h2>
                                      <div className={styles.input_group_prepend}>
                                        <button className={`${styles.btn} ${styles.btn_minus} ${styles.btn_outline_primary}`} type="button" onClick={() => UpdateQuantity(item.unique_id, item, itemQty - 1)}>-</button>
                                      </div>
                                      <input
                                        type="text"
                                        name="quantity"
                                        onChange={(e) => changeQantity(e.target.value, item.unique_id)}
                                        className={`${styles.quantity_input} ${styles.form_control} ${styles.input_number}`} value={itemQty} min="1" max="100" />
                                      <div className={styles.input_group_prepend}>
                                        <button className={`${styles.quantity_input} ${styles.form_control} ${styles.input_number}`} type="button" onClick={() => UpdateQuantity(item.unique_id, item, itemQty + 1)}>+</button>
                                      </div>
                                    </div>

                                    <div className={styles.deliverydetail}>
                                      {item.del_date &&
                                        <span>Delivery Date: {delivrydate} </span>
                                      }

                                      {item.del_charges !== '' && item.del_charges !== '0' &&
                                        <span>,  Delivery Charges : {SelectedCurrencydata.CurrencySymbol} {item.new_del_charges}</span>
                                      }

                                      <p className={styles.giftwrappertxt}>
                                        {item.giftwrapper > '0' &&
                                          <span>Giftwrapper Charges : {SelectedCurrencydata.CurrencySymbol} {item.new_giftwrapper}</span>

                                        }
                                      </p>


                                    </div>

                                    {item.cake_message && (
                                      <div className={styles.message_cart}>
                                        <span>Message: {item.cake_message}</span>
                                      </div>
                                    )}
                                  </div>

                                  <div className={styles.cartrightprice}>


                                    <div className={styles.cartpricewrapper}>
                                      <div className={styles.qtysub}>{SelectedCurrencydata.CurrencySymbol}<p>{item.subtotal}</p>
                                      </div>

                                      {DiscountPrice &&
                                        <div className={styles.salepricediscount}>
                                          {SelectedCurrencydata ?
                                            <div className={styles.saleprice_cart}> {SelectedCurrencydata.CurrencySymbol} 350</div>
                                            :

                                            <div className={styles.saleprice_cart}> 350</div>
                                          }


                                          <span className={styles.discount_cart}>(17% off)</span>
                                        </div>
                                      }

                                    </div>



                                    {uploaded_image &&
                                      <Image width="80" height="80" src={uploaded_image} alt="" />
                                    }

                                    <div className={styles.cartdlt} onClick={(e) => deleteItem(item)}>
                                      <Delete
                                        className={styles.dlticocart}
                                      />
                                      Remove

                                    </div>

                                  </div>

                                </div>
                              </div>
                          )
                        } else {

                          return (
                            <>
                              <div className={styles.cartinnerdetail} key={indx}>
                                <div className={styles.cartimgsec_addons}>
                                  <img src={item.p_image} alt="" />
                                </div>
                                <div className={styles.cartdetailwrapper}>
                                  <div className={styles.cartdetailsall}>
                                    <div className={styles.productname}>
                                      <span>{item.name}</span>
                                    </div>
                                    <div className={`${styles.cartprotype} ${styles.cart_addon}`}><p className={styles.addonp}>
                                      Addon</p></div>

                                    <div className={styles.input_group}>
                                      <h2>Qty:</h2>
                                      <div className={styles.input_group_prepend}>
                                        <button className={`${styles.btn} ${styles.btn_minus} ${styles.btn_outline_primary}`} type="button" onClick={() => UpdateQuantity(item.unique_id, item, itemQty - 1)}>-</button>
                                      </div>
                                      <input
                                        type="text"
                                        name="quantity"
                                        onChange={(e) => changeQantity(e.target.value, item.unique_id)}
                                        className={`${styles.quantity_input} ${styles.form_control} ${styles.input_number}`} value={itemQty} min="1" max="100" />
                                      <div className={styles.input_group_prepend}>
                                        <button className={`${styles.btn} ${styles.btn_add} ${styles.btn_outline_primary}`} type="button" onClick={() => UpdateQuantity(item.unique_id, item, itemQty + 1)}>+</button>
                                      </div>
                                    </div>
                                  </div>

                                  <div className={styles.cartrightprice}>
                                    <div className={styles.cartpricewrapper}>
                                      <div className={styles.qtysub}>{SelectedCurrencydata.CurrencySymbol}<p>{item.subtotal}</p>
                                      </div>

                                      {DiscountPrice &&
                                        <div className={styles.salepricediscount}>
                                          {SelectedCurrencydata ?
                                            <div className={styles.saleprice_cart}> {SelectedCurrencydata.CurrencySymbol} 350</div>
                                            :

                                            <div className={styles.saleprice_cart}> 350</div>
                                          }
                                          <span className={styles.discount_cart}>(17% off)</span>
                                        </div>
                                      }

                                    </div>
                                    <div className={styles.cartdlt} onClick={(e) => deleteItem(item)}>
                                      <Delete
                                        className={styles.dlticocart}
                                      />
                                      Remove

                                    </div>

                                  </div>

                                </div>
                              </div>
                            </>
                          )
                        }
                      })}
                    </div>
                  </Grid>
                  <Grid item md={4} sm={12} xs={12} className={styles.cartcontright}>

                    <div className={styles.outercarterap}>
                      <div className={styles.cartpricingwrap}>

                        <div className={styles.cartofertext}>
                          <Image width="40" height="25" src="/gift-voucher.webp" alt="" />
                          <h2>Available Offers</h2>
                        </div>

                        {(Coupons.length > 0) ?
                          <>
                            {Coupons && Coupons.map((citem, cind) => {
                              var discntamnt = ((citem.CouponAmount * SelectedCurrencydata.CurrencyRate).toFixed());

                              if (discntamnt < 1) {
                                discntamnt = 1;
                              }

                              var appiedCoupon = 0;

                              if (CouponDiscountsData.length > 0) {
                                if (CouponDiscountsData[0].CouponCode === citem.CouponCode) {
                                  appiedCoupon = 1;
                                }
                              }
                              return (
                                  <div className={styles.imgcartcoupon} key={cind}>
                                    <div className={styles.coupn_img}>
                                      <p>{citem.CouponName}</p>
                                      <div className={styles.coupnbtn}>
                                        {appiedCoupon ?
                                          <>
                                            <button className={'coupontext ' + (appiedCoupon ? 'applieddcoupon' : '')} onClick={() => ApplyCoupon(citem)}>Applied</button>
                                            <span className="appliedcpnbtn" onClick={() => RemoveCoupon(citem)}><Close className="appliedcpnbtnclose" /></span>
                                          </>

                                          :
                                          <button className={styles.coupontext} onClick={() => ApplyCoupon(citem)}>Apply</button>
                                        }
                                      </div>

                                    </div>

                                  </div>

                              )

                            })}
                          </>

                          :
                          (!hideCouponLoader) ?
                            <p className={styles.laodercoupon}>
                              <Image width="50" height="50"
                                src='/loading-sm.gif' className={styles.loader} alt="loader"
                              />
                            </p>
                            :
                            ''

                        }

                        <div className={styles.coupon_manual}>
                          <span className={styles.couponchg}><h3>Coupon</h3></span>
                          <span className={styles.inputcouponem}>
                            <input
                              type="text"
                              placeholder="Coupon"
                              onChange={(e) => setCouponInput(e.target.value)}
                              value={CouponInput}
                            />
                          </span>
                          <div className={styles.coupn_btn_wrap}>
                            <Button className={styles.coupn_btn} onClick={() => checkCoupon()}>Apply</Button>

                          </div>
                        </div>

                        <div className={styles.btmcartpricing}>
                          <div className={styles.titlecartpricing}>
                            <h3>Price Details</h3>
                          </div>
                          <div className={styles.cartpricedetail}>
                            <div className={styles.carttotal}>
                              <p>Cart Total</p>
                              {SelectedCurrencydata && (
                                <span>
                                  {SelectedCurrencydata.CurrencySymbol}<p>{CartSubTotal}</p>
                                </span>
                              )}
                            </div>
                            <div className={styles.carttotal}>
                              <p>Applied Coupon</p>
                              {SelectedCurrencydata && (

                                <span>
                                  <p className={styles.minus}>-</p>
                                  {SelectedCurrencydata.CurrencySymbol}<p>{CouponDiscount ? CouponDiscount : 0}</p>
                                </span>
                              )}

                            </div>

                            <div className={styles.carttotal}>
                              <p>Delivery Charges</p>
                              {SelectedCurrencydata && (
                                <span>
                                  {SelectedCurrencydata.CurrencySymbol}<p>{DeliveryChargesTotal}</p>
                                </span>
                              )}

                            </div>

                            {GiftWrapperChargesTotal > 0 &&
                              <div className={styles.carttotal}>
                                <p>Gift Wrapping Charges</p>
                                {SelectedCurrencydata && (
                                  <span>
                                    {SelectedCurrencydata.CurrencySymbol}<p>{GiftWrapperChargesTotal}</p>
                                  </span>
                                )}

                              </div>
                            }

                            <div className={styles.TotalAmountcart}>
                              <p className={styles.ttlamnt}>Total Amount</p>
                              {SelectedCurrencydata && (
                                <span>

                                  <p> {SelectedCurrencydata.CurrencySymbol}</p>
                                  {CartGrandTotal}


                                </span>
                              )}
                            </div>
                          </div>
                        </div>


                        <div className={styles.checkout_btn_btm}>
                          {(session) ?

                            <Link href="/cart/checkout"><a>
                              <Button className={styles.checkout_btn} type="button">Continue to Checkout<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                            </a></Link>
                            :
                            <button className={styles.checkout_btn} type="button" onClick={() => signIn()} >Continue to Checkout<ArrowForwardIos className={styles.checkoutarrowico} /></button>

                          }

                        </div>
                      </div>

                      {(countryid == '3') ?
                        <div className={styles.continueshopbtn}>
                          <Link href="/australia"><a>
                            <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                          </a></Link>
                        </div>
                        :
                        (countryid == '4') ?
                          <div className={styles.continueshopbtn}>
                            <Link href="/usa"><a>
                              <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                            </a></Link>
                          </div>
                          :
                          (countryid == '5') ?
                            <div className={styles.continueshopbtn}>
                              <Link href="/canada"><a>
                                <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                              </a></Link>
                            </div>
                            :
                            (countryid == '30') ?
                              <div className={styles.continueshopbtn}>
                                <Link href="/uk"><a>
                                  <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                                </a></Link>
                              </div>
                              :
                              (countryid == '31') ?
                                <div className={styles.continueshopbtn}>
                                  <Link href="/uae"><a>
                                    <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                                  </a></Link>
                                </div>
                                :
                                (countryid == '32') ?
                                  <div className={styles.continueshopbtn}>
                                    <Link href="/germany"><a>
                                      <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                                    </a></Link>
                                  </div>
                                  : (countryid == '33') ?
                                    <div className={styles.continueshopbtn}>
                                      <Link href="/singapore"><a>
                                        <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                                      </a></Link>
                                    </div>
                                    :
                                    <div className={styles.continueshopbtn}>
                                      <Link href="/"><a>
                                        <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`} type="button">Continue Shopping<ArrowForwardIos className={styles.checkoutarrowico} /></Button>
                                      </a></Link>
                                    </div>
                      }
                      {/* <div className={styles.continueshopbtn}>
                                                
                                                <Button className={`${styles.cont_shop} ${styles.cart_foot_btn}`}><span>Continue Shopping</span></Button>
                                            </div> */}

                    </div>

                  </Grid>
                </Grid>



              </div>
            </div>
          </div>

        </>
      }

      <Footer />
    </>
  )

}

export async function getServerSideProps(context) {
  if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
    var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
    var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
    var GeoData = JSON.parse(context.req.cookies.GeoData)
  } else {
    const forwarded = context.req.headers["x-forwarded-for"]
    const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
    const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);

    var geoapiresponse = await res.json();

    var currentCurrency = geoapiresponse.current_currency
    var AllCountryData = geoapiresponse.all_currency
    var GeoData = geoapiresponse.GeoData
  }
  return {
    props: {
      currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData
    }
  }
}