import React, { useState, useEffect, AwesomeSlider } from 'react';
import Grid from '@material-ui/core/Grid';
import Navbar from '../components/Navbar/Navbar';
import Footer from '../components/Footer/Footer';
import config from "../config/config";
import Head from 'next/head';
import Breadcrumb from '../components/Component/Breadcrumbs'
export default function Disclaimer({ currentCurrency, AllCurrencyData, GeoData, selectedCountryFlag }) {



    return (
        <>
            <Head>
                <title>Disclaimer - 1800rakhis</title>
                <link rel="canonical" href="https://1800rakhis.com/disclaimer" />

            </Head>
            <Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} selectedCountryFlag={selectedCountryFlag} />
            <Breadcrumb proclass="" rootbreadcrumbtext='Disclaimer' rootbreadcrumblink='' countryId='' breadcrumbtext='' selectedCountryFlag={selectedCountryFlag}/>
            <Grid item md={12} sm={12} xs={13}>

                <Grid container className='policy-container'>
                    <div>
                        <h2>Disclaimer</h2>

                    <p>Dear Customer, Your order is valuable to us. We would like you to understand and appreciate how much we care for your orders. Please go through the disclaimers and stay informed.</p>
					
					<p>The sender is bound to below terms and conditions once he/she places the order. The sender should read the below terms and place the order with 1800rakhis only if they are acceptable by him/her.</p>


                    <h3>General Disclaimer:</h3>
                    <p>{'If 1800rakhis is unable to deliver your order, then complete refund will be made. We shall not be liable for any other charges, loss of profits, emotional stress or any other liability etc. caused due to non-delivery, delayed delivery or issues with the delivery. We make no representation that the products/materials as mentioned on the Website is appropriate or available for use in other locations, and access to them from territories where any of the contents of this Website are illegal, is prohibited. The intellectual property on the Website, except all User Submissions (as defined hereinafter), including but not limited to the text, software, scripts, graphics, photos, logos, images, concepts, sounds, music, videos, interactive features and anything else capable of being copyrightable under the Applicable Law ("Content") and the trademarks, service marks and logos contained therein ("Trademarks"), are owned by/licensed to 1800rakhis.com, subject to copyright and other intellectual property rights under the Applicable Laws and international conventions. If you download or print a copy of the Content for personal use, you must retain all copyright and other proprietary notices contained therein.'}</p>
						
					<p>1800rakhis retains the right to refuse any order unconditionally.</p>	
					<p>All claims are subject to the jurisdiction of Court at Gautam Budha Nagar, India, only.</p>
					

                    <h3>Substitution Policy</h3>
                    <p>Since flower arrangements are hand-made, there may be a slight variation from the picture shown. Occasionally, substitution of flowers is necessary due to temporary and/or regional unavailability issues.</p>
					
                    <p>Every cake we offer is handcrafted and since each chef has his/her own way of baking and designing a cake, there might be slight variation in the product in terms of design and shape. Occasionally, substitution of flavours/designs is necessary due to temporary and/or regional unavailability issues.</p>
					
					<p>In the case of sweets, we may sometime deliver a different brand sweets if the current item is out of stock. We will make sure that we deliver the product as close as possible to the description/photograph shown.</p>


                    <h3>Shipping and Delivery Disclaimer:</h3>

                     <p><span>Flowers may be delivered in fully bloomed, semi-bloomed or bud stage.</span></p>
					 <ul>
					 <li>For same-day standard time delivery, orders must be received by 1800rakhis before 2:00 pm, Monday - Sunday, IST.</li>
					 <li>For same-day fixed time delivery, orders must be received by 1800rakhis before 2:00 pm, Monday - Sunday, IST.</li>
					 <li>For same-day midnight delivery, orders must be received by 1800rakhis before 2:00 pm, Monday - Sunday, IST.</li>
					 </ul>
					 
					 <p><span>Delivery may take longer due to:</span></p>
					 <ul>
					 <li>Bad weather</li>
					 <li>Political disruptions</li>
					 <li>Other unforeseen circumstances</li>
					 </ul>
					 
					 <p>In such cases, we will proactively reach out to you. Please check your e-mail and SMS regularly for updates. Before major occasions, we suggest that you place your order at least five days in advance. Products that are hand delivered cannot be delivered along with courier products.</p>
					 
					 <p>For perishable items like cakes and flowers, we attempt delivery of your order only once. In the event the delivery is not executed during the attempt, you shall still be charged for the order and no re-delivery will be possible. We will consider the order executed in the below cases:</p>
					 
					<ul>
					<li>Wrong shipping/delivery address.</li>
					<li>Recipient not available.</li>
					<li>Premises locked.</li>
					<li>Recipient refusing to accept the delivery.</li>
					</ul>
					 
					 <p>In case if the recipient is not available, he/she can inform the delivery person to deliver the order to the gate/reception/neighbour. Proof of delivery will be provided in case of any dispute in delivery</p>
					 
					 <p>Deliveries are made on Sundays and on Public Holidays for products that are delivered by hand.</p>
					 <p>If there is no one available at the shipping addresses to accept the delivery of your order at the time of delivery, the order will notbe considered late. Hence in such cases, no refunds, cancellations, liability can be made. We will surely try our best as mentioned below-</p>
					 
					 <ul>
					 <li>Call the recipient to schedule an appropriate delivery time.</li>
					 <li>{"Leave a note on the recipient's door asking them to contact the florist to schedule a delivery time."}</li>
					 <li>Leave the bouquet/arrangement in a covered, secure area of the home (porch, garage, or other entrance)</li>
					 <li>Leave the bouquet/arrangement with a neighbour and place a message on the recipients door with this information.</li>
					 
					 </ul>
					 
                     <h3>Raksha Bandhan Disclaimer</h3>
					<p>Our delivery partners may call if they face any issue locating the right address.</p>
					<p>As there is a lot of rush during festive times there may be a little delay in updating you about the delivery status. But we assure you that our team works very hard and we will make sure to send you the SMS as soon as we can.</p>
					<p>It may be possible for our customer care team to respond a little late if you drop an email during the time of Raksha Bandhan. But they will revert back as soon as they can because we are dedicated to giving you the best experience. We request you to bear with us.</p>
					<p>Kindly carefully read our substitution policy in the product description.</p>
					
					
					<h4>Raksha Bandhan Standard Delivery Service and Conditions</h4>
					
					<p>We try hard to fulfil all your orders in time but due to the huge rush at the time of Raksha Bandhan, we cannot guarantee you any fixed delivery date. We fulfil orders on a first come first served basis as per the location and other situations. Delivery of your order will bemade between 6 am to 9 pm. We request you be available during those hours to take the delivery as we make sure that the delivery is made during this time. At the time of Raksha Bandhan the delivery may be done two to three days before the due date as well.</p>
					
					<h4>Raksha Bandhan Courier Services Terms</h4>
					
					<p>The products that are delivered using our courier services may be delivered before or after the tentative delivery date. We cannot guarantee a fixed delivery date.</p>
					
					<h4>Raksha Bandhan International Services</h4>
					
					<p>There may be a little delay or variation in the response time due to differences in time zones. The products that are delivered using our courier services may be delivered before or after the tentative delivery date. We cannot guarantee a fixed delivery date. Also, the cancellation request will only be approved within 2 hours after the order is placed.</p>

					 
					 <h3>{"Valentine's Day Disclaimer"}</h3>
					
					<p>{"The prices shown may change without prior notice due to Valentine's rush. Pre-book your orders to enjoy attractive rates. In order to help service your orders in the best possible way, we request you to provide the correct address and contact details (phone number and email address) of the recipient."}</p>
					
					<p>Due to a huge rush in orders during Valentine, the delivery status confirmation by email and SMS may arrive a little later. Our team works very hard to let you know that your order is delivered as soon as we can.</p>
					
					<p>Our Customer Care team is on toes to ensure that you have a great experience with us. During the Valentine week, they may take a little more time to respond. Kindly be patient. If you have dropped us an email, we ensure it is being reviewed and will be positively answered back.</p>
					 
					<h4>{"Valentine's Special Standard Delivery Service"}</h4>
					<p>While we make best efforts to ensure we deliver your orders as soon as possible, due to huge rush during the Valentine week, we do not offer any fixed time guarantee. Orders are processed on first come first serve basis, delivery areas and other local conditions.</p>
					
					<h4>{"Valentine's Special Midnight Delivery Service"}</h4>
					<p>For Midnight Delivery orders, please note that the order will be delivered between 11 p.m. to 1 a.m.</p>
					
					
					<h4>{"Valentine's Special Courier Services"}</h4>
					<p>For products that are shipped using the services of our courier partners, we are unable to guarantee an exact date/time of delivery during the peak season.</p>
					
					

                    </div>


                </Grid>








            </Grid>

            <Footer />


        </>

    )
}

export async function getServerSideProps(context) {
    var selectedCountryFlag = ''
 if(typeof (context.req.cookies.FlagData) !== 'undefined'){
	 var selectedCountryFlagID =  JSON.parse(context.req.cookies.FlagData)
	 var selectedCountryFlag =  selectedCountryFlagID.id
 }else{
	var selectedCountryFlag  = '2'; 
 }
    if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
        var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
        var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
        var GeoData = JSON.parse(context.req.cookies.GeoData)
    } else {
        const forwarded = context.req.headers["x-forwarded-for"]
        const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
        const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);

        var geoapiresponse = await res.json();

        var currentCurrency = geoapiresponse.current_currency
        var AllCountryData = geoapiresponse.all_currency
        var GeoData = geoapiresponse.GeoData
    }
    return {
        props: {
            currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData, selectedCountryFlag: selectedCountryFlag
        }
    }


}