import React, { useState, useEffect } from 'react';
import Link from 'next/link';
import styles from '../pages/index/index.module.css';
import config from "../config/config";
import Head from 'next/head'
import Grid from '@material-ui/core/Grid';
import Navbar from "../components/Navbar/Navbar";
import Carousel from "react-multi-carousel";
import "react-multi-carousel/lib/styles.css";
import { ArrowBackIos, ArrowForwardIos } from '@material-ui/icons';
import Doodle from "../components/Component/Doodle";
import SliderSlide from "../components/Component/Slider";
import CategorySlider from '../components/Component/CategorySlider';
import RakhiCategorySlider from '../components/Component/RakhiCategorySlider';
import GiftbyPersonality from '../components/Component/GiftbyPersonality';
import Categorycard from '../components/Component/Categorycard';
import SpecialOffers from '../components/Component/specialoffer'
import RakhiSpecialOffer from '../components/Component/RakhiSpecialOffer'
import Worldwide from '../components/Component/worldwide'
import Productcard from "../components/Component/Productcard";
import Whyegift from "../components/Component/WhyChooseEgift";
import Midbannersearch from "../components/Component/Midbannersearch";
import parse from 'html-react-parser'
import { useSelector } from 'react-redux';
import Skeleton from '@material-ui/lab/Skeleton';
import Footer from '../components/Footer/Footer';
export default function Home({ homepagedata, currentCurrency, AllCurrencyData, GeoData }) {
  const selectedCurr = useSelector(state => state.cartReducer.CurrencyData);
  const [homePageHtml, sethomePageHtml] = useState([])
  const [currencyRateP, setcurrencyRateP] = useState(currentCurrency.CurrencyRate);
  const [BestSellerHtml, setBestSellerHtml] = useState([])
  const [sliderHtml, setsliderHtml] = useState([])
  const CustomRight = ({ onClick }) => (
    <button className="arrow_rightcmn" onClick={onClick} >
      <ArrowBackIos className="arrowiconcmn" />
    </button>
  );
  const CustomLeft = ({ onClick }) => (
    <button className="arrow_leftcmn" onClick={onClick} >
      <ArrowForwardIos className="arrowiconcmn" />
    </button>
  );
  useEffect(() => {
    getHomePagesearch()
    getHomePagesBestseller()

    // var newDate = new Date();
    // let currentTime = newDate.getTime();
    // var ProductShowTime = config.ProductShowInCartTime;
    // let updatedDateTIme = new Date(currentTime + ProductShowTime * 60 * 60 * 1000);
    // let currentUpTime = updatedDateTIme.getTime();

  }, [])

  async function getHomePagesearch() {
    var url = `${config.apiUrl}homepage/searchhtml/?sliderid=${homepagedata.homepagedata[0].HomePageSlider}`
    const res = await fetch(url)
    const data = await res.json()
    sethomePageHtml(data.results)
    setsliderHtml(data.slider)

  }

  async function getHomePagesBestseller() {
    var url = `${config.apiUrl}homepage/bestseller/?currencyRate=${currencyRateP}`
    const res = await fetch(url)
    const data = await res.json()
    setBestSellerHtml(data.results)
  }

  return (
    <>
      <div className={styles.maincointainer}>
        <Head>
          <title>{homepagedata.homepagedata[0].HomePageMetaTitle}</title>
          <link rel="icon" href="/static/favicon.ico"></link>
          <link rel="canonical" href="https://1800rakhis.com" />
          <meta property="og:url" content={`https://1800rakhis.com`} />
          <meta name="description" content={homepagedata.homepagedata[0].HomePageMetaDesc} />
          <meta name="keywords" content={homepagedata.homepagedata[0].HomePageMetaKeywords} />
          <meta name="twitter:card" content={homepagedata.homepagedata[0].TwitterCard} key="twcard" />
          <meta name="twitter:title" content={homepagedata.homepagedata[0].TwitterTitle} key="twtitle" />
          <meta name="twitter:description" content={homepagedata.homepagedata[0].TwitterDescription} key="twdescription" />
          <meta name="twitter:image" content={`${config.homepageseowitterimageUrl}${homepagedata.homepagedata[0].TwitterImage}`} key="twimage" />
          <meta property="og:site_name" content="1800rakhis" key="ogsite_name" />
          <meta property="og:type" content="article" key="ogtype" />
          <meta property="og:title" content={homepagedata.homepagedata[0].PageOgtitle} key="ogtitle" />
          <meta property="og:description" content={homepagedata.homepagedata[0].PageOgDescription} key="ogdescription" />
          <meta property="og:image" content={`${config.homepageseoOgimageurl}${homepagedata.homepagedata[0].PageOgImage}`} key="ogimage" />
          {/* <meta name="google-site-verification" content="mHJEQS_DGinavc6mz8kI1m0ahi2MO6NPB68LFQI6s2E" /> */}
          {(homepagedata.homepagedata[0].HomePageSeoSchema) ?
            parse(homepagedata.homepagedata[0].HomePageSeoSchema)
            :
            ''
          }
        </Head>
        <Navbar countryId={'2'} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />
        <div className='top-slider'>
          {(sliderHtml.length < 1) ?
            <Skeleton variant="rect" className="banneskel" />
            :
            <>
            </>
          }
          <Carousel
            arrows
            additionalTransfrom={0}
            autoPlaySpeed={3000}
            centerMode={false}
            className={styles.react_carousel_arrow}
            dotListClass=""
            draggable
            focusOnSelect={false}
            infinite
            itemClass=""
            keyBoardControl
            minimumTouchDrag={80}
            renderButtonGroupOutside={false}
            renderDotsOutside={false}
            customRightArrow={<CustomRight />}
            customLeftArrow={<CustomLeft />}
            responsive={{
              desktop: {
                breakpoint: {
                  max: 3000,
                  min: 1024
                },
                items: 1
              },
              mobile: {
                breakpoint: {
                  max: 464,
                  min: 0
                },
                items: 1
              },
              tablet: {
                breakpoint: {
                  max: 1024,
                  min: 464
                },
                items: 1
              }
            }}
            dots={false}
            sliderClass=""
            slidesToSlide={1}
            swipeable
          >
            {sliderHtml &&
              sliderHtml.map((slide, ind) => {
                return (
                  <SliderSlide imageName={slide.SlideImagePath} slideUrl={slide.SlideUrl} key={ind} />
                )
              })
            }


          </Carousel>
        </div>
        <div className={`${styles.subheading} cat-heading`}>
          <div className={styles.catchoiceheading}>
            <h2> Bestselling <span>Gift Categories</span></h2>
          </div>
        </div>
        <Grid container className={styles.doodle_common} >
          {<Doodle categoryLink={`${config.callBackUrl}rakhi`} categoryImage='/Egift/newdoodle/rakhi.png' categoryName='Rakhi' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send Rakhi Gifts online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}flowers`} categoryImage='/Egift/newdoodle/flowers.webp' categoryName='Flowers' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send flowers online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}cakes`} categoryImage='/Egift/newdoodle/cake.webp' categoryName='Cakes' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send cakes online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}anniversary-gifts`} categoryImage='/Egift/newdoodle/anniversary.webp' categoryName='Anniversary' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send anniversary gifts online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}birthday-gifts`} categoryImage='/Egift/newdoodle/birthday.webp' categoryName='Birthday' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send birthday gifts online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}chocolates`} categoryImage='/Egift/newdoodle/chocolate.webp' categoryName='Chocolates' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send chocolates online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}`} categoryImage='/Egift/newdoodle/plants.webp' categoryName='Plants' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send plants online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}personalized-gifts`} categoryImage='/Egift/newdoodle/personalised.webp' categoryName='Personalized' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send personalized gifts online'} />}
          {<Doodle categoryLink={`${config.callBackUrl}gifts-baskets`} categoryImage='/Egift/newdoodle/giftsbasket.webp' categoryName='Gift Baskets' mainClass={`${styles.homepage_doodle} homepage-doodle`} ImgAlt={'Send gift baskets online'} />}
        </Grid>
        <div className={styles.top_mid_banner}>
          <Midbannersearch apiData={homePageHtml} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />
        </div>

        {(BestSellerHtml.length > 0) ?

          <>
            <div className={`${styles.subheading} cat-heading`}>
              <div className={styles.catchoiceheading}>
                <h2>To Choose<span>BestSelling Gifts</span></h2>
              </div>
            </div>
            <Grid container className={`${styles.productcard}  categorypage-product-card`}>
              <Grid container spacing={3}>
                {(BestSellerHtml).map((item, index) => {
                  return (
                    <>
                      {<Productcard productImage='/Egift/bestsellergift/chocolates.webp'
                        productName={`${item.ProductName}`} productLink={'#'}
                        productPrice={`${item.displayProductPrice}`}
                        productSaleprice={`${item.displaySalePrice}`}
                        productSlug={`${item.ProductSlug}`}
                        ProductBestSeller={`${item.ProductBestSeller}`}
                        ProductNewArrival={`${item.ProductNewArrival}`}
                        TwoDayDelivery={`${item.TwoDayDelivery}`}
                        NextDayDelivery={`${item.NextDayDelivery}`}
                        ThreeHourDelivery={`${item.ThreeHourDelivery}`}
                        PremiumDelivery={`${item.PremiumDelivery}`}
                        ProductSameDayDel={`${item.ProductSameDayDel}`}
                        ProductPersonalised={`${item.ProductPersonalised}`}
                        CurrencySymbol={selectedCurr.CurrencySymbol}
                        ImgAlt={item.ImageAltTag}
                      />
                      }
                    </>

                  )
                })

                }
              </Grid>
            </Grid>
          </>
          :
          <>
          </>


        }
        <div className={`${styles.subheading} cat-heading`}>
          <div className={styles.catchoiceheading}>
            <Link href='/cakes'><a><h2>order<span>Cakes</span></h2></a></Link>
          </div>
        </div>

        <CategorySlider currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />

        <div className={styles.giftoffercont}>

          <Grid container className={styles.specialcont}>
            <SpecialOffers specialImage='/Egift/smallbanners/gifts-for-him.webp' specialName="Today's Sweet offer" specialSaleText="50% off" specialgrabmsg="Get it Now" specialbtnText="Shop Now" bannerLink={'/gifts-for-him'} ImgAlt="Send gifts for him" />
            <SpecialOffers specialImage='/Egift/smallbanners/gifts-for-her.webp' specialName="50% Off" specialSaleText="New Arrival" specialbtnText="Shop Now" specialgrabmsg="Get it Now" bannerLink={'/gifts-for-her'} ImgAlt="Send gifts for her" />
          </Grid>

        </div>

        <div className={`${styles.subheading} cat-heading`}>
          <div className={styles.catchoiceheading}>
            <Link href='/flowers'><a> <h2>order<span>Flowers</span></h2></a></Link>
          </div>
        </div>

        <Grid container className={`${styles.Categories_Card} ${styles.Categorycard}`}>

          <Categorycard CatImage='/Egift/flowers/newflowers/birthday flowers.webp' CatName='Birthday Flowers' categoryLink={'/birthday-flowers'} ImgAlt="Send birthday flowers online" />
          <Categorycard CatImage='/Egift/flowers/newflowers/anniv flowers.webp' CatName='Annivesary Flowers' categoryLink={'/anniversary-flowers'} ImgAlt="Send annivesary flowers online" />
          <Categorycard CatImage='/Egift/flowers/newflowers/roses.webp' CatName='Roses' categoryLink={'/roses'} ImgAlt="Send roses for her" />
          <Categorycard CatImage='/Egift/flowers/newflowers/carnations.webp' CatName='Carnations' categoryLink={'/carnations'} ImgAlt="Send carnations flower online " />

          <Categorycard CatImage='/Egift/flowers/newflowers/premium flowers.webp' CatName='Premium Flowers' categoryLink={'/premium-flowers'} ImgAlt="Send premium flowers online" />
          <Categorycard CatImage='/Egift/flowers/newflowers/lilies.webp' CatName='Lilies' categoryLink={'/lilies'} ImgAlt="Send lilies online" />
          <Categorycard CatImage='/Egift/flowers/newflowers/orchids.webp' CatName='Orchids' categoryLink={'/orchids'} ImgAlt="Send orchids online" />
          <Categorycard CatImage='/Egift/flowers/newflowers/mixed flower.webp' CatName='Mixed Flowers' categoryLink={'/mixed-flowers'} ImgAlt="Send mixed flowers online" />


        </Grid>



        <div className={styles.worldwide}>
          <div className={`${styles.worldcat_heading} cat-heading`}>
            <div className={styles.catchoiceheading}>
              <h2>Send Gifts<span>Worldwide</span></h2>
            </div>
          </div>
          <Grid container className={styles.worldwidecont}>

            <Worldwide worldwideimg="/Egift/Worldwide/usa.webp" coutryname="USA" categoryLink={'/usa'} ImgAlt="send gifts to usa" />
            <Worldwide worldwideimg="/Egift/Worldwide/CANADA.webp" coutryname="Canada" categoryLink={'/canada'} ImgAlt="send gifts to canada" />
            <Worldwide worldwideimg="/Egift/Worldwide/GERMANY.webp" coutryname="Germany" categoryLink={'/germany'} ImgAlt="send gifts to germany" />
            <Worldwide worldwideimg="/Egift/Worldwide/australia.webp" coutryname="Australia" categoryLink={'/australia'} ImgAlt="send gifts to australia" />
            <Worldwide worldwideimg="/Egift/Worldwide/UK.webp" coutryname="UK" categoryLink={'/uk'} ImgAlt="send gifts to uk" />
            <Worldwide worldwideimg="/Egift/Worldwide/SINGAPORE.webp" coutryname="Singapore" categoryLink={'/singapore'} ImgAlt="send gifts to singapore" />
            <Worldwide worldwideimg="/Egift/Worldwide/UAE.webp" coutryname="UAE" categoryLink={'/uae'} />
          </Grid>
        </div>

        <div className={`${styles.subheading} cat-heading`}>

          <div className={styles.catchoiceheading}>
            <h2> Why Choose<span>Us</span></h2>
          </div>
        </div>

        <Grid container className={styles.whyegift}>
          {<Whyegift wegiftImage='/Egift/whychoose/1.webp' wegiftName='Safe & Contactless Delivery' />}
          {<Whyegift wegiftImage='/Egift/whychoose/2.webp' wegiftName='Delivery within 2 Hours' />}
          {<Whyegift wegiftImage='/Egift/whychoose/3.webp' wegiftName='Delivery in 1000+ Cities' />}
          {<Whyegift wegiftImage='/Egift/whychoose/4.webp' wegiftName='Beautifully Wrapped Gifts' New='New' />}
        </Grid>

        <Footer footerdata={homepagedata.homepagedata[0].HomePageFooterContent} />

      </div>

    </>
  )
}




export async function getServerSideProps(context) {

  if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {

    var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
    var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
    var GeoData = JSON.parse(context.req.cookies.GeoData)
  } else {
    const forwarded = context.req.headers["x-forwarded-for"]
    const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
    const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);
    var geoapiresponse = await res.json();

    var currentCurrency = geoapiresponse.current_currency
    var AllCountryData = geoapiresponse.all_currency
    var GeoData = geoapiresponse.GeoData
  }

  const response = await fetch(`${config.apiUrl}homepage`)
  const data = await response.json();

  return {
    props: {
      homepagedata: data, currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData

    }
  }
}

