import Link from "next/link";
import Footer from '../components/Footer/Footer';
import Navbar from '../components/Navbar/Navbar';
import Button from '@mui/material/Button'
import React from 'react'
import config from "../config/config"
import Head from "next/head";
export default function Paymentfailed({ currentCurrency, AllCurrencyData, GeoData }) {
    return (
        <>
            <Head>
				<title>Payment Failed - 1800rakhis</title>
			</Head>
            <Navbar countryId={'2'} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} />

            <div className="paymentfailed">
                <div className="main_container">
                    <div className="cross-icon cross-delete animateDeleteIcon">
                        <span className="cross-x-mark animateXMark">
                            <span className="cross-delete-line cross-delete-left"></span>
                            <span className="cross-delete-line cross-delete-right"></span>
                        </span>
                    </div>
                </div>
                <h2>Transaction Failed! Something Went Wrong.</h2>
                <div className="paymentfailbtn">
                    <Link href='/'><a><Button className="payf_btn">Continue</Button></a></Link>
                </div>
            </div>

            <Footer />
        </>
    )

}


export async function getServerSideProps(context) {
    if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
        var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
        var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
        var GeoData = JSON.parse(context.req.cookies.GeoData)
    } else {
        const forwarded = context.req.headers["x-forwarded-for"]
        const ip = forwarded ? forwarded.split(/, /)[0] :  context.req.connection.remoteAddress
        const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);
        var geoapiresponse = await res.json();

        var currentCurrency = geoapiresponse.current_currency
        var AllCountryData = geoapiresponse.all_currency
        var GeoData = geoapiresponse.GeoData
    }

    return {
        props: {
            currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData
        }
    }
}



