import { useRouter } from 'next/router'
import Navbar from '../../components/Navbar/Navbar';
import Footer from '../../components/Footer/Footer';
import Head from 'next/head';
import SearchLayout from "../../layouts/SearchLayout"
import config from "../../config/config"
  
export default function Slugdata({apiData,currentCurrency,AllCurrencyData,GeoData,searchtext,cid}) {
  // Initializing useRouter()
  const router = useRouter()
  var countryId = router.query.cid
  var text = router.query.text
  return (
		<>
			 <Head>
				 <title>{'Search results'}</title>
				 <link rel="canonical" href="https://1800rakhis.com/search"/>
			</Head>
			<div className='maincointainer'>
				<Navbar countryId={cid} currentCurrency={currentCurrency} AllCurrencyData = {AllCurrencyData} GeoData = {GeoData}  />
				<SearchLayout apiData = {apiData} currentCurrency={currentCurrency} AllCurrencyData = {AllCurrencyData} GeoData = {GeoData} />
				<Footer footerdata = {apiData.PageFooterContent} />        
			</div>
		</>
  )
}
  

export async function getServerSideProps( context ) {
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined'){
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	}else{
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] : req.connection.remoteAddress
		const Curres = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);
		var response = await Curres.json();
		var currentCurrency = response.current_currency
		var AllCountryData = response.all_currency
		var GeoData = response.GeoData
	}	
	 const { cid } = context.query;
	 const { stext } = context.query;
	
	return { props: { apiData:{CategoryTopSectionlayout:[]},currentCurrency:currentCurrency,AllCurrencyData:AllCountryData,GeoData:GeoData,searchtext:stext,cid:cid }}
	
}

// export default Gfg;