import Link from "next/link";
import Grid from '@material-ui/core/Grid';
import Footer from '../components/Footer/Footer';
import Navbar from '../components/Navbar/Navbar';
import Button from '@mui/material/Button'
import React, { useEffect, useState,} from 'react'
import { useRouter } from 'next/router';
import config from "../config/config"
import Head from "next/head";
import { emptyCart } from '../redux/actions/cart';
import { useSelector, useDispatch } from 'react-redux';
export default function Thankyou({currentCurrency,AllCurrencyData,GeoData }) {
	const router = useRouter()
	const dispatch = useDispatch();
	const [Thanku, setsearchText] = useState(router.query.id);
	const [OrderNo, setOrderNo] = useState('');
	const [loading, setloading] = useState(true);
	useEffect(() => {
		getOrderno()
	}, [router.query.id])
	
	async function getOrderno(){
		if(router.query.id){
			await dispatch(emptyCart());
			var url = `${config.apiUrl}orders/thankyou/?orderid=${router.query.id}`
			const res = await fetch(url)
			const data = await res.json()
			setloading(false)
			setOrderNo(data.data[0].OrderNo)
		}else{
			
		}
		
	}
	
    return (
        <>
			<Head>
				<title> Thank You - 1800rakhis</title>
				<link rel="canonical" href="https://1800rakhis.com/thankyou"/>
			</Head>
            <Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData = {AllCurrencyData} GeoData = {GeoData}  />


            <div className="thankyoucont">
                <div className="main-container">
                    <div className="check-container">
                        <div className="check-background">
                            <svg viewBox="0 0 65 51" fill="none" xmlns="http://www.w3.org/2000/svg">
                                <path d="M7 25L27.3077 44L58.5 7" stroke="white" strokeWidth="13" strokeLinecap="round" strokeLinejoin="round" />
                            </svg>
                        </div>
                        <div className="check-shadow"></div>
                    </div>
                </div>
				{(OrderNo) ?
					<>
					 <h2>Thank you for your purchase</h2>
					<div className="innertext">
						<p>Your #{OrderNo} Order has been placed successfully</p>
					</div>
					<div className="ordersuccesbtn">
						<Link href='/'><a><Button className="check_btn">Continue Shopping</Button></a></Link>
					</div>
					</>
					:
					<>
					</>
				}
               
            </div>

            <Footer />
        </>
    )

}


export async function getServerSideProps( context ) {
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined'){
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	}else{
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] :  context.req.connection.remoteAddress
		const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);
		var geoapiresponse = await res.json();

		var currentCurrency = geoapiresponse.current_currency
		var AllCountryData = geoapiresponse.all_currency
		var GeoData = geoapiresponse.GeoData
	}	
	
  return {
    props: {
      currentCurrency:currentCurrency,AllCurrencyData:AllCountryData,GeoData:GeoData 
    }
  }
}



