import React, { useState, useEffect, AwesomeSlider } from 'react';
import Grid from '@material-ui/core/Grid';
import Navbar from '../components/Navbar/Navbar';
import Footer from '../components/Footer/Footer';
import config from '../config/config';
import Image from 'next/image';
import Head from "next/head";
export default function TrackOrder({ currentCurrency, AllCurrencyData, GeoData, selectedCountryFlag }) {
	const [OrderNo, setOrderNo] = useState('');
	const [Email, setEmail] = useState('');

	const [CustomerOrderNo, setCustomerOrderNo] = useState('');
	const [CustomerName, setCustomerName] = useState('');
	const [CustomerShippingName, setCustomerShippingName] = useState('');
	const [ShipAddress, setShipAddress] = useState('');
	const [ShipAddress2, setShipAddress2] = useState('');
	const [ShipAddress3, setShipAddress3] = useState('');
	const [ShipAddress4, setShipAddress4] = useState('');
	const [ShipAddress5, setShipAddress5] = useState('');
	const [BillAddress, setBillAddress] = useState('');
	const [BillCountry, setBillCountry] = useState('India');
	const [OrderStatus, setOrderStatus] = useState('');
	const [NotFound, setNotFound] = useState('');
	const [OrderCurrentCurrSymbol, setOrderCurrentCurrSymbol] = useState('');
	const [OrderSubtotal, setOrderSubtotal] = useState('');

	const [Trackload, setTrackload] = useState(false)

	const [OrderItems, setOrderItems] = useState('');

	async function setOrderNoFunction(value) {
		setOrderNo(value)
	}
	async function setEmailFunction(value) {
		setEmail(value)
	}

	function GetOrderDetail() {
		setOrderItems([])
		if (!OrderNo) {
			return false;
		}
		if (!Email) {
			return false;
		}

		var newstr = OrderNo.replace(/[^a-zA-Z0-9]/g, '');
			newstr = newstr.trim();

		var url = `${config.apiUrl}orders/trackorder`;
		setTrackload(true)
		var formData = { 'orderno': newstr, 'email': Email }

		fetch(url, {
			method: "POST",
			headers: {
			},
			body: JSON.stringify(formData)
		}).then(response => {
			return response.json();
		}).then(async response => {
			if (response.CODE === 200) {
				setTrackload(false)
				if (response.orderdata.length > 0) {

					setCustomerOrderNo(response.orderdata[0].OrderNo);

					setOrderCurrentCurrSymbol(response.orderdata[0].OrderCurrentCurrSymbol);
					setOrderSubtotal(response.orderdata[0].OrderSubtotal)

					setCustomerName(response.orderdata[0].CustomerOrderBillingFirstName + ' ' + response.orderdata[0].CustomerOrderBillingLastName)
					setCustomerShippingName(response.orderdata[0].CustomerOrderShippingFirstName + ' ' + response.orderdata[0].CustomerOrderShippingLastName)

					setShipAddress(response.orderdata[0].CustomerOrderShippingAddress)

					setShipAddress2(response.orderdata[0].CustomerOrderShippingCity + ', ' + response.orderdata[0].CustomerOrderShippingState)

					setShipAddress3(response.orderdata[0].CountryName)
					setShipAddress4(' T:' + response.orderdata[0].CustomerOrderShippingPhone)
					setShipAddress5(response.orderdata[0].CustomerOrderShippingPincode)

					setBillAddress(response.orderdata[0].CustomerOrderShippingAddress + ' ' + response.orderdata[0].CustomerOrderShippingCity)

					setOrderStatus(response.orderdata[0].OrderStatusName);
					setTrackload(false)
				} else {
					setNotFound('There is no order to show');
				}



				setOrderItems(response.orderitems)
			} else {

			}
		})
	}

	return (
		<>

			<Head>
				<title> Track Order - 1800rakhis</title>
				<link rel="canonical" href="https://1800rakhis.com/track-order" />
			</Head>

			<Navbar countryId={''} currentCurrency={currentCurrency} AllCurrencyData={AllCurrencyData} GeoData={GeoData} selectedCountryFlag={selectedCountryFlag}/>

			<Grid item md={12} sm={12} xs={13}>
				<Grid container className='track_order'>
					<div className='track_inner'>
						<h3>track order</h3>
						<form id="trackorderform">
							<ul>
								<li><input placeholder="Order No." id="orderNo" onChange={(e) => setOrderNoFunction(e.target.value)} /></li>
								<li><input type="email" placeholder="Email Id" id="emailid" onChange={(e) => setEmailFunction(e.target.value)} /></li>
								<li>

									<button type="button" id="myForm-order" className='procartbtn' onClick={(e) => GetOrderDetail(e)} >
										Track Order
									</button>

								</li>
							</ul>
						</form>
					</div>
				</Grid>

				{OrderItems.length > 0 ?

					<div className='trackinnerwrap'>


						<div className='trackrecwrap'>
							<div className='trackrec trackno'>
								<span> Order <> </><p> {`#${CustomerOrderNo}`}</p></span>
							</div>
						</div>

						<Grid container className="trackordertable">
							<Grid md={4} sm={6} xs={12} className='tracktbcont'>
								<div className='trackpersondetail track_cus_name'>
									<h2>Customer Name: </h2>
									<span>{CustomerName}</span>
								</div>
							</Grid>
							<Grid md={8} sm={6} xs={12} className='tracktbcont'>
								<div className='trackpersondetail'>
									<div className='trackshipadr'>
										<h2>Shipping Address: </h2>
									</div>
									<div className='shipsdddetail'>
										<span>{CustomerShippingName}</span><br />
										<span>{ShipAddress}, {ShipAddress2}, {ShipAddress3}, {ShipAddress5}</span><br />
										<span>{ShipAddress4}</span><br />
										
									</div>
								</div>
							</Grid>

						</Grid>

						{OrderItems &&
							<>
								{OrderItems.map((values, index) => {

									var imgsrcurl = ''
									if (values.OrderItemIsAddon == '1') {
										imgsrcurl = config.categoryPageAddonproductImageurl + '' + values.image
									} else {
										imgsrcurl = config.categoryPageproductImageurl + '' + values.image
									}



									return (
										<>
											<div className='trackorderitem'>
												<div className='tracitemwrap'>
													<div className='trackitemimg'>
														<Image src={imgsrcurl} height={100} width={100}  alt = "" title = ""/>

													</div>
													<div className='trackitemdetail'>
														<div className='trackinnerdetail'>
															<div className='itemntrack'>
																
																<span>{values.ProductName}</span>

																<div className='orderitem_date'>
																		<div className='itemn_msg'>
																			{(values.CakeMessage) && (values.OrderItemIsAddon != '1') ?
																				<>
																					<h2>Cake message :</h2>
																					<span>{values.CakeMessage}</span>
																				</>
																				:
																				<>
																				</>
																			}
																		</div>
																		<div className='itemndel_date'>
																			{(values.OrderItemIsAddon != '1')  ?
																				<>
																					<h2>Delivery Date :</h2>
																					<span>{values.ProductDeldate}</span>
																				</>
																				:
																				<>
																				<p>Addon</p>
																				</>
																			}
																			
																		
																		</div>
																</div>

															</div>
															<div className='itemntrack track_qty'>
																<h2>Qty:</h2>
																<span>{values.OrderItemQty}</span>
															</div>
															<div className='itemntrack track_price'>
																<h2>Price:</h2>
																<span>{OrderCurrentCurrSymbol}<p>{values.RowTotal}</p></span>
															</div>
															<div className='itemntrack track_price'>
															     <h2>Status:</h2>
																<span className='item_status' >{values.OrderStatusName}</span>
															</div>
														</div>
													</div>
                                                    

												</div>
											</div>

										</>
									)
								})}

							</>
						}



					</div>

					:

					<>
						<div className="cart-empty-content">
							<div className="imgKT">

							</div>
							<p className="cart-empty">{NotFound}</p>

						</div>

					</>

				}

			</Grid>

			<Footer />

		</>

	)
}



export async function getServerSideProps(context) {
	var selectedCountryFlag = ''
 if(typeof (context.req.cookies.FlagData) !== 'undefined'){
	 var selectedCountryFlagID =  JSON.parse(context.req.cookies.FlagData)
	 var selectedCountryFlag =  selectedCountryFlagID.id
 }else{
	var selectedCountryFlag  = '2'; 
 }
	if (typeof (context.req.cookies.CurrencyData) !== 'undefined') {
		var currentCurrency = JSON.parse(context.req.cookies.CurrencyData)
		var AllCountryData = JSON.parse(context.req.cookies.AllCountryData)
		var GeoData = JSON.parse(context.req.cookies.GeoData)
	} else {
		const forwarded = context.req.headers["x-forwarded-for"]
		const ip = forwarded ? forwarded.split(/, /)[0] : context.req.connection.remoteAddress
		const res = await fetch(`${config.apiUrl}setcurrency/?ip=${ip}`);

		var geoapiresponse = await res.json();

		var currentCurrency = geoapiresponse.current_currency
		var AllCountryData = geoapiresponse.all_currency
		var GeoData = geoapiresponse.GeoData
	}
	return {
		props: {
			currentCurrency: currentCurrency, AllCurrencyData: AllCountryData, GeoData: GeoData, selectedCountryFlag:selectedCountryFlag
		}
	}

}