import React, { useState, useEffect, AwesomeSlider } from 'react';
import jsCookie from "js-cookie";

export function GetStorage(key) {
    try {
        const serialState = localStorage.getItem(key);
        if (serialState === null) {
          return undefined;
        }
        return JSON.parse(serialState);
    } catch (err) {
        return undefined;
    }
}

export function SetStorage(key,data) {
    try {
        const serialState = JSON.stringify(data);
        localStorage.setItem(key, serialState);
    } catch(err) {

    }
}

export function DeleteStorage(key) {
    try {
        localStorage.removeItem(key);
    } catch(err) {
        
    }
}


export function GetCookieStorage(key) {
    try {
        let result = [];  
        const localData = jsCookie.get(key);
        if (localData && localData.length > 0) {
          result = JSON.parse(localData);  
        }
        return result;
    } catch (err) {
        return undefined;
    }
}